#ifdef AIX
#define BSD_INCLUDES
#endif

#include <sys/types.h>

#if defined(M_XENIX) && !defined(M_UNIX)
# include <sys/types.tcp.h>
# include <sys/errno.tcp.h>
#endif

#include <sys/time.h>

#ifndef AIX
#include <sys/timeb.h>
#endif

#include <sys/ioctl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define	TELOPTS

#include <arpa/telnet.h>
#include <netdb.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <memory.h>
#include "config.h"
#include "lint.h"
#include "lnode.h"
#include "object.h"
#include "lint2.h"
#include "lang.h"
#include "sent.h"
#include "input_to.h"
#include "comm.h"
#include "error.h"
#include "s_hash.h"
#include "realms.h"

int socket PROT((int, int, int));

#if !defined(hp300) && !defined(NeXT) && !defined(linux)
extern int setsockopt PROT((int, int, int, char *, int));
extern int bind PROT((int, struct sockaddr *, int));
#endif

extern int gethostname(),close(),_check_object(),
	   check_object(), write(),query_idle(),read();

extern char *query_ip_number PROT((OBJECT *));

#ifndef hp300
extern int ioctl();
extern long time();
#endif


extern char *ctime();

extern void abort();

#if !defined(linux)
extern void ftime();
#endif

 
int listen PROT((int, int));
int accept PROT((int, struct sockaddr *, int *));
int select PROT((int, fd_set *, fd_set *, fd_set *, struct timeval *));
int getpeername PROT((int, struct sockaddr *, int *));
struct value *new_player_link();
unsigned char save_flag=0;
extern char *string_copy PROT((char *));

#if !defined(hp300) && !defined(linux)
void bzero PROT((char *, int));
void shutdown();
#endif

void set_prompt PROT((char *,struct object *));
char *query_prompt();
void telnet_neg PROT((char *, char *));

extern struct object_status *ob_status[];

extern char *xalloc();

extern long hb_time,current_time;
char *first_cmd_in_buf PROT((struct interactive *));
void next_cmd_in_buf PROT((struct interactive *));
char *skip_eols PROT((struct interactive *, char *));
int check_snoop PROT((OBJECT *));

void remove_interactive();

extern struct value *clone_object();

extern void logon(), debug_message(), fatal(), free_sentence();

struct interactive *next_player=0,*all_players=0;

extern int errno;

void new_player();


fd_set readfds;

int nfds = 0;
int num_player;

/*
 * Interprocess communication interface to the backend.
 */

extern int *port_arrays;

void prepare_ipc()
{
   unsigned short port_num=cf.base_port;
   int i;

   extern void setup_port();

   for(i=0;i<cf.port_numbers;i++,port_num+=2)
        setup_port(&port_arrays[i],port_num);
}

#ifdef M_XENIX

unsigned short prep_port_addr(i)
unsigned short i;
{
  unsigned short i2=0;

  if(i & 0x1) i2|=0x100;
  if(i & 0x2) i2|=0x200;
  if(i & 0x4) i2|=0x400;
  if(i & 0x8) i2|=0x800;
  if(i & 0x10) i2|=0x1000;
  if(i & 0x20) i2|=0x2000;
  if(i & 0x40) i2|=0x4000;
  if(i & 0x80) i2|=0x8000;
  if(i & 0x100) i2|=0x1;
  if(i & 0x200) i2|=0x2;
  if(i & 0x400) i2|=0x4;
  if(i & 0x800) i2|=0x8;
  if(i & 0x1000) i2|=0x10;
  if(i & 0x2000) i2|=0x20;
  if(i & 0x4000) i2|=0x40;
  if(i & 0x8000) i2|=0x80;
  
  return i2;
}
#endif

void setup_port(port,num)
int *port;
unsigned short num;
{
    struct sockaddr_in sin;
    struct hostent *hp;
    int tmp;
    char host_name[100];

    if (gethostname(host_name, sizeof host_name) == -1) 
		fatal("comm1: Error in gethostname()\n");
    hp = gethostbyname(host_name);
    if (hp == 0) {
	(void)fprintf(stderr, "gethostbyname: unknown host.\n");
	exit(1);
    }
    memset((char *)&sin, '\0', sizeof sin);
    memcpy((char *)&sin.sin_addr, hp->h_addr, hp->h_length);
#ifdef M_XENIX
    sin.sin_port=prep_port_addr(num);
#else
    sin.sin_port=htons(num);
#endif
    sin.sin_family =(short)hp->h_addrtype;
    sin.sin_addr.s_addr = INADDR_ANY;
    *port = socket(hp->h_addrtype, SOCK_STREAM, 0);
    if (*port == -1) {
	perror("socket");
	(void)abort();
    }
    tmp = 1;
    if (setsockopt (*port, SOL_SOCKET, SO_REUSEADDR ,
		    (char *) &tmp, sizeof (tmp)) < 0) {
	perror ("setsockopt");
	exit (1);
    }
    if (bind(*port, (struct sockaddr *)&sin, sizeof sin) == -1) {
	if (errno == EADDRINUSE) {
	    debug_message(sys_realm,"Socket already bound!\n");
	    exit(errno);
	} else {
	    perror("bind");
	    (void)abort();
	}
    }
    if (listen(*port, 5) == -1) {
	perror("listen");
	(void)abort();
    }
    tmp = 1;
#if defined(M_XENIX) || defined(sun) || defined(AIX)
    if (ioctl(*port, FIONBIO, &tmp) == -1) {
	perror("ioctl socket FIONBIO");
	(void)abort();
    }
#else  
    if (fcntl(*port, F_SETFL, FNDELAY) == -1) {
	perror("ioctl socket FNDELAY");
	(void)abort();
    }
#endif 

    (void)signal(SIGPIPE, SIG_IGN);
}

/*
 * This one is called when shutting down the MUD.
 */

void ipc_remove()
{
    int i;

    debug_message(sys_realm,"Shutting down all ports.\n");

    for(i=0;i<cf.port_numbers;i++)
        (void)close(port_arrays[i]);
}

/*
 * Do not call remove_interactive() when write fails, as this may cause
 * command_giver to point to a deallocated object, which some callers
 * of add_message() can't handle.
 */

/*VARARGS1*/
void add_message(fmt, a1, a2, a3, a4, a5, a6, a7, a8, a9)
    char *fmt;
    int a1, a2, a3, a4, a5, a6, a7, a8, a9;
{
    extern void write_file PROT((char *,char *,int));
    char buff[32000];
    char buff2[32200];
    struct interactive *ip;
    int n, offset, chunk, length;
    int from, to;

    if (!_check_object(command_giver)) return;

    ip = command_giver->interactive;

    if (!ip || !query_ip_number(ip->ob)) 
      { 
         if(ip && !ip->closing) remove_interactive(ip->ob);
         return;
      }

    (void)sprintf(buff, fmt, a1, a2, a3, a4, a5, a6, a7, a8, a9);
    length = strlen(buff);

    /*
     * Always check that your arrays are big enough ! :-)
     */

    if (length > sizeof buff) fatal("To long message!\n");

    if (ip->snoop_by) {

	struct object *save = command_giver;
	command_giver = ip->snoop_by->ob;
	add_message("%%%s", buff);
	command_giver = save;
    }

    if(command_giver->logged) write_file(command_giver->logged,buff,1);

    for (from = 0, to = 0; to < sizeof buff2 && buff[from] != '\0';) {
	if (buff[from] == '\n') buff2[to++] = '\r';
	buff2[to++] = buff[from++];
    }
    buff2[to++] = '\0';
    length = to-1;

    /*

     * We split up the message into something smaller than the max size.
     */

    for (offset=0; length > 0; offset += chunk, length -= chunk) {

	chunk = length;

	if (chunk > MAX_SOCKET_PACKET_SIZE) chunk = MAX_SOCKET_PACKET_SIZE;

	if ((n = write(ip->socket, buff2 + offset, chunk)) == -1) {
		switch(errno)
		  {
	    		case EMSGSIZE:
				debug_message(sys_realm,"comm1: write EMSGSIZE.\n");
				return;
			case EBADF:
				debug_message(sys_realm,"comm1: closed socket, message discarded.\n");
			        remove_interactive(ip->ob);
			        return;
			default:
				debug_message(sys_realm,"comm1: message discarded.\n");
				return;
		  }
	}
	if (n != chunk)
        debug_message(sys_realm,"comm1: write socket. Size %d(%d) is to big!\n",chunk, n);
	continue;
    }
}

/*
 * Copy a string, this is where we parse out telnet commands, unwanted
 * hi-bit ascii, returns, and take action on backspace and del.
 */

static void copy_chars(from, to, n)
    register char *from, *to;
    int n;
{
    int i,i2;
    char in_buff[TBUFF];

    for (i=0,i2=0; i<n; i++) 
       {
	 if(from[i]=='\b' || from[i]==127 || from[i]=='\r') continue;

	 if(from[i] & 128)
	   {
	     if((unsigned char)from[i]==IAC)
	          while(from[i] & 128) i++;    /* strip telnet commands */

             continue;
	   }

	in_buff[i2++] = from[i];
      }

    if(!i2) return;

    in_buff[i2]=0;

    (void)strcat(to,in_buff);
}

void purge_dead_sockets()
{
   register struct interactive *ip,*next;

	/* remove dead interactive sockets */

        for (ip=all_players;ip;ip=next) {
	    next=ip->next;
	    if (!query_ip_number(ip->ob)) {
		remove_interactive(ip->ob);
		continue;
	    }
	  }
}

int who_socket=-1;

void check_for_connects()
{
	int new_socket;
	struct sockaddr_in addr;
	int i,length;

           if(who_socket!=1)
             {
                (void)shutdown(who_socket,2);
                (void)close(who_socket);
	        who_socket=-1;
	     }

	/* Get new players in groups of 5.
	 * if we don't get a player break early.
         * no reason to keep trying when no-ones there.
        */

	length = sizeof addr;
        for(i=0;i<cf.port_numbers;i++)
          {
	     new_socket = accept(port_arrays[i], (struct sockaddr *)&addr, &length);

	     if (new_socket != -1)
	        {
		 extern void do_rwho();

                 if(!i) { who_socket=new_socket;do_rwho(new_socket);}
		   else new_player(cf.base_port+(i*2),new_socket, length);
	        }
	       else if (new_socket == -1)
		     {
			if(errno != EWOULDBLOCK && errno != EINTR) 
		          {
	    		    perror("accept");
	    		    (void)abort();
		          }
	             }

             }
}

void do_rwho(socket)
int socket;
{
	struct interactive *ip;

	(void)write(socket,"\r\n",2);
	(void)write(socket,cf.mud_name,strlen(cf.mud_name));
	(void)write(socket," - Running UriMUD v", 19);
        (void)write(socket,VERSION,strlen(VERSION));

	if(!all_players)
		(void)write(socket,"\r\n\r\nThe system is curently empty.\r\n",35);
        else
	{
	 (void)write(socket,"\r\n\r\nName              Port      Idle  Host\r\n",49);
	 (void)write(socket,"----------------------------------------------------\r\n",55);
	 for(ip=all_players;ip;ip=ip->next)
	  {
		char buff[200];
		double tm;
		OBJECT *ob=ip->link_ob;
		extern char *query_host_name();
		VALUE *v;

		v=apply(0,"query_user_name",ob,0,0);

		if(!v || strchk(v,1) || !_check_object(ob)) continue;

		tm=(float)query_idle(ob)/60.00;

		if(tm<1.0) tm=0.0;
		(void)sprintf(buff,"%-15s   %d  %8.2f  %s\r\n",v->u.string,ip->port_num,tm,query_host_name(ip->link_ob));
	        if(buff[0]>=97) buff[0]-=32;
		(void)write(socket,buff,strlen(buff));
	  }
	}
        (void)write(socket,"\r\n",2);
}

/*
 * Get a message from any player.  For all players without a completed
 * cmd in their input buffer, read their socket.  Then, return the first
 * cmd of the next player in sequence that has a complete cmd in their buffer.
 */

int twait = 0;		 /* wait time for select() */

unsigned char more_count=0;

void get_messages()
{
        extern unsigned char more_cmds;
	extern int call_out_delay();
	extern struct link_list *hb_list;

	struct timeval timeout;
        int max_delay,res;
	extern int reset_delay;
        struct interactive * ip = 0,*next=0;
        char *p;
#ifndef AIX
	extern struct timeb wait_time;
	struct timeb now_time;
#endif
 
    /*
     * Stay in this loop until we have a message from a player.
     * or it's time to do something else.
     */


	nfds = 0;
	FD_ZERO(&readfds);

	for(ip=all_players;ip;ip=ip->next) {
		FD_SET(ip->socket, &readfds);
		if (ip->socket >= nfds) nfds = ip->socket+1;
	}

	timeout.tv_sec = 0; /* avoid busy waiting when no buffered cmds */
        timeout.tv_usec = 0;


	max_delay=call_out_delay();

        if(max_delay<0 || max_delay>2) max_delay=2;

        if(++more_count>=cf.max_ed) {more_cmds=0;more_count=0;}

        if(more_cmds) { timeout.tv_sec=0;timeout.tv_usec=0; }
	  else
           {
             timeout.tv_sec=max_delay>0?max_delay>2?2:max_delay:0;
#ifndef AIX
	ftime(&now_time);
	if(!max_delay && !(now_time.time-wait_time.time)) 
	    timeout.tv_usec =1000*(now_time.millitm-wait_time.millitm);
	       else timeout.tv_usec=0;
#else
	/* we have to delay some, we don't want to suck cpu cycles. */
	timeout.tv_usec=250;
#endif
           }

	res = select(nfds, &readfds, 0, 0, &timeout);

	/* if we recieved nothing, leave.  This way we proccess any pending
	   commands.  And if there are none, twait will be set when we get
	   back.
	 */
	if (res<1) return;

	/* waiting packets */

	for (ip=all_players; ip; ip=ip->next) /* read all pending sockets */
	   if (FD_ISSET(ip->socket, &readfds)) { /* read this player */
		    int l,tt,size=TBUFF;
		    char buff[TBUFF];

		    /* dont overfill their buffer */

		    if(ip->text) size = TBUFF - strlen(ip->text) - 1;
			  else size=TBUFF-1;

			/* check to see if there buffer is full and yet	
			   there is not a single command in it.

			   In this case we have to purge there buffer, and
			   they have to start over.  

			   This is better then them getting locked up until
			   they disconnect and call back.
			*/

		    if(size<1 && !strchr(ip->text,'\n'))
		       {
			 size=TBUFF;
			 memset((char *)ip->text,'\0',TBUFF);
		       }

		    if(size<1) continue;  /* buffer is full */
			

		    if ((l = read(ip->socket, buff, size)) == -1) {
			switch(errno)
			  {
				case EMSGSIZE:
			    		debug_message(sys_realm,"read EMSGSIZE !\n");
			    		continue;
				default:
					remove_interactive(ip->ob);
					continue;
			  }
		    }
		    if (!l) {
			remove_interactive(ip->ob);
			continue;
		    }

		    buff[l] = '\0';
		    copy_chars(buff,ip->text,l);
		}
}

/*
 * find the first character of the next complete cmd in a buffer.
 */

char *first_cmd_in_buf(ip)
	register struct interactive *ip;
{
	register char *p;
	char q[TBUFF];
	int i;

    if(ip->text[0]==0) return 0;
	p=strchr(ip->text,'\n');
	if(!p) return 0;
	i=p-ip->text;
	(void)strncpy(q,ip->text,i);
    q[i]=0;
    return q;
}
void next_cmd_in_buf(ip)
	register struct interactive *ip;
{
	register char *p;

    if(ip->text[0]==0) return;
	p=strchr(ip->text,'\n');
	if(!p) return;
	if(p[1])
		(void)strcpy(ip->text,&p[1]);
	else
	     (void)memset((char *)ip->text,'\0',sizeof ip->text);
}

/*
 * Remove an interactive player immediately.
 */
void remove_interactive(ob)
    register struct object *ob;
{
    register struct interactive *ip=0,*prev=0;
    register struct object *save = command_giver;

	if(!_check_object(ob)) return;
    if(!ob->interactive) fatal("Tried to remove interactive from non-intereractive object!\n");
    for (ip=all_players; ip; prev=ip,ip=ip->next) 
      {
	if (ip != ob->interactive) continue;

	if (ip->closing)
	    fatal("Double call to remove_interactive()\n");

	ip->closing = 1;

	command_giver = ob;

	add_message("Closing down.\n");

	if(ip->link_ob)
	  {
	    ip->link_ob->interactive=0;
	    ip->link_ob=0;
	  }

	if(ip->ob)
	  {
	    ip->ob->interactive=0;
	    ip->ob=0;
	  }

	if (ip->snoop_by)
	  {
	    ip->snoop_by->snoop_on = 0;
	    ip->snoop_by = 0;
	  }

	if (ip->snoop_on) 
	  {
	    ip->snoop_on->snoop_by = 0;
	    ip->snoop_on = 0;
	  }

	if (ip->input_to) 
	  {
	    free_input_to(ip->input_to);
	    ip->input_to = 0;
	  }

	if(ip->default_err_message)
		free_string(ip->default_err_message,"remove_interactive");

	if(ip->host_name)
		free_string(ip->host_name,"remove_interactive");


	(void)shutdown(ip->socket, 2);
	(void)close(ip->socket);

	num_player--;

	if(prev) prev->next=ip->next;

	if(all_players==ip) all_players=ip->next;

	if(next_player==ip) next_player=ip->next;

	ip->next=0;

	free((char *)ip);

	command_giver = save;

	return;
    }

    debug_message(sys_realm,"comm1: Could not find and remove player %s\n", ob->name);
    (void)abort();
}

int allow_host_access(new_socket,len)
    int new_socket,len;
{
    register char  *p1,*p2=0;
    char buf[1043];
    struct sockaddr_in apa;
    register char *ipname;
    register FILE *f = fopen("info/Access", "r");


    if(f)
      {
	  while(fgets(buf, sizeof buf - 2, f)) 
	      {
		if(buf[0] == '#') continue; 

		if(p1 = strchr(buf, ':')) 
		  {  
		     int i=strlen(p1)-1;
		     p1[0]=0;
		     ++p1;
		     p1[i]='\r';
		     p1[i+1]=0;
		     p2= &buf[0];
	  	  }
		 else p2= &buf[0];
			  
                if(getpeername(new_socket, (struct sockaddr *)&apa, &len) == -1)
                  {
			debug_message(sys_realm,"getpeername");
			continue;
      	          }

		ipname = inet_ntoa(apa.sin_addr);
    
 		if(!strncmp(ipname, p2,strlen(p2)))
	  	  {
		      long l=time(0l);

	    	      if(p1) (void)write(new_socket, p1, strlen(p1));

		      (void)shutdown(new_socket,2);
	  	      (void)close(new_socket);

		      (void)fclose(f);
	 	      debug_message(sys_realm,"comm1: Stopping: %s @ %s", p2,ctime(&l));
	              return 0;
	          }
	     }
          (void)fclose(f);
	}
      else if(errno == EMFILE) fatal("Max files open.\n");
    return 1;
}

/*
 * get the I'th player object from the interactive list, i starts at 0
 * and can go to num_player - 1.  For users(), etc.
 */
struct object *find_link(ob)
 struct object *ob;
{
  if(ob->interactive) return ob->interactive->link_ob;
  else return 0;
}

struct object *used_object(ob)
 struct object *ob;
{
  if(ob->interactive) return ob->interactive->ob;
  else return 0;
} 

struct object * get_interactive_object(i,flag)
int i,flag;
{
    register struct interactive *ip;

    for (ip=all_players; ip;ip=ip->next)
      if (!(--i))
	  if(!flag) return(ip->ob);
		else return(ip->link_ob);
    return 0;
}

void new_player(port,new_socket, len)
    unsigned short port;
    int new_socket;
    int len;
{
    register OBJECT *ob;
    register char *p,get_info[4];
    jmp_buf erc;
    struct jmp_globals jmp;
    
    if(!allow_host_access(new_socket,len)) return;

#ifdef MAX_PLAYERS
    if(num_player==MAX_PLAYERS)
      {
    	 p = "UriMUD is full. Come back later.\r\n";
	(void)write(new_socket, p, strlen(p));
        (void)shutdown(new_socket,2);
	(void)close(new_socket);
	return;
      }
#endif
	
	     
	set_jump_state(erc,&jmp);
	if(!setjmp(error_recovery_context)) ob =(clone_object(cf.logon_ob))->u.ob;
	    else {ob=0;clear_jump_state(&jmp);}

	reset_jump_state(erc);

	if (!ob)
	  {
		write(socket,"Error durring logon.  Goodbye!\r\n",32);
		(void)shutdown(new_socket, 2);
		(void)close(socket);
	   	return;
	  }
	ob->interactive =
	    (struct interactive *)xalloc(sizeof (struct interactive));
        ob->interactive->port_num=port;
	ob->interactive->default_err_message = 0;
	ob->interactive->next=all_players;
	all_players=ob->interactive;
	if(next_player==all_players) next_player=ob->interactive;
	command_giver = ob;
	ob->interactive->ob = ob;
	ob->interactive->link_ob=ob;
	ob->interactive->text[0] = 0;
	ob->interactive->input_to = 0;
	ob->interactive->closing = 0;
	ob->interactive->snoop_on = 0;
	ob->interactive->snoop_by = 0;
	ob->interactive->last_cmd[0]=0;
	ob->interactive->do_close = 0;
	ob->interactive->noecho = 0;
	ob->interactive->host_name=0;
	ob->interactive->default_err_message=0;
  	ob->interactive->last_time=current_time;
	ob->flags|=PLAYER;
    set_prompt("> ",ob);
	ob->interactive->socket = new_socket;
	  getpeername(new_socket, (struct sockaddr *)&ob->interactive->addr, &len);
	num_player++;
	logon(ob,"logon",&const0);
}

struct value *new_player_link(new_ob,old_ob,arg)
    register struct object *new_ob,*old_ob;
    register struct value *arg;
{
    struct object *save_comm=command_giver;

        if(new_ob==old_ob || !check_object(new_ob) || !check_object(old_ob) ||
	   !old_ob->interactive)
			 return &const0;

	if(new_ob->interactive && new_ob->interactive!=old_ob->interactive)
		 remove_interactive(new_ob);

        if(new_ob==old_ob->interactive->link_ob)
 	  {
	    old_ob->interactive->ob=new_ob;
	    old_ob->interactive=0;
	  }
	 else
	  {
		new_ob->interactive = old_ob->interactive;
		new_ob->interactive->ob = new_ob;
		if(old_ob!=new_ob->interactive->link_ob)
	   	    old_ob->interactive = 0;
	  }
	command_giver = new_ob;
	new_ob->flags|=PLAYER;
	logon(new_ob,"link",arg);
        if(save_comm!=old_ob) command_giver=save_comm;
     return  &const1;
}

int call_function_interactive(u, str)
    register struct interactive *u;
    register char *str;
{
    register INPUT_TO *i;
    register struct value *val;
    struct object_status *save_ob_status[2];
    int cs;

    if (!u->input_to) return 0;

    /*
     * Special feature: input_to() has been called to setup
     * a call to a function.
     */
    if (!_check_object(u->input_to->ob)) 
	  {
		/* Sorry, the object has selfdestructed ! */
		free_input_to(u->input_to);
		u->input_to = 0;
	 	return 0;
      }
    i=u->input_to;
    val = make_string(str);
    /*
     * We must clear this reference before the call to apply(), because
     * someone might want to set up a new input_to().
     */
    u->input_to = 0;
    /*
     * Now we set ob_status[0].ob to this object, so that input_to will
     * work for static functions.
     */
	for(cs=0;cs<2;cs++)
	  {
		save_ob_status[cs]=ob_status[cs];
		ob_status[cs]=0;
	  }
    ob_status[0]=alloc_ob_status();
    ob_status[0]->ob=i->ob;
    (void)apply(i->fun_p,0, i->ob, val,(i->arg.type?&i->arg:0));
	for(cs=0;cs<2;cs++)
 	  {
	     if(ob_status[cs]) free_ob_status(ob_status[cs]);
		 ob_status[cs]=save_ob_status[cs];
	  }
    free_input_to(i);
    return 1;
}

int set_call(ob, sent, noecho)
    register struct object *ob;
    register struct input_to *sent;
    int noecho;
{
    struct object *save = command_giver;
    if (!ob || !sent) return 0;
    if (!ob->interactive || ob->interactive->input_to) return 0;
    ob->interactive->input_to = sent;
    ob->interactive->noecho = noecho;
    command_giver = ob;
    if (noecho) add_message("%c%c%c", IAC, WILL, TELOPT_ECHO);
    command_giver = save;
    return 1;
}

void remove_all_players()
{
	register struct interactive *ip;
	jmp_buf erc;
	struct jmp_globals jmp;
	extern void destruct_object PROT((OBJECT *,char *));

        if(save_flag) return;

	save_flag=1;

	for (ip=all_players;ip;ip=all_players) 
          {
		if(ip->ob)
		  {
			command_giver =ip->ob;

			if(ip!=all_players || !ip->ob) continue;

			if(ip->link_ob!=ip->ob)
			  {
				set_jump_state(erc,&jmp);

				if(!setjmp(error_recovery_context))
				    (void)apply(0,"quit", ip->ob, &const0,0);
			    	  else clear_jump_state(&jmp);

				reset_jump_state(erc);
			  }

			ob_status[0]=0;
			if(ip==all_players && ip->ob)
				destruct_object(ip->ob,0);
		  }
        }
}

char *query_prompt(ob)
  struct object *ob;
{
   if(!ob->interactive) return "\0";
   return ob->interactive->prompt;
}

void set_prompt(str,ob)
    char str[80];
    struct object *ob;
{
   if(ob->interactive) (void)strcpy(ob->interactive->prompt,str);
}

/*
 * Print the prompt, but only if input_to not is enabled.
 */
void print_prompt()
{
    if (!command_giver) fatal("print_prompt: no command_giver\n");
    if (!command_giver->interactive->input_to)
		add_message("%s",command_giver->interactive->prompt);
}

int check_snoop(ob)
	register OBJECT *ob;
{
   VALUE *ret,v;
   
   v.type=T_OBJECT;
   v.u.ob=ob;
   ret=apply(mcp.fun_p[3],0,mcp.ob,&v,0);
   if(!ret || numchk(ret,T_INT) || !ret->u.n_int) return 0;
   return 1;
}

void set_snoop(me, you)
    register struct object *me, *you;
{
    register struct interactive *on = 0, *by = 0, *ip;
    
    for(ip=all_players; ip && (!on || !by); ip=ip->next) 
	  {
		if (ip->ob == me) by = ip;
	  		else if (ip->ob == you) on = ip;
      }
	if(!by) fatal("set_snoop: Could not find myself.\n");
    if(!check_object(you)) 
	  {
		add_message("Ok.\n");
		if (!by->snoop_on) return;
		by->snoop_on->snoop_by = 0;
    	by->snoop_on = 0;
		return;
      }
    if (!on) 
	  {
		add_message("Unable to locate the that player.\n");
		return;
      }
    if(by->snoop_on) by->snoop_on->snoop_by = 0;
    if (on->snoop_by)
	  {
		add_message("Busy.\n");
		return;
      }
	if(check_snoop(you))
	  {
   		 on->snoop_by = by;
    	 by->snoop_on = on;
     	 add_message("Ok.\n");
	  }
	 else add_message("Failed.\n");
}

char *query_host_name(ob)
    register struct object *ob;
{
	register struct hostent *host;
	register char *h_name;

	if (!ob)
	  {
	     char name[20];

	     gethostname(name, sizeof name);
	     name[sizeof name -1]= '\0';
	     return name;
	  }
	if (!ob->interactive) return 0;

	if(ob->interactive->host_name) 
	   return ob->interactive->host_name;

#if defined(hp300) || defined(linux)
	host=gethostbyaddr((const char *)&ob->interactive->addr.sin_addr,
#else
	host=gethostbyaddr(&ob->interactive->addr.sin_addr,
#endif
                   4 ,AF_INET);

	if(!host || !host->h_name)
		ob->interactive->host_name=make_shared_string(query_ip_number(ob));
#ifndef linux
	  else ob->interactive->host_name=make_shared_string(host->h_name);
#else
	  else ob->interactive->host_name=make_shared_string((char *)host->h_name);
#endif

	return ob->interactive->host_name;
}
    
#ifndef INET_NOT_A_OK

char *query_ip_number(ob)
    struct object *ob;
{
    if (!ob) ob = command_giver;
    if (!ob || !ob->interactive) return 0;
    return inet_ntoa(ob->interactive->addr.sin_addr);
}

#else 
/*
Note: if the address string is "a.b.c.d" the address number is
      a * 256^3 + b * 256^2 + c * 256 + d

*/

char *query_ip_number(ob)
    struct object *ob;
{
    u_long s_ad;
    int a, b, c, d;
    static char addr[20]; /* 16 + 1 should be enough */

    if (!ob) ob = command_giver;
    if (!ob || !ob->interactive) return 0;
    s_ad = ob->interactive->addr.sin_addr.s_addr;
    d = s_ad % 256;
    s_ad /= 256;
    c = s_ad % 256;
    s_ad /= 256;
    b = s_ad % 256;
    a = s_ad / 256;
    (void)sprintf(addr, "%d.%d.%d.%d", d, c, b, a);
    return addr;
}
#endif


struct value *query_snoop(ob)
    register struct object *ob;
{
    struct value *arg1;

    if(!check_snoop(ob_status[0]->ob) ||
       !ob->interactive->snoop_by) return &const0;

    arg1=make_object(ob->interactive->snoop_by->ob);
    return arg1;
}

int query_idle(ob)
    register struct object *ob;
{
    if (!check_object(ob) || !ob->interactive) return -1;
    return current_time - ob->interactive->last_time;
}

void notify_no_command() {
    register char *p;

    if (!check_object(command_giver) || !command_giver->interactive) return;
    p = command_giver->interactive->default_err_message;
    if (p) {
	add_message(p);
	free_string(p,"notify_no_command");
	command_giver->interactive->default_err_message = 0;
    } else {
	add_message("What ?\n");
    }
}

void clear_notify() {
    if (!check_object(command_giver) || !command_giver->interactive) return;
    if (command_giver->interactive->default_err_message) {
	free_string(command_giver->interactive->default_err_message,"clear_notify");
	command_giver->interactive->default_err_message = 0;
    }
}

void set_notify_fail_message(str)
    char *str;
{
    clear_notify();
    if (!check_object(command_giver) || !command_giver->interactive)
	return;
    command_giver->interactive->default_err_message = make_shared_string(str);
}


int check_last_cmd()
{
  if(command_giver->interactive->last_cmd[0]!=0) return 1;
  return 0;
}

void set_last_cmd(cmd)
  char *cmd;
{
 (void)strcpy(command_giver->interactive->last_cmd,cmd);
}

char *get_last_cmd()
{
  return command_giver->interactive->last_cmd;
}

int query_port_number(ob)
	OBJECT *ob;
{
	if(ob->interactive)
        	return (int)ob->interactive->port_num;
	
        return -1;
}
