#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <memory.h>
#include <string.h>
#include "config.h"

struct config cf;	/* global config structure		 */

int open(),read(),close(),printf(),write(),sscanf();
char *gets();
#ifndef hp300
long lseek();
#endif
void exit();

char *install_dir=0;

void main(argc,argv)
	int argc;
	char **argv;
{
   int f,s;
   char *file;
   char buff[256];
   unsigned int ui;

   if(argc<2) file="config.uri";
	else file=argv[1];

   if(argc==3) install_dir=argv[2];

   (void)memset((char *)&cf,'\0',sizeof (struct config));

   f=open(file,O_RDWR | O_CREAT);

   if(f==-1) 
     {
        (void)printf("Could not open configuration file '%s'.\n",file);
	exit();
     }

   fchmod(f,0660);

   if((s=read(f,&cf,sizeof (struct config)))<sizeof (struct config))
     {
	if(s==-1)
	  switch(errno)
            {
		case EBADF:
			(void)printf("File '%s' is not open for update.\n",file);
			exit();
		case EFAULT:
			(void)printf("Bad buffer pointer for read().\n");
			exit();
		case EINTR:
			(void)printf("Signal interupt.\n");
			exit();
	    }

	  (void)strcpy(cf.log,"log/System");
	  (void)strcpy(cf.logon_ob,"closed/logon");
	  cf.max_mem=0;
	  cf.max_ed=20;
	  cf.base_port=2028;
          cf.port_numbers=2;
	  (void)strcpy(cf.host_name,"localhost");
	  (void)strcpy(cf.mud_name,"YOUR MUD NAME GOES HERE");
	  if(!install_dir)
	   {
	      (void)strcpy(cf.mud_lib,"/usr/local/mud/mudlib");
	      (void)strcpy(cf.temp_dir,"/usr/local/mud/tmp");
           }
	  else
           {
	      (void)sprintf(cf.mud_lib,"%s/mudlib",install_dir);
	      (void)sprintf(cf.temp_dir,"%s/tmp",install_dir);
           }
	  (void)strcpy(cf.init_file,"info/init_file");
	  (void)strcpy(cf.cpp,"/lib/cpp");
	  (void)strcpy(cf.cp,"/bin/cp");
	  (void)strcpy(cf.grep,"/bin/grep");
	  cf.max_local=30;
	  cf.max_cost=25000;
	  cf.max_array_size=1000;
	  cf.alloc_call=1;
	  cf.alloc_sent=1;
	  cf.alloc_value=1;
	  cf.vartable=2003;
	  cf.ptable=5003;
	  cf.vtable=27;
	  cf.ltable=53;
	  cf.stable=4013;
	  cf.otable=809;
     }
   else lseek(f,0,0);

   (void)printf("\n\nUriMUD v%s Configuration Editor: %s.\n",VERSION,file);
   (void)printf("--------------------------------\n\n");
   (void)printf("Press <ENTER> to except default value.\n\n");

#if 0
   (void)printf("Debug log [%s]: ",cf.log);
   (void)gets(buff);
   if(buff[0]!='\0') (void)strncpy(cf.log,buff,strlen(buff)+1);
#endif

   (void)printf("\nThis is the name of the object that users will use when\n");
   (void)printf("they first login to the mud.\n");
   (void)printf("Logon Object [%s]: ",cf.logon_ob);
   (void)gets(buff);
   if(buff[0]!='\0') (void)strncpy(cf.logon_ob,buff,strlen(buff)+1);

   (void)printf("\nThe following value will be used to limit the amount of\n");
   (void)printf("memory the mud will be able to use.  If this value is set to\n");
   (void)printf("0, there will be no limit.\n");
   (void)printf("Maximum Memory [%u]: ",cf.max_mem);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui); cf.max_mem=ui;}

   (void)printf("\nThe following value is used to determin how many consecutive\n"); 
   (void)printf("commands a user can have executed while in ed().  The\n");
   (void)printf("perpose for this is primarily to allow fast text uploads\n");
   (void)printf("into the editor.\n");
   (void)printf("Maxmim Ed Commands [%u]: ",cf.max_ed);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.max_ed=(unsigned char)ui;}

   (void)printf("\nThe following value is used for the who login port number\n");
   (void)printf("and is used to determin what the login port numbers will be.\n");
   (void)printf("All login ports will be setup in increments of two from this\n");
   (void)printf("base address.  ei.  A base of 2028 would have who info on\n");
   (void)printf("2028, and the first login port would be on 2030.  The next\n");
   (void)printf("login port would be on 2032,2034.. and so on.\n");
   (void)printf("Base Port Address [%u]: ",cf.base_port);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui); cf.base_port=(unsigned short)ui; }

   (void)printf("\nThe following value is used to determin how many ports your\n");
   (void)printf("will use.  The minimum number of ports is 2.  One for who and\n");
   (void)printf("One for user login.\n");
   (void)printf("Number of Ports to setup (min 2) [%u]: ",cf.port_numbers);
   (void)gets(buff);
   if(buff[0]!='\0') 
     {
       (void)sscanf(buff,"%u",&ui); 

	if(ui<2) ui=2;

       cf.port_numbers=(unsigned char)ui; 
     }

   (void)printf("\nThe following value is the name of the machine you will be\n");
   (void)printf("running the mud on.  This can be found in /etc/hosts.\n");
   (void)printf("Host Name [%s]: ",cf.host_name);
   (void)gets(buff);
   if(buff[0]!='\0') (void)strncpy(cf.host_name,buff,strlen(buff)+1);

   (void)printf("\nThis is the name of the mud, it will be show anytime\n");
   (void)printf("someone log's into the who port.\n");
   (void)printf("Mud Name [%s]: ",cf.mud_name);
   (void)gets(buff);
   if(buff[0]!='\0') (void)strncpy(cf.mud_name,buff,strlen(buff)+1);

   if(!install_dir)
     {
       (void)printf("\nThis is the directory where the mudlib will be found.\n");
       (void)printf("The mudlib MUST be on a single file system.\n");
       (void)printf("Mudlib Dirctory [%s]: ",cf.mud_lib);
       (void)gets(buff);
       if(buff[0]!='\0') (void)strncpy(cf.mud_lib,buff,strlen(buff)+1);

       (void)printf("This is the directory where the mud will do all it's\n");
       (void)printf("temp work.  This directory MUST be on the same file system\n");
       (void)printf("as the mudlib directory.\n");
       (void)printf("Temp Directory [%s]: ",cf.temp_dir);
       (void)gets(buff);
       if(buff[0]!='\0') (void)strncpy(cf.temp_dir,buff,strlen(buff)+1);
     }

#if 0
   (void)printf("Mud init_file [%s]: ",cf.init_file);
   (void)gets(buff);
   if(buff[0]!='\0') (void)strncpy(cf.init_file,buff,strlen(buff)+1);
#endif

   (void)printf("\nThe following value needs to be the complete path and name\n");
   (void)printf("for the cpp pre-compiler.\n");
   (void)printf("CPP [%s]: ",cf.cpp);
   (void)gets(buff);
   if(buff[0]!='\0') (void)strncpy(cf.cpp,buff,strlen(buff)+1);

   (void)printf("\nThe following value needs to be the complete path and name\n");
   (void)printf("for the unix cp command.\n");
   (void)printf("CP [%s]: ",cf.cp);
   (void)gets(buff);
   if(buff[0]!='\0') (void)strncpy(cf.cp,buff,strlen(buff)+1);

   (void)printf("\nThe following value needs to be the complet path and name\n");
   (void)printf("for the unix grep command.\n");
   (void)printf("GREP [%s]: ",cf.grep);
   (void)gets(buff);
   if(buff[0]!='\0') (void)strncpy(cf.grep,buff,strlen(buff)+1);

   (void)printf("\nMaxmim # of local Variables [%u]: ",cf.max_local);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.max_local=(unsigned char)ui;}

   (void)printf("\nMaxmim Eval Cost [%u]: ",cf.max_cost);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.max_cost=ui;}

   (void)printf("\nMaxmim Array Size [%u]: ",cf.max_array_size);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.max_array_size=(unsigned short)ui;}

#if 0
   (void)printf("Block Size for call_outs() [%u]: ",cf.alloc_call);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.alloc_call=(unsigned char)ui;}

   (void)printf("Block Size for verbs [%u]: ",cf.alloc_sent);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.alloc_sent=(unsigned short)ui;}

   (void)printf("Block Size for (value *) [%u]: ",cf.alloc_value);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.alloc_value=(unsigned char)ui;}
#endif

   (void)printf("\nThe following values are used to tune the muds hash tables.\n");
   (void)printf("If you don't know what your doing do NOT change them.\n");
   (void)printf("These values must always be a prime number.\n");
   (void)printf("Variable Compile Hash Table Size [%u]: ",cf.vartable);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.vartable=(unsigned short)ui;}

   (void)printf("\nGlobal Program Hash Tables Size [%u]: ",cf.ptable);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.ptable=(unsigned short)ui;}

   (void)printf("\nVerb Table Size (keep at 27) [%u]: ",cf.vtable);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.vtable=(unsigned short)ui;}

   (void)printf("\nLiving Hash Table Size [%u]: ",cf.ltable);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.ltable=(unsigned short)ui;}

   (void)printf("\nString Hash Table Size [%u]: ",cf.stable);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.stable=(unsigned short)ui;}

   (void)printf("\nObject Hash Table Size [%u]: ",cf.otable);
   (void)gets(buff);
   if(buff[0]!='\0') { (void)sscanf(buff,"%u",&ui);cf.otable=(unsigned short)ui;}

   if(write(f,&cf,sizeof (struct config))==-1)
     {
	(void)printf("\nCould not read configuration file '%s'.\n",file);
	exit();
     }
}
