inherit "obj/soul";

int chat_room;

object c_owner;
object rooms_array;

string invite_list;

string topic;

int pvt;

/* make it so init,exit,and reset can be static */
init()
{
   set_heart_beat(1);
   remove_invite(this_player()->query_name());
   add_action("get_input","",1);
   write("Welcome to UriChat 1.0!\n");
   write("You have entered Rm: "+chat_room+"\t"+topic+"\n");
   show_chat_room();
   write("\n /help for a list of commands.\n\n");
   say(capitalize(this_player()->query_name())+" has entered the chat room.\n");
}

static show_chat_room()
{
   object rm_users;
   int i;

   rm_users=all_inventory(this_object());
   if(sizeof(rm_users)==1)
      {
	     write("There is nobody else here.\n");
		 if(chat_room && !c_owner)
		   {
			 write("You are now the owner of this room.\n");
	                 c_owner=this_player();
		   }
	  }
   else
      {
		write("Other people here with you are:\n");
   		for(i=0;i<sizeof(rm_users);i++)
	  	  if(rm_users[i] && rm_users[i]!=this_player())
		 	write(capitalize(rm_users[i]->query_name())+"\n");
	  }
   write("\n\n");
}


static get_input(str)
{
   if(stringp(str) && str[0]=='/') return slash_cmd(++str);
   say("\n"+this_player()->chat_name()+": "+str+"\n");
   if(this_player()->query_echo())
     write(this_player()->chat_name()+": "+str+"\n");
   return 1;
}

static slash_cmd(cmd)
{
string tmp,tmp2;

  if(!cmd) cmd=="";
  cmd=lower_case(cmd);
  if(cmd[0]=='q') { this_player()->unlink();return 1;}
  if(cmd[0]=='h' || cmd=="?")
	 {
		if(cmd[0]!='?') sscanf(cmd,"help %s",tmp);
		  else sscanf(cmd,"? %s",tmp);
	    help(tmp);
		return 1;
	 }
  if(cmd=="p" || !strncmp(cmd,"p ",2)) {send_private(cmd);return 1;}
  if(cmd[0]=='s')
    {
		if(pvt && this_player()!=c_owner)
		  {
			 write("I'm sorry only the chat room owner can invite to this room.\n");
			 return 1;
	      }
		summon_user(cmd);
		return 1;
	}
  if(cmd[0]=='f') {sscanf(cmd,"%s %s",tmp2,tmp);do_fealing(tmp);return 1;}
  if(cmd[0]=='m') {sscanf(cmd,"%s %s",tmp2,tmp);do_emote(tmp);return 1;}
  if(cmd[0]=='e') { this_player()->set_echo();return 1;}
  if(cmd[0]=='w') { "closed/mcp"->show_who(0);return 1;}
  if(cmd[0]=='g') {sscanf(cmd,"%s %d",tmp2,tmp);goto_room(tmp);return 1;}
  if(cmd[0]=='n') { make_new_chat_room();return 1;}
  if(cmd[0]=='l') { list_chat_rooms();return 1;}
  if(!strncmp(cmd,"cw",2)) { show_chat_room();return 1;}
  if(!strncmp(cmd,"cl",2)) 
    { 
	   string cl;
	
	   cl=find_link(this_player())->query_cls();
	   if(!cl) write("clear screen option not set.  See User Configuration Menu.\n");
		  else write(cl);
		  return 1;
	}
  if(!chat_room)
    {
      write("Un-known '/"+cmd+"' command.\n");
 	  return 1;
	}
  if(this_player()!=c_owner)
	{
	   write("This function reserved for the room owner.\n");
	   return 1;
	}
  if(cmd[0]=='t') {sscanf(cmd,"topic %s",tmp);set_topic(tmp); return 1;}
  if(cmd[0]=='o') {sscanf(cmd,"owner %s",tmp);set_owner(tmp);return 1;}
  if(!strncmp(cmd,"pr",2)) {set_private(1);return 1;}
  if(!strncmp(cmd,"pu",2)) {set_private(0);return 1;}
  write("Un-known '/"+cmd+"' command.\n");
  return 1;
}

/*  to handle inheritance of soul for fealings */

static jump(str)
{
        if(!str) str="for joy";

        write("You jump "+str+".\n");
	say(capitalize(this_player()->query_name())+" jump's "+str+".\n");
        return 1;
}

static pos() { return "his/her"; }

static cname() { return capitalize(this_player()->query_name()); }

static find_ob(str)
{
   return present(str,this_object());
}

static do_action(str,flag) {
    object who;
    if(str) {
        who = present(lower_case(str),this_object());
        if (!who || who == this_player()) return;
        tell_object(who, mess[2]+"\n");
    }
    write(mess[0]+"\n");
    if(who) say(mess[1]+"\n",who);
    else say(mess[1]+"\n");
    return 1;
} 

static do_fealing(str)
{
  string tmp,tmp2;
  int ret;

  if(strchr(str,' '))
    { 
       tmp=explode(str,' ');
       tmp2=tmp[0];
       tmp=implode(del_element(tmp,0),' ');
    }
   else {tmp2=str;}

  ret=call_other(this_object(),tmp2,tmp);

  if(!ret) write(tmp2+" what ?\n");
}

/* end of fealing routings.  */

static do_emote(str)
{
string nam;

   nam=capitalize(this_player()->query_name());

   say("\n"+nam+" "+str+"\n");

   if(this_player()->query_echo()) write(nam+" "+str+"\n");

   return 1;
}

static summon_user(cmd)
{
   string who;

   if(sscanf(cmd,"s %s",who)!=1) write("Incorect format to /s.\n");
   else
    {
      object usrs;
      int i;

	  who=lower_case(who);
      usrs=users(1);
      for(i=0;i<sizeof(usrs);i++)
        if(usrs[i] && usrs[i]->query_name()==who)
		   {
		      tell_object(usrs[i],"You have been invited to CHAT by: "+this_player()->query_name()+" in room: "+chat_room+"\n");
			  if(pvt) add_invite_list(who);
			  write("User invited.\n");
			  return;
	       }
      write("No user by the name of '"+capitalize(who)+"' was found on the system.\n");
    }
}

static make_new_chat_room()
{
  object new_room;

  new_room=clone_object("bbs/chat/chat_room");
  move_object(this_player(),new_room);
}

goto_room(num)
{
   if((chat_room && num==chat_room) || (!num && !chat_room && present(this_player())))
     {
		write("You are already here.\n");
	    return;
	 }
   if(chat_room)
	 {
		"bbs/chat/chat_room"->goto_room(num);
		return;
	 }
   if(num>sizeof(rooms_array)-1 || num<0 || !rooms_array[num])
	 write("There is no room '"+num+"' to goto.\n");
	else
		 if(rooms_array[num]->query_private() && 
			!rooms_array[num]->query_invite(this_player()->query_name()))
		      write("I'm sorry, you must be invited before you may enter a private room.\n");
		   else
			    move_object(this_player(),rooms_array[num]);
}

static set_private(flag)
{
   if(!chat_room) return;
   if(this_player()!=c_owner) write("Sorry, you are not the owner.\n");
    else 
	  {
		 pvt=flag;
		 if(flag) write("This room is now private.\n");
		  else write("This room is now public.\n");
	  }
    return 1;
}

static set_owner(tmp)
{
  if(!chat_room) return;
  if(this_player()!=c_owner) write("Sorry, you are not the owner.\n");
   else if(!tmp) write("Owner unchanged.\n");
		  else
			{
			  object new_owner;

			  tmp=lower_case(tmp);
			  new_owner=present(tmp);
			  if(!new_owner) write("Sorry no person by that name in this room.\n");
			   else
				{
				   c_owner=new_owner;
				   write("Ownership transfered.\n");
				   tell_object(c_owner,this_player()->query_name()+" has transfered ownership to you of this room\n");
			    }
		    }
  return 1;
}

static set_topic(top)
{
  if(!chat_room) return;
  if(this_player()!=c_owner) write("Sorry, you are not the owner.\n");
  else if(!top) write("Topic unchanged.\n");
	     else
		  {
	  		 write("The topic is now set to: "+top+"\n");
			 topic=top;
		   }
  return 1;
}

  
list_chat_rooms()
{
  int i;

  if(chat_room) {"bbs/chat/chat_room"->list_chat_rooms();return;}
  write("\nActive chat rooms are:\n");
  write("----------------------------\n");
  for(i=0;i<sizeof(rooms_array);i++)
     if(rooms_array[i])
	  {
		write("Room #: "+i+"\t"+rooms_array[i]->query_topic());
        if(rooms_array[i]->query_private()) write(" P");
	    write("\n");
	  }
}

static help(topic)
{
  if(!topic)  {print_cmds();return;} 
  topic=lower_case(topic);
  if(topic=="quit")
	  write("/quit\tThis commands takes you out of chat and back to the main menu.\n");
  else if(topic=="clear")
	  write("/clear\tThis command clears your screen based on you user settings.\n");
  else if(topic=="help")
	  write("/help\tThis command will show you a list of avaiable commands.\n");
  else if(topic=="?")
	  write("/?\tThis command will show you a list of available commands.\n");
  else if(topic=="p") 
	  write("/p\tThis command, followed by a name allows you to send a private mesasge\nto that individual if they are in the chat system.\n");
  else if(topic=="who")
	  write("/who\tThis command shows you who is on the system and what they are doing.\n");
  else write("No such command '"+topic+"'\n");
}

static send_private(who_msg)
{
  string who,msg;
  object usrs;
  int i;

  if(sscanf(who_msg,"p %s %s",who,msg)!=2) 
	 {
		write("Invalid /p format.\n");
	    return;
	 }
  usrs=users();
  for(i=0;i<sizeof(usrs);i++)
	if(usrs[i] && !strncmp(file_name(usrs[i]),"bbs/chat/chat_user",18) &&
	   find_link(usrs[i])->query_name()==who)
	 {
		tell_object(usrs[i],"*** "+this_player()->chat_name()+": "+msg+"\n");
		write("Message to "+capitalize(who)+" sent.\n");
	    return;
	 }
  write("No user by the name '"+who+"' in the chat system.\n");
}

static print_cmds()
{
   cat("/bbs/chat/chat_cmds");
}

assign_new_chat_room()
{
  int i,found_slot;

  if(chat_room) return;
  for(i=0;i<sizeof(rooms_array) && !found_slot;i++)
    if(!rooms_array[i]) found_slot=1;
  if(found_slot) 
    {
	   rooms_array[--i]=previous_object();
       return i;
    }
  rooms_array=rooms_array+({previous_object()});
  return sizeof(rooms_array)-1;
}

exit(ob)
{
   say(capitalize(ob->query_name())+" has left the chat room.\n");
   if(ob==c_owner)
	 {
	    c_owner=0;
        if(!pvt)
		  {
			 object inv;
		     int s;

		     inv=all_inventory(this_object());
			 s=sizeof(inv)-1;
			 if(inv[s]!=ob && objectp(inv[s]))
				 {
				    tell_object(inv[s],"You are the new owner of this room.\n");
					c_owner=inv[s];
				 }
			  else
				 if(s>0 && objectp(inv[s-1]))
				   {
				 	 tell_object(inv[s-1],"You are the new owner of this room.\n");
					 c_owner=inv[s-1];
				   }
		  }
     }
   if(sizeof(all_inventory(this_object()))<2) 
     if(chat_room)
	  {
		 call_out("close_this_room",0);
	     "bbs/chat/chat_room"->remove_from_room_list(chat_room);
	  }
     else set_heart_beat(0);
}

static close_this_room()
{
  destruct(this_object());
}

reset(arg)
{
  topic="Public Chat";
  if(strchr(file_name(this_object()),'#')) 
		chat_room="bbs/chat/chat_room"->assign_new_chat_room();
   else
    {
      rooms_array=allocate(1);
	  rooms_array[0]=this_object();
    }
  return 1;
}

query_topic() { return topic; }

query_private() { return pvt;}

query_invite(name)
{
  int i;

  if(!invite_list) return;
  for(i=0;i<sizeof(invite_list);i++)
	if(invite_list[i]==name) return 1;
}

static add_invite_list(name)
{
  int i;
  if(!invite_list) invite_list=({name});
   else
     invite_list=invite_list+({name});
}

static remove_invite(name)
{
  int i;

  if(!invite_list) return;
  for(i=0;i<sizeof(invite_list);i++)
      if(name==invite_list[i]) invite_list=del_element(invite_list,i);
}

query_room() { return chat_room;}

heart_beat()
{
object ob;
int i,s;

 ob=all_inventory(this_object());

 for(s=sizeof(ob);i<s;i++)
  {
    if(!objectp(ob[i])) continue;
    if(!query_ip_number(ob[i])) destruct(ob[i]);
  }
}
