private;
global;

#include "config.h"

	/* The following variables contain user information */

int time_of_logout;		/* Track when last they were on.	  */
int number_of_failed_logins;	/* Number of failed login attemts since
				   last successful login.	          */
int time_limit;			/* Time allowed per call.		  */
int calls_to_date;		/* Total calls ever made.		  */
int calls_to_day;		/* Total calls made today.	   	  */
int length_of_call;		/* Time user was on-line.		  */
int max_idle_time;		/* Max time allowed to idle.		  */

int access;			/* User access.  This is a bit-flag var.  */
#define Valid_user	0	/* Validated user.			  */
#define Time_limit	1	/* Time limit inforced.			  */
#define Call_back	2	/* Call back wait inforced.		  */
#define Idle_check	3 	/* Idle check inforced.			  */
#define Sysop		4 	/* Sysop.				  */
#define Realm_owner	5 	/* Realm Owner.				  */
#define Verb_match	6 	/* Exact Verb Matching only.		  */
#define Expert		7	/* Exper Mode.				  */
							
string name;			/* User name/handle.			  */
string password;		/* User password.			  */
string cls;			/* Users Clear Screen Code.		  */
string ip_number;		/* Ip number users host machine.	  */

	/* The following varaibles contain personal information. */

string real_name;		/* Users real name.			  */
string date_of_birth;		/* Users date of birth.			  */
string address;			/* Users street address or P.O Box.	  */
string city;			/* Users city.				  */
string state;			/* Users state.				  */
string zip;			/* Users zip code.			  */
string phone;			/* Users void home phone.		  */
string email;			/* Users optional computer mail address   */

	/* The following are temp variables */

static int five_min_warning;
static int uc_set;
static int num_chances;
static int one_min_warning;
static int time_of_call;
static int no_save;
static int user_status;

static string status_name;
static string temp_pass;

static object me,mail_obj;

static int new_player;
static int verbs_set;

static logon() 
{
    me = this_object();
    no_save=1;
	time_of_call=time();
    enable_commands(1);
    cat("/news/WELCOME");
    write("Username: ");
    call_out("time_out",120);
    input(this_object(),"logon2");
    return 1;
}

static logon2(str) 
{
object temp;

    remove_call_out("time_out");
    if(!str || str == "")
      {
        destruct(this_object());
        return;
      }
    str = lower_case(str);
	if(find_player(str,1))
	  {
		write("You are already logged on!!\n");
		destruct(this_object());
		return;
	  }
	if(str == "new") 
	  {
#ifdef NO_NEW_USERS
		write("\nI'm sorry but we are not accepting new users at this time.\n");
		destruct(this_object());
		return;
	  }
#else
        write("Please enter the name or handle that you wish to use.\n(one word): ");
        new_player=1;
        call_out("time_out",120);
        input(this_object(),"logon2");
        return;
	  }
#endif
    if(!valid_name(str)) 
	  {
        write("Give name again: ");
	    call_out("time_out",120);
        input(this_object(),"logon2");
        return 1;
      }
    if(file_size("/banish/"+str)>=0) 
	  {
        write("That name is reserved.\n");
		if(new_player) 
	  	  {
            write("Please try another.\n");
		    call_out("time_out",120);
	    	input(this_object(),"logon2");
	    	write("Name: ");
	   		return;
	  	  }
        destruct(this_object());
        return;
      }
    if(str != "guest") 
       {
      	if(!new_player && !restore_object("users/" + str))
		  {
        	write("I'm sorry, there is no such account in use at this time.\n");
			destruct(this_object());
			return;
     	  }
	    if(!new_player && !test_bit(access,Valid_user))
		  {
			write("I'm sorry your account has not been validated yet.\n");
			write("Please try back later.\n");
		    terminate();
			return;
		  }
      	if(new_player && str!="guest") 
		  {
        	if(file_size("/users/"+str+".o")!=-1) 
			  {
	   			write("That name is in use, please try another.\n");
	    		write("Name: ");
			    call_out("time_out",120);
   			    input(this_object(),"logon2");
	    		return;
              }
			 else name = str;
       	  }
       }
	 else
	  {
#ifdef NO_GUESTS
		write("I'm sorry but we do not allow guests on the system at this time.\n");
		destruct(this_object());
	    return;
#else
        name="guest";
		set_bit(access,Time_limit);
		set_bit(access,Idle_check);
		time_limit=600;
		max_idle_time=180;
		finnish_start();
		return;
#endif
      }
#ifdef CALL_BACK_WAIT
    if(test_bit(access,Call_back) && time()-time_of_logout<300)
	  {
        write("I'm sorry but you must wait 5 minutes before you can login again.\n");
        destruct(this_object());
        return;
      }
#endif
	set_living_name(name);
    if(new_player)
	  {
		  write("Please enter you desired password now.\nPreferably a mix of numbers and upper and lower case letters.\n");
		  write("It must aslo be at least 6 letters in length.\n");
	  }
    write("Password: ");
    call_out("time_out",120);
    if(new_player) input(this_object(),"new_password", 1);
    else input(this_object(),"check_password", 1);
}
static new_password(str) 
{
    remove_call_out("time_out");
    write("\n");
	if(strlen(str)<6)
	  {
		write("Password too short.  Please choose a new one.\n");
		write("Password: ");
		call_out("time_out",120);
		input(this_object(),"new_password",1);
		return;
	  }
    if(!password) 
	  {
        password = str;
        write("Password: (again) ");
	    call_out("time_out",120);
        input(this_object(),"new_password", 1);
        return;
      }
    if(password != str) 
	  {
        write("You changed!\n");
        destruct(this_object());
        return;
      }
    password = crypt(password,password);
    save_object("users/"+name);
    ok();
}

static check_password(str) 
{
    remove_call_out("time_out");
	num_chances++;
    if(!password && name != "guest")
        write("\nYou have no password! Set it in the user configuration menu.\n");
    else 
     if(name != "guest" && crypt(str,str) != password)
	   {
	         write("Wrong password!\n");
		 if(num_chances>=3)
	           {
		 	 number_of_failed_logins++;
         	 	terminate();
         	 	return;
		   }
		 write("Try again: ");
		 call_out("time_out",120);
		 input(this_object(),"check_password",1);
		 return;
            }
    write("\n");
    ok();
    return 1;
}

reset()
{
  if(creator(this_object()) || query_realm(this_object(),1)!="sysop")
     destruct(this_object());
  return 1;
}

static valid_name(str) 
{
    int i, length;
    length = strlen(str);
    if(str == "logon") write("Invalid name\n");
      else
       if(length >11) write("Your name must not be longer than 11 characters.\n");
        else
         if(length <2) write("Your name must be at least 3 characters in length.\n");
          else 
  		    {
        	  for(i=0;i<length;i++)
               if((str[i] < 'a' || str[i] > 'z') && str[i] != '-')
				 {
                   write("Invalid characters in name:"+str+"\n");
                   write("Character number was "+(i+1)+".\n");
                   return;
            	 }
               return 1;
    	    }
}   

static main_menu(do_prompt) 
{
  user_status=-1;
  set_prompt(this_object(),"Login> ");
  verb_matching(test_bit(access,Verb_match));
  if(!test_bit(access,Expert)) menu();
  if(name!="guest" && objectp(mail_obj)) mail_obj->check_mail();
  if(do_prompt) write("Login> ");
  if(verbs_set) return;
  verbs_set=1;
  if(test_bit(access,Sysop)) 
	{
	  add_action("goto_system","&",2);
	}
  add_action("menu","?");
  add_action("system_help",({"help","HELP"}));

#ifdef lp245_DIST
  add_action("area",({"1","2"}));
#else
  add_action("area","1");
#endif

  add_action("terminate",({"quit","QUIT","terminate","TERMINATE"}));
  add_action("who",({"who","WHO"}));
  if(name=="guest") return;
  add_action("finger",({"finger","FINGER"}));
  add_action("list_users",({"list","LIST"}));
  add_action("area",({"chat","CHAT"}));
  add_action("user_config",({"user configuration","uc","UC","USER CONFIGURATION"}));
}

static list_users()
{
  cat("/users/LIST");
  return 1;
}

static finger(user)
{
  if(!user) write("Improper format to 'finger' command.\n");
   else
    {
		user=lower_case(user);
  		if(file_size("/users/"+user+".o")==-1) write("No such user.\n");
		  else
	   	   {
			 object ob;

			 ob=clone_object("closed/finger_ob");
			 if(!restore_object("users/"+user,ob))
				write("Sorry, No information on '"+user+"' found.\n");
			  else
			   {
				 write("\nUser....: "+ob->query_user_name()+"\n");
				 write("Last on.: "+(find_player(user,1)?"now":ob->query_last_call())+"\n");
				 write("Calls...: "+ob->query_calls_to_date()+"\n");
				 write("Net Mail: "+ob->query_email()+"\n");
			     if(ob->query_sysop()) write("Sysop\n");
			   }
			  destruct(ob);
		    }
	 }
  return 1;
}

static system_help(option)
{
  /* convert to more later */
  if(!option) cat("/bbs/help/system");
	else cat("/bbs/help/system"+extract(option,0,0));
  return 1;
}

static menu()
{
  cat("/bbs/menus/logon");
  if(test_bit(access,Sysop)) write("\n	'&' To enter Sysop area.\n");
  return 1;
}

static area(arg) 
{
string verb;

  if(arg) verb=arg;
     else verb=query_verb();
  if(verb=="1")
    {
	  user_status=1;
	  status_name="Def Distribution";
          set_prompt(this_object(),"> ");
          new_player("r1/obj/player", this_object(), ({name,0}));
	  return 1;
    }
#ifdef lp245_DIST
  if(verb=="2")
    {
	  user_status=2;
	  status_name="2.4.5lp mudlib";
          set_prompt(this_object(),"> ");
          new_player("r2/obj/player", this_object(),name);
	  return 1;
    }
#endif
  if(verb=="chat")
	{
	  user_status=-2;
	  set_prompt(this_object(),"");
	  new_player("bbs/chat/chat_user",this_object(),name);
      return 1;
    }
write(query_verb());
  write("I'm sorry that area is not open at this time.\n");
  return 1;
}

static terminate() 
{
   object used;

   set_heart_beat(0);
   used=used_object(me);
   if(used) tell_object(used,"Good bye.\n");
   time_of_logout = time();
   length_of_call=time()-time_of_call; 
   no_save=0;
   save_me();
   if(mail_obj) destruct(mail_obj);
   destruct(this_object());
   return 1;
}

static who()
{
  write("\n");
  "closed/mcp"->show_who();
  write("\n");
  return 1;
}

static check_idle_status()
{
  if (test_bit(access,Idle_check) && query_idle(used_object(me)) >= max_idle_time)
	{
	  tell_object(used_object(me),"Idle out!\n");
	  terminate();
	  return;
	}
}

static heart_beat() 
{
		if(!query_ip_number(me)) 
		   {
			terminate();
			return;
		    }
#ifdef NO_IDLE
		check_idle_status();
#else
		if(name=="guest") check_idle_status();
#endif

#ifdef TIME_LIMIT
		check_time_limit();
#else
		if(name=="guest") check_time_limit();
#endif
}

static check_time_limit()
{
 if(test_bit(access,Time_limit) && !five_min_warning && 
	time_limit-(time()-time_of_call)<=300)
	{
	  tell_object(used_object(me),"\nYou have 5 minutes left!\n");
	  five_min_warning=1;
	  return;
	}
 if(test_bit(access,Time_limit) && !one_min_warning &&
	time_limit-(time()-time_of_call)<=60)
	{
	  tell_object(used_object(me),"\nYou have 1 minute left!\n");
	  one_min_warning=1;
	  return;
    }
 if(test_bit(access,Time_limit) && time()-time_of_call>=time_limit)
	{
	  tell_object(used_object(me),"Time up!\n");
	  terminate();
	  return;
	}
}

static ok() 
{
  if(!new_player) move_player_to_start1();
   else
    {
      write("\n");
  	  cat("/info/Disclaimer");
  	  write("\n\n\nIf you do not accept this please hangup now.\nContinuing will be taken as your acceptance of this policy.");
  	  call_out("time_out",240);
  	  input(this_object(),"get_answere"); 
	}
}

static get_answere() 
{
  write("\n");
  remove_call_out("time_out");
  move_player_to_start1();
} 

static move_player_to_start8() 
{
  if (!email || uc_set) 
    {
	  write("If you have a net e-mail address that you would like\n");
	  write("available to others enter it below.\n");
      if(uc_set) write("\nOld email...: "+email+"\n");
      write("Enter your email address (or 'none'): ");
      if(!uc_set) call_out("time_out",120);
      input(this_object(),"getmailaddr");
      return;
    }
  move_player_to_start10();
}

static getmailaddr(maddr) 
{
  if(!uc_set) remove_call_out("time_out");
  if(uc_set && maddr!="") email = maddr;
  if(!uc_set) email=maddr;
  if(!email || email=="") email="none";
  move_player_to_start10();
}

static move_player_to_start1() 
{
   if(!test_bit(access,Valid_user)) cat("/bbs/menus/validate_msg");
   if(!real_name)
	 {
       write("Enter your REAL name (first last): ");
       call_out("time_out",120);
       input(this_object(),"set_real_name");
       return;
     }
#if 0
   move_player_to_start2();
#else
   move_player_to_start8();
#endif
}
 
static set_real_name(nm) 
{
string first,last;

  remove_call_out("time_out");
  if(!nm || strlen(nm)<5 || sscanf(nm,"%s %s",first,last)!=2)
   {
      write("You must enter a REAL FULL name.\n");
      write("Try again (first and last: ");
      call_out("time_out",120);
	  input(this_object(),"set_real_name");
      return;
   }
  real_name=nm;
#if 0
  move_player_to_start2();
#else
  move_player_to_start8();
#endif
}
 
static move_player_to_start6()
{
  if(!phone || uc_set)
    {
      if(uc_set) write("\nOld phone #.: "+phone+"\n");
      write("Please Enter Your voice phone (xxx/xxx-xxxx): ");
	  if(!uc_set) call_out("time_out",120);
      input(this_object(),"set_phone");
      return;
    }
   move_player_to_start7();
}
 
static set_phone(number)
{
  int area,prefix,sufix;
 
   if(!uc_set) remove_call_out("time_out");
   if(uc_set && number=="")
	{
		move_player_to_start7();
		return;
	}
   if(strlen(number)<12 ||
	  sscanf(number,"%d/%d-%d",area,prefix,sufix)!=3)
    {
      write("Sorry, you must enter a phone number.\n");
	  write("Ex. xxx/xxx-xxxx : ");
	  if(!uc_set) call_out("time_out",120);
	  input(this_object(),"set_phone");
      return;
    }
  phone=number;
  move_player_to_start7();
}
 
static move_player_to_start2()
{
  if(!address || uc_set)
   {
     if(uc_set) write("\nOld address.: "+address+"\n");
     write("Please enter your street address or PO box.: ");
	 if(!uc_set) call_out("time_out",120);
     input(this_object(),"set_address");
     return;
   }
  move_player_to_start3();
}
 
static set_address(addrs)
{
  if(uc_set) { if(addrs!="") address=addrs;}
  else 
   {
    remove_call_out("time_out");
    if(addrs=="")
      {
        write("I'm sorry, but you must enter an address.\n");
        write("Address: ");
	    if(!uc_set) call_out("time_out",120);
        input(this_object(),"set_address");
        return 1;
      }
    address=addrs;
   }
  move_player_to_start3();
}
 
static move_player_to_start3()
{
   if(!city || uc_set)
    {
      if(uc_set) write("\nOld city....: "+city+"\n");
      write("Enter your city: ");
	  if(!uc_set) call_out("time_out",120);
      input(this_object(),"set_city");
      return;
    }
  move_player_to_start4();
}
 
static set_city(cty)
{
   if(!uc_set) remove_call_out("time_out");
   if((!uc_set && strlen(cty)<2) || (uc_set && cty!="" && strlen(cty)<2))
    {
      write("I'm sorry but you must enter a city.\n");
      write("Enter your City: ");
	  if(!uc_set) call_out("time_out",120);
	  input(this_object(),"set_city");
      return 1;
    }
  if(cty!="") city=cty;
  move_player_to_start4();
}
 
static move_player_to_start4()
{
  if(!state || uc_set)
   {
     if(uc_set) write("\nOld state...: "+state+"\n");
     write("Enter your State: ");
	 if(!uc_set) call_out("time_out",120);
     input(this_object(),"set_state");
     return;
   }
 move_player_to_start5();
}
 
static set_state(st)
{
  if(!uc_set) remove_call_out("time_out");
  if((!uc_set && strlen(st)<2) || (uc_set && st!="" && strlen(st)<2))
   {
     write("You must enter a state.\n");
     write("Enter your state: ");
     input(this_object(),"set_state");
	 if(!uc_set) call_out("time_out",120);
     return;
   }
  if(st!="") state=st;
  move_player_to_start5();
}
 
static move_player_to_start5()
{
   if(!zip || uc_set)
    {
      if(uc_set) write("\nOld zip.....: "+zip+"\n");
      write("Enter your zip-code (xxxxx): ");
	  if(!uc_set) call_out("time_out",120);
      input(this_object(),"set_zip");
      return 1;
    }
  move_player_to_start6();
}
 
static set_zip(zip_code) 
{
int code;
 
   if(!uc_set) remove_call_out("time_out");
   if(uc_set && zip_code=="")
     {
	    move_player_to_start6();
		return;
	 }
   if(strlen(zip_code)<5 || sscanf(zip_code,"%d",code)!=1) 
     {
       write("I'm sorry but you must enter a zip-code.\n");
       write("Enter zip-code: ");
	   if(!uc_set) call_out("time_out",120);
	   input(this_object(),"set_zip");
       return;
     }
   zip=code;
   move_player_to_start6(); 
}
 
static move_player_to_start9() 
{
   if(uc_set) 
     {
        write("User Config complete.\n");
	    uc_set=0;
	    return;
     }
       
   if(new_player)
     {
       write("You can now leave a message to the Sysop's or corrections to the above.\nAlso please leave a time that we can call you voice.\n");
       write("Message: ");
       call_out("time_out",120);
       input(this_object(),"set_message");
       return;
     }
   move_player_to_start10();
} 

static set_message(msg) 
{
  remove_call_out("time_out");
  move_player_to_start10(msg);
}

static move_player_to_start7()
{
  if(!date_of_birth || uc_set) 
    {
	   if(uc_set) write("\nOld dob.....: "+date_of_birth+"\n");
	   write("What is your birthdate ( mm/dd/yy ) - ");
	   if(!uc_set) call_out("time_out",120);
	   input(this_object(),"set_birth");
	   return;
    }
  move_player_to_start10();
}

static set_birth(birth) 
{
  int mo,day,yr;

	if(!uc_set) remove_call_out("time_out");
    if(uc_set && birth=="")
	  {
		move_player_to_start8();
	    return;
	  }
	if((sscanf(birth, "%d/%d/%d", mo, day, yr) != 3 &&
	   sscanf(birth, "0%d/%d/%d", mo, day, yr) != 3) ||
	   mo < 1 || day < 1 || yr < 0 || mo > 12 || day > 31 || yr > 99) 
	  {
        write("Enter in the format mm/dd/yy where mm is the month,\n");
        write("dd is the day, and yy is the year, 08/21/91\n");
		write("Enter date: ");
		if(!uc_set) call_out("time_out",120);
		input(this_object(),"set_birth");
		return;
	  }
	date_of_birth = birth;
	move_player_to_start8();
}

static move_player_to_start10(msg) 
{
    if(new_player) 
	  {
#ifdef VALIDATE
        write("We will try to get your request for validation completed within 24 hours.\n");
        write("If a Sysop is on at this time you may be validated immediately.\n");
	    write_file("/users/Validate","\nUser name:\t"+name+"\nReal name:\t");
		write_file("/users/Validate",real_name+"\nAddress:\t"+address+"\n");
		write_file("/users/Validate","City:\t"+city+", "+state+" "+zip+"\n");
	    write_file("/users/Validate","Phone:\t"+phone+"\nDate of Birth:\t");
	    write_file("/users/Validate",date_of_birth+"\nMessage:\t");
	    write_file("/users/Validate",msg+"\nTime:"+ctime(time())+"\n");
#endif
	    time_limit=1800;
	    max_idle_time=300;
#ifndef VALIDATE
	    set_bit(access,Valid_user);
#endif
#ifdef TIME_LIMIT
	    set_bit(access,Time_limit);
#endif
#ifdef  CALL_BACK_WAIT
		set_bit(access,Call_back);
#endif
#ifdef NO_IDLE
	    set_bit(access,Idle_check);
#endif
        new_player=0;
#ifdef VALIDATE
        write("\n\nThank you for calling.\n");
        terminate();
        return;
#endif
      }
    finnish_start();
}
 
static give_first_warning()
{
int min;

    if(test_bit(access,Time_limit))
	  {
        min=time_limit/60;
        write("\nYou have "+min+" minutes left of this call.\n");
		write("You will receive a 5 and 1 minute warning.\n\n");
	  }
}

static finnish_start() 
{
#ifdef TIME_LIMIT
		give_first_warning();
#else
		if(name=="guest") give_first_warning();
#endif
    no_save=0;
	if(number_of_failed_logins)
	  {
		 write("\nThere have been "+number_of_failed_logins+" failed login ");
		 write("atempt(s)\nsince your last login.\n");
		 number_of_failed_logins=0;
	  }
    if(ip_number!=query_ip_number(me))
	  write("Your last call was from "+ip_number+" ip address.\n");
    ip_number=query_ip_number(me);
    calls_to_date++;
    if(time()-time_of_logout>=86400) calls_to_day=1;
	  else calls_to_day++;
    save_me();
    if(name!="guest")
      {
	mail_obj=clone_object("bbs/mail");
    	move_object(mail_obj,this_object());
      }
    set_heart_beat(1);
    main_menu(0);
}

save_me() 
{
  if(!no_save && name!="guest") save_object("users/"+name);
}

link(do_prompt)
{
   main_menu(1);
}

short()
{
    if(name) return capitalize(name)+" "+query_status();
}

static time_out() 
{
	write("Time out!\n");
	destruct(this_object());
}

query_name() { return name; }
query_user_name() { return name; }

set_status(stat) 
{
  if(!stat) return;
  if(stat==-1)
	{
	  if(!previous_object() ||
	     strncmp(file_name(previous_object()),"bbs/mail",8)) return;
	  user_status=-1;
	  status_name=0;
	  return 1;
	}
  status_name=stat;
  user_status=1;
  return 1;
}

query_status() 
{
  int len,i;
  string fill;

  len=11-strlen(name);
  fill=" ";
  for(i=0;i<len-1;i++) fill=fill+" ";
  if(user_status==0) return fill+" is loggin in";
  if(user_status==-1) return fill+" at the Main Menu";
  if(user_status==-2 && used_object(this_object()))
	 return fill+" is in Chat "+used_object(this_object())->query_chat_extra();
  if(user_status==-3) return fill+" is in the BBS";
  if(user_status==-4) return fill+" is in User Config";
  return fill+" "+status_name;
}

query_sysop() { return test_bit(access,Sysop);}

query_realm_owner() { return test_bit(access,Realm_owner);}

query_verb_preference() { return test_bit(access,Verb_match); }

query_access() { return access; }

set_access(num)
{
   /* To change the 0th bit you must pass -1 so as to keep accedents
      from happening. */

   if(!num || !previous_object() || query_realm(previous_object(),1)!="sysop")
	 return;
   if(numberp(num)!=1)
	  if(!stringp(num)) return;
		else sscanf(num,"%d",num);
   if(num==-1) num==0;
   set_bit(access,num);
   return 1;
}

remove_access(num)
{
   /* To change the 0th bit you must pass -1 so as to keep accedents
      from happening. */

   if(!num || !previous_object() || query_realm(previous_object(),1)!="sysop")
	  return;
   if(numberp(num)!=1)
	  if(!stringp(num)) return;
		else sscanf(num,"%d",num);
   if(num==-1) num==0;
   clear_bit(access,num);
   return 1;
}

query_cls() { return cls;}

query_verb_pref() { return test_bit(access,Verb_match);}

static user_config()
{
   remove_all_verbs(this_object(),this_object());
   verbs_set=0;
   user_status=-4;
   set_prompt(this_object(),"[UC]> ");
   add_action("umenu",({"help","?"}));
   add_action("umenu_cmd",({"1","2","3","4","5","6","7","quit","email"}));
   if(!test_bit(access,Expert)) umenu();
   return 1;
}

static umenu()
{
  cat("/bbs/menus/uc_menu");
  return 1;
}

static umenu_cmd()
{
 string verb;

 verb=lower_case(query_verb());
 if(verb=="1") 
   { 
      write("If you want to leave information unchanged, just press return when prompted.\n");
      uc_set=1;
#if 0
      move_player_to_start2();
#else 
      move_player_to_start8();
#endif
   }
 else if(verb=="2") set_cls();
 else if(verb=="3") set_verb_pref();
 else if(verb=="4") change_password();
 else if(verb=="5") 
    {
		write(cls);
	    write("This should be the only thing on your screen, in the upper left hand corner.\n");
    }
 else if(verb=="6") show_user_info();
 else if(verb=="7") set_expert();
 else if(verb=="quit") { remove_all_verbs(this_object(),this_object());main_menu(0);}
 else write("No such menu option.\n");
 save_me();
 return 1;
}

static set_expert()
{
   write("Current setting is: ");
   if(test_bit(access,Expert)) write("Expert.\n");
     else write("Novice.\n");
   write("Do you wish to change this? ");
   input(this_object(),"ask_expert");
   return 1;
}

query_expert() { return test_bit(access,Expert);}

static ask_expert(yes_no)
{

   yes_no=lower_case(yes_no);
   if(yes_no[0]!='y') write("Mode unchanged.\n");
    else 
	 {
	   write("Mode changed.\n");
	   if(test_bit(access,Expert)) clear_bit(access,Expert);
		 else set_bit(access,Expert);
	 }
}

show_user_info()
{
   if(!this_player() || query_realm(this_player(),1)!="sysop") return;
   if(this_player()!=this_object())
	 {
   		write("User.....: "+name+"\n");
   		write("Access...: "+access+"\n");
     }
   write("Name.....: "+capitalize(real_name)+"\n");
   write("Address..: "+address+"\n");
   write("C/S/Z....: "+city+", "+state+" "+zip+"\n");
   write("DOB......: "+date_of_birth+"\n");
   write("Phone #..: "+phone+"\n");
   write("Email....: "+email+"\n");
   write("Verb pref: ");
   if(test_bit(access,Verb_match)) write("Exact match only\n");
	 else write("Pattern matching enabled\n");
   write("CLS......: ");
   if(cls) write("Set\n");
	 else write("No set\n\n");
   write("E/N Mode.: ");
   if(test_bit(access,Expert)) write("Expert\n");
     else write("Novice\n");
   return 1;
}

static set_cls()
{
   write("To enter your clear screen sequence enter each character by it's\n");
   write("decimal equivalent. (ie.  a = 97 )\n");
   write("If your code uses and the 'escape' (all ansi) it's decimal code is 27.\n");
   write("Each character's code should be separated by a space.\n");
   write("\nexample:\n\tIf your code is: ^L  you would enter 12.\n");
   write("\tIf your code is: ESCAPE [ 2 J  you would enter: 27 91 50 74.\n");
   write("\nEnter the code sequence: ");
   input(this_object(),"set_cls2");
   return 1;
}

static set_cls2(cl)
{
  string cl_arr; 
  int i;

  if(cl=="")
    {
	   write("Clear screen command unchanged.\n");
	   return 1;
	}
  if(strchr(cl,' '))
   {
     cls="";
     cl_arr=explode(cl,' ');
     for(i=0;i<sizeof(cl_arr);i++)
	  {
		cls+=" ";
		sscanf(cl_arr[i],"%d",cls[i]);
	  }
   }
  else { cls=" ";sscanf(cl,"%d",cls[0]);}
  write("Clear screen command has been set.\nUse the test option at the menu to verify that it works.\n");
}

static set_verb_pref()
{
  write("Current verb preference is set to: ");
  if(test_bit(access,Verb_match)) write("Exact match only.\n");
    else write("Pattern matching enabled.\n");
  write("\nDo you wish to change this? ");
  input(this_object(),"ask_verb");
}

static ask_verb(yes_no)
{
   yes_no=lower_case(yes_no);
   if(stringp(yes_no) && yes_no[0]=='y')
     {
	    if(test_bit(access,Verb_match)) clear_bit(access,Verb_match);
	  	  else set_bit(access,Verb_match);
	    verb_matching(test_bit(access,Verb_match));
		write("Verb prefference has been changed.\n");
	 }
   else write("Verb prefference has not been changed.\n");
}


static change_password()
{
   write("Enter old password: ");
   input(this_object(),"cold_password",1);
}

static cold_password(pass)
{
   /* work crypt function into this later. */
   if(password && crypt(pass,pass)!=password)
    {
	  write("\nWrong password!\n");
	  return;
	}
  write("\n\nYou may now enter your new password.  Remeber it must be at least 6 letters\n");
  write("in length, and should be a mix of numbers, and upper and lower case letters.\n");
  write("\nEnter new password: ");
  input(this_object(),"cnew_password",1);
}

static cnew_password(pass)
{
   temp_pass=pass;
   write("\nAgain: ");
   input(this_object(),"cknew_password",1);
}

static cknew_password(pass)
{
   if(pass!=temp_pass)
     {
	    write("\nPasswords do not match.  Password unchanged.\n");
	    temp_pass=0;
	    return;
     }
   if(strlen(pass)<6)
	 {
		write("\nPassword too short.  Password unchanged.\n");
		temp_pass=0;
		return;
	 }
   password=crypt(temp_pass,temp_pass);
   temp_pass=0;
   write("\nYour password has been changed.\n");
}

static goto_system()
{
  set_prompt(this_object(),"Uri% ");
  user_status=1;
  status_name="is in the System";
  new_player("closed/sysop",this_object(),name);
  return 1;
}
