#include "object.h"
/*
  
   This object is a standard food or drink object.  You clone it
   and confure it like yo do the other standard cloneable objects.
  
   To use this you can do:
     inherit "r1/obj/food_drink";
   ......
   or,
   object ob;
   ob = clone_object("r1/obj/food_drink");
  
*  For more documentation look at /doc/build/food_drinks


   These functions are defined:
           set_type(int)        0-alcohol,1-reg drink,2-food.

	   set_container(int)   0-no container, 1-contianer.

	   set_short(string)	To set the short description.

	   set_long(string)	To set the long description.

	   set_value(int)	To set the value of the item.

           set_empty_value(int)
	   set_weight(int)	To set the weight of the item.

	   set_strength(int)	To set the healing power of the item. If you
				don't wish the item to have healing powers
				just set this value to 0.  set strength before
				you set value.

	   set_consumer_mess(string)
				To set the message that is written to the 
				player when he drinks or eats the item.

	   set_consuming_mess(string)
				To set the message given to the surrounding
				players when this object is drunk or ate.

	   set_empty_container(string)
				The container of the liquid inside. For
				example "bottle" or "bowl".

*/

string empty_value, consuming_mess, 
	consumer_mess, empty_container;
int strength, full,type,container;

init()
{
	if(type<2) add_action("consume", "drink");
	 else add_action("consume","eat");
}

prevent_insert()
{
  if(r1/obj/food_drink::prevent_insert())
     {
	 write("You don't want to ruin the " + ids[sizeof(ids)-1]+ ".\n");
  	 return 1;
     }
}


set_empty()
{
   if(!container) {destruct(this_object());return;}
   full=0;
   set_id(empty_container);
}

short()
{ 
    if (full || !container) return short_desc;
       else return "An empty " + empty_container;
}

long() 
{
   if (!long_desc) return short() + ".\n";
      else return long_desc;

}

consume(str)
{
	object tp;
	string p_name;

	tp = this_player();
	p_name = tp->query_name();

	if ((container && !full) || !str || !id(str)) return;

        if(type<=1)
          {
           if(!tp->add_fluid(strength) || (!type && !tp->add_alcohol(strength)))
	       {
		  write("You couldn't posibly drink another drop!\n");
		  return 1;
	       }
	  }
        else if(!tp->add_food(strength))
		{
		  write("You coudln't posibly eat another bite!\n");
		  return 1;
		}
		
	write(consumer_mess);

	if (consuming_mess)
		say(p_name +" "+ consuming_mess);
	else
		if(type<=1) say(p_name + " drinks " + short_desc + ".\n");
		   else say(p_name+" eats "+short_desc+".\n");

	set_empty();
	return 1;
}

set_empty_value(v) 
{ 
   if(v>value) v=value;
   empty_value=v;
}

set_strength(s) 
{
	strength = s; 
}

set_consuming_mess(dm) 
{ 
	consuming_mess = dm; 
}

set_consumer_mess(dm) 
{ 
	consumer_mess = dm; 
}

set_empty_container(ec)
{
	empty_container = ec;
}

set_container(n)
{
  if(n) container=1;
    else container=0;
}

set_type(t)
{
  if(t<0) t=0;
  if(t>2) t=2;
  type=t;
}

/*
 * Things that other objects might want to know.
 */

query_value() 
{ 
    if(full || !container) return value; 

    return empty_value;
}

query_type() { return type; }

query_container() { return container; }
