#include "object.h"

pointer fuel;
int light_status;
int light_amt;

#define HOOD		1	/* we have a hood */
#define LAMP		2	/* we are a lamp */
#define HOOD_OPEN	3	/* the hood is open */
#define LIT		4	/* we are lit. */


set_lamp(n)
{
  if(n) light_status=set_bit(light_status,LAMP);
   else light_status=clear_bit(light_status,LAMP);
}

query_lamp() { return test_bit(light_status,LAMP); }

set_hood(n)
{
  if(n) light_status=set_bit(light_status,HOOD);
   else light_status=clear_bit(light_status,HOOD);
}

query_hood() { return test_bit(light_status,HOOD); }

query_hood_open() { return test_bit(light_status,HOOD_OPEN); }

query_lit() { return test_bit(light_status,LIT); }

query_prevent_insert() 
{
 if(obj/gen::query_prevent_insert())
   {
      write("You can not put a lit lamp in a container.\n");
      return 1;
    }
}

long() 
{
  string tmp;

  tmp=long_desc?long_desc:short_desc+".\n";

  if(test_bit(light_status,LIT)) tmp+="It is lit.\n"; 

  if(!test_bit(light_status,LAMP)) 
       return tmp;

 if(test_bit(light_status,HOOD))
  if(test_bit(light_status,HOOD_OPEN)) tmp+="The hood is open.\n";
     else tmp+="The hood is closed.\n";

  if(fuel[0]==fuel[1]) tmp+="The "+ids[0]+" is full.\n";
   else if(fuel[0]<fuel[1] && fuel[0]>=(fuel[1]*3)/4)
            tmp+="The "+ids[0]+" is almost full.\n";
     else if(fuel[0]<(fuel[1]*3)/4 && fuel[0]>fuel[1]/2)
            tmp+="The "+ids[0]+" is three forths full.\n";
       else if(fuel[0]==fuel[1]/2) 
	    tmp+="The "+ids[0]+" is half empty.\n";
         else if(fuel[0]<fuel[1]/2 && fuel[0]>fuel[1]/4) 
	    tmp+="The "+ids[0]+" is three forths empty.\n";
           else if(fuel[0]>0 && fuel[0]<=fuel[1]/4) 
	    tmp+="The "+ids[0]+" is almost empty.\n";
             else if(fuel[0]<1) tmp+="The "+ids[0]+" is empty.\n";

   return tmp;
}

short() 
{
  if(test_bit(light_status,LIT))
      return short_desc+" (lit)";
   else return short_desc;
}

add_fuel(f) 
{
  fuel[0]+=f; 
  if(fuel[0]>fuel[1]) fuel[0]=fuel[1];
   else if(fuel[0]<1) fuel[0]=0;
  return 1;
}

query_fuel(n)
{ 
   if(n==-1) return fuel;
  
   if(n>1) return -1;

   return fuel[0];
}

set_max_fuel(num)
{
  if(numberp(num) && num>0) 
   if(!pointerp(fuel)) fuel=({0,num});
     else fuel[1]=num;
}

init() 
{
  if(!this_player() ||
    (environment()!=this_player() && !present(this_player(),environment()))) return;
  if(test_bit(light_status,LAMP))
   {
     add_action("light","turn");
     add_action("hood",({"close","open"})); 
   }
  else add_action("light",({"light","douse","extinguish"}));
}

hood(str)
{
int num;
int light;

  if(!test_bit(light_status,HOOD)) return;

  if(stringp(str)) str=lower_case(str);
     else return;

  if(str!="hood") return;

  str=query_verb();

  if(str=="open" && test_bit(light_status,HOOD_OPEN))
    {
       write("It is already open!\n");
       return 1;
    }

  if(str=="close" && !test_bit(light_status,HOOD_OPEN))
    {
      write("It is already closed!\n");
      return 1;
    }

  light=set_light(0);

  if(str=="open")
   {
     write("You open the hood of your "+ids[0]+".\n");
     if(light>0) say(this_player()->query_name()+" opens the hood to "+gender()+" "+ids[0]+".\n");

     if(test_bit(light_status,LIT))
       {
         set_light(2);

         if(light<1 && set_light(0)>0)
          {
             say("You can see again.\n");
             write("You can see again.\n");
          }
       }

     light_status=set_bit(light_status,HOOD_OPEN);
    }

  if(str=="close")
   {
     write("You close the hood of your "+ids[0]+".\n");

     if(light>0) say(this_player()->query_name()+" closes the hood to "+gender()+" "+ids[0]+".\n");

     if(test_bit(light_status,LIT)) 
      {
       set_light(-2);
       if(light>0 && set_light(0)<1)
         {
           say("It goes dark.\n");
           write("It goes dark.\n");
         }
      }

   light_status=clear_bit(light_status,HOOD_OPEN);
   }

  return 1;
}

light(str)
{
int light;
string on_off,id_str,tmp;

  if(str) str=lower_case(str);
   else return;

  if(test_bit(light_status,LAMP))
   {
      if(sscanf(str,"%s %s %s",id_str,tmp,on_off)==3 ||
         sscanf(str,"%s %s",id_str,on_off)==2)
        {
          if(tmp) id_str+=" "+tmp;
          if(!id(id_str) || !strstr("onoff",on_off)) return;
        }
      else return;
    }
  else if(!id(str)) return;
	else on_off=query_verb();

  if((on_off=="light" || on_off=="on") && test_bit(light_status,LIT)) 
    {
      write("It is already lit.\n");
      return 1;
    }

  if(strstr("douseextinguishoff",on_off) && !test_bit(light_status,LIT)) 
    {
      write("It's not lit.\n");
      return 1;
    }

  light=set_light(0);

  if(on_off=="light" || on_off=="on")
    {
      if(fuel[0]<1)
       {
         write("The "+ids[0]+" fails to light.\n");
         return 1;
       }

      set_heart_beat(1);

      if(test_bit(light_status,HOOD_OPEN))
         set_light(4);
      else 
       {
         if(test_bit(light_status,LAMP)) set_light(2);
		else set_light(1);
       }

      light_status=set_bit(light_status,LIT);
      set_prevent_insert(1);

      if(light<1 && set_light(0)>0) 
       {
         write("You can see again.\n");
         say("You can see again.\n");
       }

       write("You "+query_verb()+" the "+ids[0]+(test_bit(light_status,LAMP)?" on":"")+".\n");

      if(set_light(0)>0) say(this_player()->query_name()+" "+query_verb()+" "+gender()+" "+ids[0]+(test_bit(light_status,LAMP)?"on":"")+".\n");
    }

  if(strstr("douseextinguishoff",on_off))
   {
     set_heart_beat(0);

     if(light>0) say(this_player()->query_name()+" "+query_verb()+" "+gender()+" "+ids[0]+(test_bit(light_status,LAMP)?" off":"")+".\n");

     if(test_bit(light_status,LAMP)) write("You turn off the "+ids[0]+".\n");
	 else write("You "+on_off+" the "+ids[0]+".\n");

     if(test_bit(light_status,HOOD_OPEN)) set_light(-4);
      else if(test_bit(light_status,LAMP)) set_light(-2);
		else set_light(-1);

     if(light>0 && set_light(0)<1)
      {
        say("It turns dark.\n");
        write("It turns dark.\n");
      }

     set_prevent_insert(0);
     light_status=clear_bit(light_status,LIT);
    }
  return 1;
}

heart_beat()
{
  if(--fuel[0]<1)
   {
     fuel[0]=0;
     out_of_fuel();
     set_heart_beat(0);
     return;
   }
}

out_of_fuel() 
{
  if(test_bit(light_status,LAMP))
    {
        if(test_bit(light_status,HOOD_OPEN)) set_light(-4);
          else set_light(-2);
    }
  else set_light(-1);

  light_status=clear_bit(light_status,LIT);
  set_prevent_insert(0);

  if(!set_light(0)) say("There is darkness as a " + ids[0] + " goes dark.\n");
  else say("The " + ids[0] + " goes dark.\n");
}

query_value()
{
    if(test_bit(light_status,LAMP)) return 300+(fuel[0]/10);
      else return fuel[0]/100;
}

static gender()
{
  if(this_player()->query_gender()==1) return "his";
  if(this_player()->query_gender()==2) return "her";
  return "it's";
}

extra_restore(file)
{
  set_prevent_insert(0);
  if(!test_bit(light_status,LIT)) return 0;
   light_status=clear_bit(light_status,LIT);
   if(test_bit(light_status,LAMP)) command("turn "+ids[0]+" on",this_player());
     else command("light "+ids[0],this_player());
}
