#include "living.h"
#include "wizard.h"
#include "levels.h"
#include "log.h"
#include "generic.h"
#include "entry.h"


inherit "obj/soul";

#define CONTROL "r1/closed/control"
#define MCP "r1/closed/mcp"
#define SAVE_DIR "r1/p/"

private;
no_ext_save;

#define MAX_SCAR	10
#define CHUNK 20

int talk;        	    	/* For talk echo */
int block_sh,block_tells;

int chunk;

int scar;
int intoxicated;		/* How many ticks to stay intoxicated. */
int player_num;
int stuffed;			/* How many ticks to stay stuffed */
int soaked;			/* How many ticks to stay soaked */
int headache, max_headache;

string title;			/* Player title. */
string descript;		/* Personal Description. */
string saved_where;     	/* room location */


string current_path;		/* Current directory */
string user_name;		/* the name of the user that owns this account. */

static string more_file;	/* Used by the more command */

static int more_line;
static int time_to_save;	/* Time to autosave. */
static int last_time;

static int no_save,dest_on_save;

static object me,link_to;

/* link() is called when the players logges on. */

static link(arg) 
{
	no_save = 1;
	last_time=time();
	me = this_object();
	link_to=find_link(me);

        if(!pointerp(arg)) {destruct(me);R0}

	enable_commands(1);

	if(arg[0] == "guest")
	 {
		hit_points=({50,0});
		spell_points=({0,0});
		title = "the guest";
		user_name=name="guest";
		use_light = 1;
		set_neuter();
	 }
        else if(!restore_object(SAVE_DIR+itoc(arg[0][0])+"/"+arg[0]+"."+arg[1]))
	  {
		hit_points=({50,0});
		spell_points=({0,0});
		title = "the newbie";
		user_name=name=arg[0];
		use_light = 1;
		set_neuter();
		mkdir(SAVE_DIR+itoc(name[0])+"/"+name+"."+arg[1]+".s");
	  }
	if(!user_name)
	 {
		write("Error, This is not your account.\n");
		destruct(me);
		R0
	 }

        player_num=arg[1];

        if(wiz_level)
          {
             new_player("r1/obj/obj_dev/wizard",this_player(),arg);
	     call_out("wiz_dest",30);
	     no_save=1;
	     return;
	  }

        CONTROL->add_players(this_object());


        init_arrays();
	time_to_save = time()+900;
	dead = ghost;
	local_weight[1] = 0;
	set_living_name(name);
	cap_name=capitalize(name);

        if(!playing_time)
          {
             playing_time=time();
	     set_up_new_player();
          }
	
#ifdef LOG_ENTER
	log_file("ENTER", cap_name+", from: "+query_host_name(this_object())+" @"+ctime(time())+".\n");
#endif

	add_soul_commands();
	add_standard_commands();
        set_heart_beat(1);
	move_object(me, "r1/room/control/start");
        if(credits<0.00) credits=0.00;
	verb_matching(find_link(this_object())->query_verb_pref());
	restore_inv();
	write("Now entering game...");
	call_out("finnish3",1);
}

finnish3()
{
    write("\n");

    if(saved_where && saved_where!="r1/room/void") move_object(me, saved_where);
     else
      {
        move_object(me, ENTRY_POINT);
        saved_where=ENTRY_POINT;
      }

    if(user_name!="guest") no_save=0;
    save_me(2);

    if(!is_invis) say(cap_name+" enters the game.\n");

    if(!brief) look();
      else glance();
      write("> ");
}

static set_up_new_player()
{
 object torch;
 int tm;

#ifdef LOG_NEWPLAYER
	log_file("NEWPLAYER", cap_name+" on:"+ctime(time())+".\n");
#endif

    torch=clone_object("r1/obj/light");
    torch->set_short("An Oil Lamp");
    torch->set_can_pick_up(1);
    torch->set_can_drop(1);
    torch->set_max_fuel(3000);
    torch->add_fuel(1000);
    torch->set_lamp(1);
    torch->set_hood(1);
    torch->set_weight(2.0);
    torch->set_id("lamp:oil lamp");
    move_object(torch,this_object());
    add_weight(2.0);
    tm="r1/obj/obj_dev/day_night"->query_time();
    if(tm[0]<2 || tm[0]>4)
	 {
		write("It is currently night time, you have been granted a lit lamp.\n");
                command("open hood");
	        command("turn lamp on");
	 }
	else write("It is currently day time, you have been granted an unlit lamp.\n");
}

/* Called by command 'save' */

save_character() 
{
    save_me(0);
    write("Ok.\n");
    return 1;
}
 
reset(arg) 
{
    if (creator(this_object())) 
      {
	no_save=1;
	destruct(this_object());
	return;
      }  
    chunk = CHUNK;
    init_arrays();
    name = "logon";
    cap_name = "Logon";
    msgin = "arrives"; msgout = "leaves";
    mmsgin = "arrives in a puff of smoke.";
    mmsgout = "disappears in a puff of smoke.";
    title = "the newbie";
    set_can_pick_up(1);
    set_visable_inventory(1);
    set_can_put_in(1);
    return 1;
}

/* Enable other objects to query our hit point. */

short() 
{
    string to_return;

	if (ghost) to_return = "The ghost of " + cap_name;
    	  else to_return = cap_name + " " + title + " (" + alignment + ")";

    if(query_ip_number(this_object()) && query_idle(this_object())/60)
      to_return += " {"+(query_idle(this_object())/60)+"}";

    if(to_return) 
        if(query_ed(this_object())) to_return = "[ "+to_return+" ]";

    if(query_verb() != "who" && query_verb() != "swho" && attacker &&
      present(attacker))

        to_return += " *Fighting "+attacker->query_name()+"*";
    return to_return;
}

long() 
{
    string cap_pronoun;
    string long_ds;

    cap_pronoun = capitalize(query_gender_string(1));
    long_ds=short() + ".\n";
    if (ghost) return;
    long_ds+=show_scar();
    if (hit_points[0] < hit_points[1]/10)
		long_ds+=cap_pronoun + " is in very bad shape.\n";
      else if (hit_points[0] < hit_points[1]/5) 
			  long_ds+=cap_pronoun + " is in bad shape.\n";
    	else if (hit_points[0] < hit_points[1]/2) 
		  	    long_ds+=cap_pronoun + " is not in a good shape.\n";
    	  else if (hit_points[0] < 3*hit_points[1]/4) 
				  long_ds+=cap_pronoun + " is slightly hurt.\n";
    		else long_ds+=cap_pronoun + " is in good shape.\n";
    if(descript) long_ds+=descript+"\n";

    return long_ds;
}

list_skills(str)
{
  string tmp;
  int s,i;

  if(str!="skills") return 0;

  if(!sizeof(skill_names)) 
    {
       write("You are without skill.\n");
       return 1;
    }

  write("Skill List\n");
  write("------------------\n");
  for(s=sizeof(skill_names);i<s;i++)
   {
      write(sprintf(tmp,"%-15s: %-2d   ",upper_case(skill_names[i]),skill_levels[i]));
      if(!((i+1)%3)) write("\n");
   }
  write("\n");
  return 1;
}

score() 
{
    string tmp;

    if (ghost) 
	  {
		write("You are in an immaterial state with no scores.\n");
	    return 1;
      }
	write("Race   : "+race+"\n");
	if(!levels[1]) write("Level  : "+levels[0]+"\n");
           else if(!levels[2]) write("Levels : "+levels[0]+"/"+levels[1]+"\n");
	     else write("Levels : "+levels[0]+"/"+levels[1]+"/"+levels[2]+"\n");

	if(!classes[1]) write("Class  : "+classes[0]+"\n");
           else if(!classes[2]) write("Classes: "+classes[0]+"/"+classes[1]+"\n");
	     else write("Classes: "+classes[0]+"/"+classes[1]+"/"+classes[2]+"\n");

	sprintf(tmp,"H.P.   : %4d (%5s                 Str   : %-d\n",hit_points[0],
		    (hit_points[1]+")"),Str[0]);
	write(tmp);
        if(magical)
	   sprintf(tmp,"S.P.   : %4d (%5s                 Dex   : %2d\n",spell_points[0], (spell_points[1]+")"),Dex[0]);
	   else 
	      sprintf(tmp,"                                     Dex   : %2d\n",Dex[0]);
	write(tmp);
    sprintf(tmp,"Exp    : %-10d                  Con   : %2d\n",exp[0],Con[0]);
    write(tmp);
	sprintf(tmp,"Credits: %-10.2f                  Int   : %2d\n",credits,Int[0]);
	write(tmp);
	sprintf(tmp,"Age    : %-7.2f                     Wis   : %2d\n",age,Wis[0]);
	write(tmp);
	write(sprintf(tmp,"Height : %-3.2f\n",height));
        sprintf(tmp,"Weight : %-6.2f  Carrying: %-8.4f  Encumbrance: %8.4f\n",local_weight[0],local_weight[1],query_encumbrance());
	write(tmp);
    if (whimpy) write("\nWimpy mode   : "+whimpy+"0%  "+(whimpy_dir?("Cmd: "+whimpy_dir):"")+"\n");
     else write("\nBrave mode.\n");
    if (intoxicated || stuffed || soaked)
      {
  	    tmp = "You are ";
        if (intoxicated)
			{
	    	  tmp += "intoxicated";
	    	  if (stuffed && soaked) tmp += ", ";
	    	    else
	    		 {
				   if (stuffed || soaked) tmp += " and ";
					else tmp += ".\n";
	    		 }
			}
        if (stuffed)
		  {
	    	tmp += "satiated";
	    	if (soaked) tmp += " and ";
	    	  else tmp += ".\n";
		  }
		if (soaked) tmp += "not thirsty.\n";
	    write(tmp);
      }
    show_playing_time();
    return 1;
}

/* Identify ourself. */

id(str, lvl)
{
    if(str == name || str == "the ghost of " + name) return 1;

    return 0;
}


set_level(cls,lev)
{
int i,i2;

    if(this_player() && this_player()!=this_object() &&
       this_player()->query_wiz_level() &&
	   this_player()->query_wiz_level()<ADMIN)
      {
        log_file("ADVANCE","The Wizard "+this_player()->query_real_name()+
             " tried to change "+name+" players level@"+ctime(time())+"\n");
	return 0;
      }
   if(name=="guest" || name=="logon") return 0;

   if(this_player() != this_object()) 
      log_file("ADVANCE", this_player()->query_name()+"["+
      	       this_player()->query_level()+"] changed "+cap_name+"["+levels[0]+
      	       "] to Level "+lev+" at "+ctime(time())+"\n");
  	else log_file("ADVANCE",name+" changed there level to "+lev+" from "+levels[0]+ "@"+ctime(time())+"\n");

   if(!set_level(cls,lev))
     {
        log_file("ADVANCE",name+" could not have the class: "+cls+" advanced to level: "+lev+"\n");
        return 0;
     }

   for(;i<hit_points_die[0];i++)
     i2+=random(hit_points_die[1])+Con[1];

   hit_points[0]+=i2;
   hit_points[1]+=i2;

   i=0;

   if(query_class("mage")) i=Int[0];

   if(query_class("cleric"))
     {
       i2=i;

       i=Wis[0];

       if(i2) i=(i+i2)/2;
     }

   if(i) 
    {
     spell_points[0]+=i-spell_points[1];
     spell_points[1]=i;
    }

  return lev;
   
}

set_title(t) { title = t?t:""; return 1;}

quit()
{

#ifdef LOG_QUIT
    log_file("QUIT", cap_name+", "+ctime(time())+".\n");
#endif

  if(name!="guest" && name!="logon")
   {
      save_me(1);
      write("Saving "+cap_name+".\n");
   }
  else
   {
      object arr;
      int i,s;

      drop_all();

     no_save=1;
          save_me(1);

   }

   if (!is_invis) say(cap_name + " left the game.\n");

   set_heart_beat(0);

   if(query_verb()=="&")
     {
       destruct(this_object());
       return 1;
     }

    if(query_verb()=="logout")
     {
       destruct(find_link(this_object()));
       destruct(this_object());
       return 1;
     }

   return_to_p_menu();

   return 1;
}

communicate(str) 
{
    string verb;
    string type;

    verb = query_verb();
    if (!str) return 0;
    str = valid_input(str);

    switch(str[strlen(str)-1])
      {
        case '?':
	     type=" asks: ";
	     break;
	case '!':
	    type=" exclaims: ";
	    break;
        case '.':
	    type=" says: ";
	    break;
	default:
	    type=" says: ";
	    str+=".";
      }

    if (ghost)
	  {
		say(short() + type + str + "\n");
		if(talk) write(short()+type+str+"\n");
		  else write("Ok.\n");
		return 1; 
	  }
    say(cap_name + type + str + "\n");
    if(talk) write(cap_name+type+str+"\n");
      else write("Ok.\n");
    return 1;
}

static heart_beat() 
{
    if(!objectp(link_to))
      {
        save_me(1);
	say(cap_name+" has just disconnected.\n");
	CONTROL->del_players(this_object());
        destruct(this_object());
        return 1;
      }

    if (name!="guest" && time() > time_to_save) 
      {
	if (!brief && !this_object()->query_wiz_level()) write("Autosave.\n");
	save_me(0);
	time_to_save = time() + 900;
      }

    if(ghost) return;
}

static test_dark() 
{
    if (set_light(0) <= 0) 
	  {
		write("It is too dark.\n");
		return 1;
      }
    return 0;
}

put(str)
{
    int i;
    string item;
    string container;
    object item_o;
    object container_o;

    if (!str) return 0;
    if (!use_light && test_dark()) return 1;
    if (sscanf(str, "%s in %s", item, container) != 2) 
	  {
		write("put what ?\n");
		return 1;
      }
    container = lower_case(container);
    container_o = present(container, this_player());
    if (!container_o)
	  container_o = present(container, environment(this_player()));
    if (!container_o) 
	  {
		write("There are no " + container + "s here!\n");
		return 1;
      }
    if (!container_o->can_put_in()) 
	  {
		write("You can't do that.\n");
		return 1;
      }
    item = lower_case(item);
    item_o = present(item, this_player());
    if (!item_o) 
	  {
		write("You have no " + item + "!\n");
		return 1;
      }
    if (item_o == container_o) return 0;
    if (environment(item_o)!=this_object() &&
	!environment(item_o)->query_can_get_out()) return 1;
    if (!item_o->query_can_drop() || item_o->query_prevent_instert()) return 1;
    i = item_o->query_weight();
    if (container_o->add_weight(i)) 
	  {
  		/* Remove the weight from the previous container. */

	    environment(item_o)->add_weight(-i);
		move_object(item_o, container_o);
		say(cap_name + " puts the " + item + " in the " + container + ".\n");
		write("Ok.\n");
		item_o->drop();
		return 1;
      }
    write("The "+lower_case(container)+" is too full to hold it.\n");
    return 1;
}

pick_up(str) 
{
    string item;
    string container;
    object item_o;
    object container_o;
    int w;

    if (!str) 
      {
	write("What ?\n");
	return 1;
      }

    if (ghost) 
      {
	write("You fail.\n");
	return 1;
      }

    if (!use_light && test_dark()) return 1;

    if (str == "all") 
      {
	if(environment()->query_can_get_out()) get_all(environment());
		else write("You can't take that from there.\n");

	return 1;
      }

    if(sscanf(str,"all %s",item)==1 &&
       sscanf(item,"%s from %s",item_o,container)!=2 &&
       sscanf(item,"from %s",container)!=1)
      {
	if(environment()->query_can_get_out()) 
		get_all(environment(),0,lower_case(item));
	   else write("You can't take them.\n");

	return 1;
      }

    if (sscanf(str, "%s from %s", item, container) != 2) 
      {
	pick_item(str);
	return 1;
      }

    container_o = present(lower_case(container));

    if (!container_o) 
      {
	write("There is no " + container + " here.\n");
	return 1;
      }

    if (!container_o->can_put_in()) 
      {
	write("You can't do that!\n");
	return 1;
      }

    if(item=="all")
      {
	if(container_o->query_can_get_out())
	       get_all(container_o,lower_case(container));
	  else write("You can't take them.\n");

       return 1;
      }

    if(sscanf(item,"all %s",item_o)==1)
      {
	  if(container_o->query_can_get_out())
		  get_all(container_o,lower_case(container),lower_case(item_o));
	    else write("You can't take them.\n");

	  return 1;
      }

    item_o = present(item, container_o);

    if (!item_o)
      {
	write("There is no " + item + " in the " + container + ".\n");
	return 1;
      }

    if (!item_o->query_can_pick_up(item)) 
      {
	write("You can not take the " + item + " from " + container + ".\n");
	return 1;
      }

    w = item_o->query_weight();

    if (!add_weight(w)) 
      {
         write("You can not carry more.\n");
	 return 1;
      }

    container_o->add_weight(-w);
    move_object(item_o, me);

    write("Ok.\n");
    say(cap_name + " takes the " + item + " from " + container + ".\n");

    return 1;
}

pick_item(obj) 
{
    object ob;
    int i;

    obj = lower_case(obj);
    if (environment(this_player())->id(obj))
	  {
		write("You can't take that.\n");
		return 1;
      }
    ob = present(obj, environment(this_player()));
    if (!ob)
	  {
		write("That is not here.\n");
		return 1;
      }
    if (ghost) 
	  {
		write("You fail.\n");
		return 1;
      }
    if (environment(ob) == me) 
	  {
		write("You already have it!\n");
		return 1;
      }
    if (!ob->query_can_pick_up() || !environment(ob)->query_can_get_out()) 
	  {
		write("You can not take that!\n");
		return 1;
      }
    i =ob->query_weight();
    if (add_weight(i)) 
	  {
		move_object(ob, me);
		say(cap_name + " takes the " + obj + ".\n");
		write("Ok.\n");
		return 1;
      }
    write("You can't carry that much.\n");
    return 1;
}

drop_thing(obj) 
{
    string tmp;
    string tmp2;
    int i;

    if (!obj) 
     {
	write("What ?\n");
	return 1;
     }

    if (obj == "all") 
     {
	drop_all(1);
	return 1;
     }

    if(sscanf(obj,"all %s",tmp)==1)
     {
	 drop_all(1,tmp);
	 return 1;
     }

    if (sscanf(obj, "%s in %s", tmp, tmp2) == 2) 
     {
	put(obj);
	return 1;
     }

    tmp = obj;

    obj = present(lower_case(obj), this_player());

    if (!obj)
     {
	write("That is not here.\n");
	return 1;
     }

    if (drop_one_item(obj)) 
     {
	write("Ok.\n");
	say(cap_name + " drops the " + tmp + ".\n");
     }

    return 1;
}

shout_to_all(str) 
{
 string list;
 int i;

    if (spell_points[0] < 0) 
	  {
		 write("You are low on power.\n");
		 return 1;
      }
    str = valid_input(str);
    if (!str) 
	  {
		write("Shout what ?\n");
		return 1;
      }
    if (ghost) 
	  {
		write("You fail.\n");
		return 1;
      }
    adj_spell_points(-20);
    shout(cap_name+" shouts: "+str+"\n");
    if(talk) write("You shout: "+str+"\n");
	  else write("Ok.\n");
    return 1;
}

inventory() 
{
    string inv;
    int i;

    if (!use_light && test_dark()) return 1;
    inv = all_inventory(me);
    for(i=0;i<sizeof(inv);i++) 
	  {
		string str;

        if(!inv[i]) continue;
		str = inv[i]->short();
	 	if (str) write(capitalize(str) + ".\n");
      }
    return 1;
}
 
examine(str) { return look("at " + str); }

glance(str) { return look(str,1); }
 
look(str,mode) 
{
 return "r1/closed/mcp"->look(str,mode,0,0,"r1/closed/mcp"->find_light(this_object()));
}

static rectify_path(path)
{
    return "closed/mcp"->rectify_path(path);
}

tell_whisper(str)
{
    object tell_ob;
    string mode,who,msg,tmp;

    mode=query_verb();

    if(!str || sscanf(str,"%s %s",who,msg)!=2)
      {
        write(mode+" who msg\n");
        return 1;
      }


    who=lower_case(who);
 
    if(mode=="tell") 
	{
	   tell_ob = find_player(who);
	   if(!tell_ob) tell_ob=find_living(who);
	}
      else tell_ob=present(who);

    while(!tell_ob && sscanf(msg,"%s %s",tmp,msg))
     {
        who+=" "+lower_case(tmp);
        if(mode=="tell") 
           {
               tell_ob = find_player(who);
               if(!tell_ob) tell_ob=find_living(who);
           }
	 else tell_ob=present(who);
     }

    if (!tell_ob) 
      {
	write("No one with that name.\n");
	return 1;
      }
   if(mode=="tell")
    if(tell_ob->query_block_tells() && levels[0]<tell_ob->query_level())
     {
       write("No player with that name.\n");
       return 1;
     }

    msg = valid_input(msg);

    if(!msg) 
      {
        write("Invalid message.\n");
        return 1;
      }

    if(!strchr("?.!",msg[strlen(msg)-1])) msg+=".";

    tell_object(tell_ob, cap_name + " "+mode+"s you: " + msg + "\n");
        if(talk)
		write("You "+mode+" "+who+": "+msg+"\n");
	else
		write("Ok.\n");
    return 1;
}
 
/*
 * This routine is called from other routines to drop one specified object.
 * We return true if success.
 */
 
emote(str)
{
    if (!str || !(str=valid_input(str)))
      {
       write("emote what?\n");
       return 1;
      }

    if(!strchr("?.!",str[strlen(str)-1])) str+=".";

    str=cap_name+" "+str;
    write("You emote: "+str+"\n");
    say(":"+str+"\n");
    return 1;
}

drop_one_item(ob)
{
    int w;
 
    if(!ob->query_can_drop() || !environment()->query_can_put_in()) return 0;
    w = call_other(ob, "query_weight", 0);
    if(w) add_weight(-w);
    move_object(ob, environment(me));
    ob->drop();
    return 1;
}
 
drop_all(verbose,items)
{
    object inv;
    int i;

    if(!environment()->query_can_put_in())
     {
       if(verbose) write("Sorry, You cannot drop your stuff here!\n");
       return;
     }

    if(items && !present(items,me))
      {
	 if(items[strlen(items)-1]=='s')
	   {
	      items=extract(items,0,strlen(items)-2);

	      if(!present(items,me))
	        {
		    write("You are not carrying that.\n");
		    return 1;
		}
	    }
	  else
	    {      
		write("You are not carrying that.\n");
		return 1;
	    }
      }

    inv = all_inventory(me);

    for(i=0;i<sizeof(inv);i++) 
     {
	string out;

        if(!inv[i] || (items && !inv[i]->id(items))) continue;

	if (drop_one_item(inv[i]) && verbose) 
          {
	    say(cap_name + " drops " + inv[i]->short()+".\n");
	    tell_object(me, "drop: " + inv[i]->short()+".\n");
	  }
     }
}
 
bug(str)
{
    if (!str) 
      {
	write("Give an argument.\n");
	return 1;
      }

    log_file("BUGS", "\n");
    log_file("BUGS", cap_name + " (" +
	     file_name(environment(this_object())) + "):\n");
    log_file("BUGS", str + "\n");

    smart_report("Bug " + cap_name + "\n" + str);

    write("Ok.\n");
    return 1;
}
 
idea(str)
{
    if (!str) {
	write("Give an argument.\n");
	return 1;
    }
    log_file("IDEA", cap_name + ":\n");
    log_file("IDEA", str + "\n");
    smart_report("Idea " + cap_name + "\n" + str);
    write("Ok.\n");
    return 1;
}
 
converse()
{
    write("Give '/s' to stop.\n");
    write("]");
    input(this_object(),"converse_more");
    return 1;
}
 
static converse_more(str)
{
    string cmd;
    if (str == "/s") {
	write("Ok.\n");
	return;
    }
    if (str && str[0] == '!') {
	sscanf(str, "!%s", cmd);
	command(cmd);
    } else if (str != "") {
        str = valid_input(str);
	say(cap_name + " says: " + str + "\n");
    }
    write("]");
    input(this_object(),"converse_more");
}
 
toggle_whimpy(str)
{
	if(!str && whimpy) whimpy = 0;
	else if(!str && !whimpy) whimpy = 5;
	else
		if(sscanf(str, "%d", whimpy) != 1) {
			if(sscanf(str, "%s", whimpy_dir) != 1) return;
			write("You set emergency command to '"+whimpy_dir+"'.\n");
			return 1;
		}
	else if(whimpy >5 || whimpy < 0) whimpy = 5;
    if (whimpy)
	write("Wimpy mode set to "+whimpy+"0%.\n");
    else
        write("Brave mode.\n");
    return 1;
}
 
toggle_brief()
{
    brief = !brief;
    if (brief)
        write("Brief mode.\n");
    else
        write("Verbose mode.\n");
    return 1;
}
 
add_intoxination(i) {
    if(i < 0)
    {
	if (-i > intoxicated / 10)
		i = -intoxicated / 10;
    }
    intoxicated += i;
    if(intoxicated < 0)
	intoxicated = 0;
}
 
add_stuffed(i)
{
    if(i < 0)
    {
	if (-i > stuffed / 10)
		i = -stuffed / 10;
    }
    stuffed += i;
    if (stuffed < 0)
	stuffed = 0;
}
 
add_soaked(i)
{
    if(i < 0)
    {
	if (-i > soaked / 10)
		i = -soaked / 10;
    }
    soaked += i;
    if (soaked < 0)
	soaked = 0;
}
 
second_life() 
{
object death_mark;

    if(name=="guest") return 0;

    make_scar();
    ghost = 1;
    msgin = "drifts around.";
    msgout = "blows";
    headache = 0;
    intoxicated = 0;
    stuffed = 0;
    soaked = 0;

    save_me(0);

#ifdef LOG_KILLS

      log_file("KILLS","\n"+ name + "(" + levels[0] + "/" + levels[1] + 
	       "/" + levels[2] + ")" + " killed by " +
  	       (attacker?attacker->short():"unknown") + "(" +
	       (attacker?attacker->query_real_name():"unknown") +
	       "), creator: " + (attacker?creator(attacker):"unknown") + "\n");

     log_file("KILLS","on : "+ ctime(time()) +" in " + 
	      (environment()?file_name(environment()):"unknown") + "\n");

#endif

    if(attacker)
	tell_object(this_object(),"You recieve a fatal blow from the "+attacker->query_name()+".\n");
		tell_object(this_object(), "\nYou die.\nYou have a strange feeling.\n" +
		"You can see your own dead body from above.\n\n");

    return 1;
}
 
remove_ghost() {
    if (!ghost) return 0;

    tell_object(this_object(),"You feel a very strong force.\n"+
    "You are sucked away...\n"+
    "You reappear in a more solid form.\n");
    say("Some mist disappears.\n"+ cap_name + " appears in a solid form.\n");
    ghost = 0;
    dead = 0;
    msgin = "arrives.";
    msgout = "leaves";
    save_me(2);
    return 1;
}
 
give_object(str)
{
    string item, dest,crd_str;
    object item_ob, dest_ob,env;
    int w;
    int crd;
 
    if (!str) return 0;

    if (!use_light && test_dark()) return 1;

    if (sscanf(str, "%d credits to %s", crd, dest) == 2) item = 0;
        else if(sscanf(str, "credits to %s", dest)==1) crd=credits;
           else if ( sscanf(str, "1 credit to %s", dest) == 1 ||
                     sscanf(str, "one credit to %s", dest) == 1 ||
	             sscanf(str, "a credit to %s", dest)==1) credits = 1;
	      else if (sscanf(str, "%s to %s", item, dest) != 2)
	 	     {
			write("Give what to whom ?\n");
			return 1;
    		     }

    if (item) 
      {
	item = lower_case(item);
	item_ob = present(item, this_player());
	if (!item_ob) 
          {
	    write("There are no " + item + " here.\n");
	    return 1;
	  }

	env=environment(item_ob);

        if(env)
          {
	    if(!env->query_can_get_out())
	      {
		write("You are unable to do that.\n");
		return 1;
	      }

	    if (env == this_object())
             {
             if(!item_ob->query_can_drop())
	       {
	         write("You are unable to do that.\n");
	         return 1;
	       }
             }
	    else
              {
	        if (!item_ob->query_can_pick_up())
		  {
		     write("You can't get that !\n");
		     return 1;
	          }
	      }
           }
      }

    dest_ob = present(lower_case(dest), environment(this_player()));

    dest=capitalize(dest);

    if (!dest_ob) 
      {
	write("There is no " + dest + " here.\n");
	return 1;
      }

    if (!living(dest_ob)) 
      {
	write("You can't do that.\n");
	return 1;
      }

    if (!item)
      {
	if (crd <= 0) return 0;

	if (credits < crd) 
	  {
	    write("You don't have that many credits.\n");
	    return 1;
	  }

	credits -= crd;

	save_me(2);

	dest_ob->add_money(crd);

        say(cap_name+" gives "+dest+" some credits.\n",dest_ob);

	crd_str=crd==1?"a credit":(crd +" credits");

	tell_object(dest_ob, cap_name + " gives you " + crd_str + ".\n");

	write("You give "+crd_str+" to "+dest+".\n");
	return 1;
    }

    w = item_ob->query_weight();

    if (!dest_ob->add_weight(w)) 
      {
	write(dest + " can't carry any more.\n");
	return 1;
      }

    add_weight(-w);

    move_object(item_ob, dest_ob);

    say(cap_name+" gives "+item+" to "+dest+".\n",dest_ob);
    tell_object(dest_ob,cap_name+" gives you a "+item+".\n");
    write("You give the "+item+" to "+dest+".\n");

    item_ob->drop();

    return 1;
}
 
/*
 * Get all items here.
 */

get_all(from,container,items)
{
    object ob;
    int i,fail;
 
    if(items && !present(items,from))
	  {
		if(items[strlen(items)-1]=='s')
		   {
			  items=extract(items,0,strlen(items)-2);
			  if(!present(items,from))
			    {
				  if(items[strlen(items)-1]=='e')
				    {
					  items=extract(items,0,strlen(items)-2);
					  if(!present(items,from)) fail=1;
					}
				  else fail=1;
				}
		    }
		else fail=1;
	  if(fail)	
		 {
		   write("There is no such '"+items+"' to be found here.\n");
		   return 1;
		 }
	 }
    ob = all_inventory(from);
	if(!ob)
	  {
		write("There is nothing in the "+from->short()+" to get.\n");
	    return 1;
	  }
    for(i=0;i<sizeof(ob);i++) {
	if (ob[i]->short() && ob[i]->query_can_pick_up()) {
	    string item;
	    int w;
	    if(!ob[i] || (items && !ob[i]->id(items))) continue;
	    item=ob[i]->short();
	    w = ob[i]->query_weight();
	    if (add_weight(w)) {
		write(ob[i]->short() + ": Ok.\n");
		move_object(ob[i], this_object());
                if(item[0]=='a' || item[0]=='A') item=extract(item,2,strlen(item));
                if(!container)
		   say(cap_name + " takes a " + item + ".\n");
  		 else say(cap_name+" take a "+item+" from "+container+".\n");
                 if(container) from->add_weight(-w);
		 ob[i]->drop();
	    } else {
		write(item + ": Too heavy.\n");
	    }
	}
    }
}
 
valid_read(str) { return "closed/mcp"->valid_read(str); }

valid_write(str) { return "closed/mcp"->valid_write(str); }

save_me(value_items)
{
object ob;
string lev;

    if(no_save) {MCP->dest_all_inv(this_object());return; } 

    if(environment())
      {
          saved_where=environment()->player_save_location();

	  if(!saved_where) saved_where=file_name(environment());
      }

    if(!stringp(saved_where) || strchr(saved_where,'#'))
		 saved_where=ENTRY_POINT;

         if(value_items==1) dest_on_save=1;
    if(value_items!=2) save_inv();

    save_object(SAVE_DIR+itoc(user_name[0])+"/" + user_name+"."+player_num);

    if(!query_ip_number(this_object())) return;

    ob=clone_object("r1/closed/update_link");

    if(wiz(this_object())) lev=ntoa(wiz(this_object()));
     else
      {
        lev=ntoa(levels[0]);
        if(levels[1]) lev+="/"+levels[1];
        if(levels[2]) lev+="/"+levels[2];
      }

    ob->set_player_stats(user_name,player_num,dead,lev);
    destruct(ob);
}

smart_report(str) 
{
    string who;
    string current_room;
 
    current_room = file_name(environment(this_object()));
    if (sscanf(current_room, "r1/w/%s/", who) != 1)
	return;
    log_file(who + ".rep", current_room + " " + str + "\n");
}
 
query_quests(str) 
{
    int i;
 
	if(!pointerp(quests)) return 0;
    if (!str) return quests;
	for(i=0;i<sizeof(quests);i++)
		if(quests[i]==str) return 1;
}
 
set_quest(q) 
{
    if (!q) return;
    if (query_quests(q)) return 0;
#ifdef LOG_SET_QUEST
    if (previous_object())
	  {
		log_file("QUESTS", name + ": " + q + " from " +
		 		file_name(previous_object()) + "\n");
		if (this_player() && this_player() != this_object() &&
	  		query_ip_number(this_player()))
	    	  log_file("QUESTS", "Done by " + this_player()->query_real_name() + "\n");
      }
#endif /* LOG_SET_QUEST */
    if (!quests) quests=({q});
    else quests+=({q});
    return 1;
}

query_real_name() { return name; }

query_user_name() { return user_name; }

query_player_num() { return player_num; }

who(str)
{
    object list;
    int i;

    if(!str) 
	  {
    	list = users();
    	for(i=0;i<sizeof(list);i++) 
		  {
			string sh;

        	if(list[i] && list[i]->query_real_name()!="logon")
         	  {
	  			 sh = list[i]->short();
	   			 if(list[i] && !list[i]->short() && list[i]->query_wiz_level()<ADMIN)
	    		 write("("+capitalize(list[i]->query_real_name())+")\n");
	   			 else if (sh) write(sh + "\n");
              }
    	  }
    	return 1;
      }
	if(str=="system") {"closed/mcp"->show_who(0);return 1;}
}
 
more(path) {
int lines;
   if(this_player()!=this_object()) return 0;
    if (!path) return 0;
	path=rectify_path(path);
	if(!path) return 1;
    if(file_size(path)==-2)
     {
       write("You cannot more a directory.\n");
       return 1;
     }
    more_file = path;
    more_line = 1;
    write("\n");
    if(!(lines=cat(more_file, more_line, chunk))) {
	write("No such file\n");
	return 1;
    }
    input(this_object(),"even_more");
    write("\nMore: line " + (lines) + " (q/u/r/<return>) ");
    return 1;
}
 
static even_more(str) 
{
int lines;

    write("\n");
    if (str == "q") 
      {
	write("Ok.\n");
	return;
       }
     else if (str == "u") 
            {
	      more_line -= chunk;
	      if (more_line < 1) more_line = 1;
            }
          else if(str=="r") {}
    else more_line+=chunk;
    if(!(lines=cat(more_file, more_line, chunk))) {
	more_file = 0;
        write("\n:EOF\n");
	return;
    }
    write("\nMore: line " + (more_line + lines) + " (q/u/r/<return>)");
    input(this_object(),"even_more");
}

set_descript(str)
{
  str = valid_input(str);
  if(str && strlen(str) > 80) str = extract(str, 0, 79);
  descript=str;
  write("Ok.\n");
  return 1;
}
 
remove_scar()
{
  if(!scar) return;
  scar &= ~(1 << random(MAX_SCAR) ); 
}
 
make_scar() {
    if (levels[0] < 10) return;
    scar |= 1 << random(MAX_SCAR);
}
 
show_scar() {
    int i, j, first, old_value;
    string scar_desc,msg;
 
    scar_desc = ({ "left leg", "right leg", "nose", "left arm", "right arm",
		   "left hand", "right hand", "forhead", "left cheek",
		   "right cheek" });
    j = 1;
    first = 1;
    msg="";
    old_value = scar;
    while(i < MAX_SCAR) {
	if (scar & j) {
	    old_value &= ~j;
	    if (first) {
		msg=cap_name + " has a scar on " + query_gender_string(3) +
		      " " + scar_desc[i];
		first = 0;
	    } else if (old_value) {
		msg+=", " + query_gender_string(3) + " " + scar_desc[i];
	    } else {
		msg+=" and " + query_gender_string(3) + " " + scar_desc[i];
	    }
	}
	j *= 2;
	i += 1;
    }
    if (!first)
	msg+=".\n";

   return msg;
}
 
add_standard_commands() {
    add_action("church_clock","clock");
    add_action("ghost_escape","escape");
    add_action("toggle_talk", "talk");
    add_action("set_descript","describe");
    add_action("give_object","give");
    add_action("score",({"score","stats"}));
    add_action("list_skills","list");
    add_action("save_character","save");
    add_action("quit",({"&","logout","quit"}),2);
    add_action("communicate","say");
    add_action("emote","emote");
    add_action("emote",":",1);
    add_action("communicate",({"'",";"}), 1);
    add_action("shout_to_all","shout");
    add_action("put","put");
    add_action("pick_up",({"get","take"}));
    add_action("drop_thing","drop");
    add_action("inventory",({"inventory","i"}));
    add_action("look","look");
    add_action("glance","glance");
    add_action("examine","examine");
    add_action("examine", "exa", 2);
    add_action("ext_help",({"help","help2"}));
    add_action("tell_whisper",({"tell","whisper"}));
    add_action("bug","bug",2);
    add_action("converse","converse",2);
    add_action("toggle_brief","brief",2);
    add_action("toggle_whimpy","wimpy",2);
    add_action("who", "who",2);
    add_action("clock",({"date","time"}));
    add_action("short_mv",({"e","w","n","s","u","d","sw","se","ne","nw"}),2);
}
 
short_mv()
{
  if(query_verb()=="sw") command("southwest");
   else if(query_verb()=="se") command("southeast");
    else if(query_verb()=="nw") command("northwest");
      else if(query_verb()=="ne") command("northeast");
	else if(query_verb()=="w") command("west");
	  else if(query_verb()=="e") command("east");
	    else if(query_verb()=="n") command("north");
	      else if(query_verb()=="s") command("south");
		else if(query_verb()=="u") command("up");
		  else if(query_verb()=="d") command("down");
 return 1;
}

ghost_escape()
{
  int cost;
 
  if(!ghost)
   {
     write("You are not a ghost!!\n");
     return 1;
   }
  if(environment() && file_name(environment())==ENTRY_POINT)
   {
     write("You are already here!!\n");
     return 1;
   }
  if(environment() && file_name(environment())=="r1/w/man-ing/prison/prison")
    {
	write("You cannot escape from prison\n");
	return 1;
    }

  if(levels[0]==1) cost=200;
   else cost=1000*levels[0];
  write("This will cost you an extra "+cost+" experience to be returned to the start.\nAre you sure? (y/n) ");
  input(this_object(),"question_ghost");
  return 1;
}
 
question_ghost(yesno)
{
 
  if(lower_case(yesno)[0]=='y')
   {
     write("Very well then..  So be it!!\n");
     if(levels[0]==1) exp[0]-=200;
       else exp[0]-=1000*levels[0];
     if(exp[0]<0) exp[0]=0;
     MCP->move_player(this_object(),"X",ENTRY_POINT,0);
     return;
   }
 write("A wise man never waists.\n");
} 
 
finnal_death()
{
  log_file("FINNAL",cap_name+" "+ctime(time())+".\n");
  levels=({0,0,0});
  exp=({0,0,0});
  classes=({0,0,0});
  set_alignment("neutral");
  set_al(0);
  heal_self(100);
  if(query_gender()) set_title("the peasant");
	   else set_title("the utter creature");
  return 1;
}

ext_help(str) 
{
	int lev;
    if(!str) 
	 {
		if(query_verb()=="help2") cat("/r1/doc/help2");
			else cat("/r1/doc/help");
		return 1;
     }
    if(sscanf(str, "level %d", lev) == 1) {
        if(lev < 1 || lev > 413) {
            write("That is not a valid level.\n");
            return 1;
        }
        write("\n");
        write("Level      : "+lev+"\n");
        write("Experience : "+find_exp(lev)+"\n");
        write("Titles -\n");
        write("Male       : "+find_title(lev,1)+"\n");
        write("Female     : "+find_title(lev,2)+"\n");
        write("Creature   : "+find_title(lev,3)+"\n");
        write("\n");
        return 1;
    }
    if(str=="advance") 
     {
		int ex;

		lev=levels[0]+1;
		ex=find_exp(lev)-exp[0];
		if(ex<0) ex=0;
	    write("\n"+ex+" experience points required to advance to level "+lev+".\n\n");
        return 1;
    }
    if(sscanf(str, "quest %d", lev) == 1) {
        this_player()->cat_file("/r1/log/quest/quest"+lev);
        return 1;
    }
    if (str) return cat("/r1/doc/playerhelp/" + str);
}
 
clock()
{
int hour;
string am_pm;
int min,sec;
string tm, time_str,time2;
 
  tm=ctime(time());
  time_str=allocate(5);
  time_str[0]=extract(tm,0,2);
  time_str[1]=extract(tm,4,6);
  time_str[2]=extract(tm,8,9);
  time_str[3]=extract(tm,11,18);
  time_str[4]=extract(tm,20,23);

  time2=explode(time_str[3],':');

  hour=atoi(time2[0]);

  if(hour>12) 
   {
     hour-=12;
     am_pm="pm";
   }
   else am_pm="am";

  if(hour==0) hour=12;

  if(query_verb()=="time")
     write("The time is: "+hour+":"+time2[1]+":"+time2[2]+am_pm+".\n");

  if(query_verb()=="date")
     write("The Date is: "+time_str[0]+"  "+time_str[1]+" "+time_str[2]+", "+time_str[4]+"\n");

   return 1;
}
 
church_clock() 
{
   call_other("closed/clock", "clock");
   return 1;
}
 
toggle_talk(str) 
{
	if(str) return;
	if(talk) {talk = 0;write("No talk echo.\n");return 1;}
	talk = 1;write("Talk echo.\n");return 1;
}
 
valid_input(str)
{
 int count;
 string output;output = "";
 if(str) 
   for(count=0;count<strlen(str);count++)
    if(str[count]<127 && str[count]>31) output+=extract(str,count,count);
 return output;
}
 

save_inv()
{ 
   string nam;

   nam=SAVE_DIR+itoc(user_name[0])+"/"+user_name+"."+player_num+".s";

   if(file_size(nam)==-1) mkdir(nam);

   save_inventory(this_object(),nam);

   if(dest_on_save) {no_save=1;MCP->dest_all_inv(this_object());}
}

restore_inv() 
{
  if(user_name=="guest") return;
  write("Restoring inventory, Please wait...\n");
  if(restore_inventory(this_object(),SAVE_DIR+itoc(user_name[0])+"/"+user_name+"."+player_num+".s"))
    write("Done.\n\n");
}

return_to_p_menu(dont_leave)
{
   string tmp;
   int i;

   CONTROL->del_players(this_object());

       set_heart_beat(0);
       destruct(me);

   return 1;
}
	
setmout(m) { msgout = m; return 1; }
setmin(m) { msgin = m ; return 1; }
setmmout(m) { mmsgout = m ; return 1; }
setmmin(m) { mmsgin = m ; return 1; }

set_user_name(nam,num) 
{
  if(!this_player() || strncmp(file_name(this_player()),"r1/closed/",10))
     return; 

  user_name=nam;
  player_num=num;
}

query_block_shouts() { return block_sh;}
query_block_tells() { return block_tells;}
query_use_light() { return use_light; }
query_title() { return title; }
query_msgin() { return msgin; }
query_msgout() { return msgout; }
query_mmsgin() { return mmsgin; }
query_mmsgout() { return mmsgout; }
query_talk() {return talk;}
query_descript() { return descript; }
query_intoxination() { return intoxicated; }
query_stuffed() { return stuffed; }
query_soaked() { return soaked; }
query_brief() { return brief; }

query_can_get_out()
{
  if(this_player()==this_object()) return 1;
}

wiz_dest()
{
  destruct(this_object());
}

query_name() { return cap_name;}
query_num_hands() { return 2; }
query_can_talk() { return 1; }
