#ifndef M_XENIX
#include <stdlib.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <errno.h>
#include "lint.h"
#include "lnode.h"
#include "object.h"
#include "lint2.h"
#include "lang.h"
#include "config.h"
#include "sent.h"
#include "input_to.h"
#include "realms.h"
#include "wiz_list.h"
#include "error.h"
#include "o_hash.h"
#include "s_hash.h"
#include "p_hash.h"
#include "var_hash.h"


extern REALMS *sys_realm;

extern char		*string_copy PROT((char *)),
			*make_new_name PROT((char *)),
			*check_file_name PROT((char *,int,int)),
			*make_shared_string PROT((char *));

extern int		file_size PROT((char *)),
			stat(),
			link(),
			unlink(),
			fstat();

extern void		set_reset PROT((OBJECT *)),
			assign_svalue(),
			write_file PROT((char *,char *,int)),
			add_message(),
			load_ob_from_swap(),
			remove_reset PROT((struct link_list *));

extern OBJECT		*lookup_object_hash PROT((char *));

extern VALUE		*allocate_array PROT((unsigned short));

void			add_light(),
			pre_load_pointers(),
			clear_object PROT((OBJECT *)),
			remove_object PROT((OBJECT *,int)),
			remove_swap_file();

static void		free_object PROT((OBJECT *));

char			*save_array();

VALUE			*all_inventory();

OBJECT			*load_object();

int			_check_object PROT((OBJECT *)),
			check_object PROT((OBJECT *));

extern unsigned char	save_flag;

struct inherit_list	*new_inherit_list=0;

OBJECT			*obj_list_destruct=0,
			*obj_free_list=0;

char			*inherit_file,
			*compile_file;

int			num_parse_error,
			num_ob_in_free_list,
			tot_alloc_ob_bytes,
			tot_alloc_svalue,
			tot_alloc_object;

void	load_mcp();

extern struct object_status *ob_status[];

struct MCP mcp;

VALUE *all_inventory(ob)
     register OBJECT *ob;
{
  register OBJECT *cur;
  register VALUE *v;
  unsigned short cnt;
  int res;

  for (cnt=0,cur=ob->ref_ob[1]; cur; cur = cur->ref_ob[2]) cnt++;

  if (!cnt) return &const0;

  v =allocate_array(cnt);

  cur=ob->ref_ob[1];

  for(cur=ob->ref_ob[1],res=0;res<cnt;res++) 
   {
     v->u.vec->item[res].type=T_OBJECT;
     v->u.vec->item[res].u.ob = cur;

     cur->num_ref++;
     cur=cur->ref_ob[2];
   }
  return v;
}


/*
 * Move or destruct one object.
 */
void move_or_destruct(what, to)
    register OBJECT *what, *to;
{
    int res;
    register OBJECT *super=to->ref_ob[0];


	if(check_object(to) && check_object(what) && what->fun_p[0])
	  {
		jmp_buf erc;
		struct jmp_globals jmp;
		VALUE *arg=0;
	     
		set_jump_state(erc,&jmp);
		if(!setjmp(error_recovery_context))
    			arg=apply(what->fun_p[0],0,what,&const1,0);
		else {arg=0;clear_jump_state(&jmp);}
		reset_jump_state(erc);

	        if(!numchk(arg,T_INT) && arg->u.n_int)
	          {
	 	    if(what->fun_p[1])
                     {
		      set_jump_state(erc,&jmp);
		      if(!setjmp(error_recovery_context))
    			    (void)apply(what->fun_p[1],0,what,&const1,0);
		         else clear_jump_state(&jmp);
		      reset_jump_state(erc);
		     }	
		    move_object(what, to,0,0);
                  }
		 else destruct_object(what,0);
	  }
   	else if(check_object(what)) destruct_object(what,0);
}

/*
 * move an object.
 * The object has to be taken from one inventory list and added to another.
 * The main work is to update all command definitions, depending on what is
 * living or not. Note that all objects in the same inventory are affected.
 */
void finish_move2(item)
    register OBJECT *item;
{
  	item->num_ref--;
	if(item->ref_ob[5]) 
	  {
		 item->ref_ob[5]->num_ref--;
		 item->ref_ob[5]=0;
	  }
	item->flags&=~MOVE2;
}

void move_object(item, dest,loc_flag,dest_flag)
    register OBJECT *item, *dest;
    int loc_flag,dest_flag;
{
    VALUE v;
    register OBJECT *pp, *ob, *next_ob,*env,*save_cmd = command_giver;
	jmp_buf erc;
	struct jmp_globals jmp;

    /* Recursive moves are not allowed. */
    for (ob = dest; ob; ob = ob->ref_ob[0])
		if (ob == item) return;
	if(item->flags & MOVE2 && dest==item->ref_ob[5]) return;
	if(item->ref_ob[5]) item->ref_ob[5]->num_ref--;
	item->ref_ob[5]=dest;
	if(dest) dest->num_ref++;
	if(item->flags & MOVE) return;
	env=item->ref_ob[0];
	item->num_ref++; /* this makes sure we don't get free'd until we are done */
	item->flags|=MOVE;
    if (item->not_touched && item->links[0]) 
	  {
		item->not_touched=0;
		set_jump_state(erc,&jmp);
		if(!setjmp(error_recovery_context))
			(void)apply(item->reset,0, item, &const1,0);
			else clear_jump_state(&jmp);
		reset_jump_state(erc);
		command_giver=save_cmd;
		if (!check_object(item) || env!=item->ref_ob[0]) 
				{item->num_ref--;return; }
      }
            if (check_object(item->ref_ob[0]) && item->ref_ob[0]->fun_p[5]) 
              {
	    	VALUE *v2;

		v.type=T_OBJECT;
	    	v.u.ob = item;		/* No need to increment ref count */
	    	command_giver = item;

		set_jump_state(erc,&jmp);
	        if(setjmp(error_recovery_context))
			clear_jump_state(&jmp);
        	else
       	          {
	    		v2=apply(item->ref_ob[0]->fun_p[5],0, item->ref_ob[0], &v,0);
	    		if(!numchk(v2,T_INT) && v2->u.n_int==1 && !dest_flag) 
			  {
			    reset_jump_state(erc);
			    item->num_ref--;
			    command_giver=save_cmd;
			    return;
			  }
                  }
		reset_jump_state(erc);
		command_giver=save_cmd;

		if(!check_object(item) || env!=item->ref_ob[0])
		 { item->num_ref--;return;}
              }

	if(item->ref_ob[0])
          {
            if(item->ref_ob[0]->flags & COMMANDS) 
	 	 (void)remove_sent(item, item->ref_ob[0],0);

	    if(item->flags & COMMANDS)
		 (void)remove_sent(item->ref_ob[0],item,0);

	    /* remove any light we add to the environment */

	    add_light(item->ref_ob[0], - item->total_light);

	    for(pp=item->ref_ob[0]->ref_ob[1];pp;pp=pp->ref_ob[2])
	      {
		if(pp==item) continue;

		if(pp->flags & COMMANDS)
		    (void)remove_sent(item,pp,0);

		if(item->flags & COMMANDS)
	            (void)remove_sent(pp,item,0);
	      }

            if(item->ref_ob[0]->ref_ob[1]==item) 
		item->ref_ob[0]->ref_ob[1]=item->ref_ob[2];
          }
    
    env=item->ref_ob[0]=0;
    remove_object(item,2);
	item->flags&=~MOVE;
    dest=item->ref_ob[5];
    if(!dest)  {item->num_ref--;return;} /* If we have no place to go, stop. */
	item->flags|=MOVE2;
    if (dest->not_touched && dest->links[0]) 
	  {
		dest->not_touched=0;
		set_jump_state(erc,&jmp);
		if(!setjmp(error_recovery_context))
			(void)apply(dest->reset,0, dest, &const1,0);
		 else clear_jump_state(&jmp);
		reset_jump_state(erc);
		command_giver=save_cmd;
		if (!check_object(dest) || !check_object(item) || item->ref_ob[0])
			{finish_move2(item); return;}
      }

/* before moving the object into the room reset any objects in need of
   a reset */

    for(ob=dest->ref_ob[1];ob;ob=next_ob) {
	next_ob=ob->ref_ob[2];
	if(ob->not_touched && ob->links[0])
      {
	    ob->not_touched=0;
		set_jump_state(erc,&jmp);
		if(!setjmp(error_recovery_context))
	    	(void)apply(ob->reset,0,ob,&const1,0);
		  else clear_jump_state(&jmp);
		reset_jump_state(erc);
		command_giver=save_cmd;
		if(!check_object(item) || item->ref_ob[0])
		  {finish_move2(item);return;}
	  }
	}

    if(!loc_flag || !dest->ref_ob[1])
	  {
		if(dest->ref_ob[1]) 
                  {
		    dest->ref_ob[1]->ref_ob[3]=item;
    		    item->ref_ob[2]= dest->ref_ob[1];
		  }
    	 	dest->ref_ob[1] = item;
	  }
	 else
	  {
		OBJECT *last;

		for(last=dest->ref_ob[1];last;last=last->ref_ob[2])
			 if(!last->ref_ob[2]) break;
		if(!last) fatal("Bad inventory tree.\n");
		last->ref_ob[2]=item;
		item->ref_ob[3]=last;
	  }
    item->ref_ob[0] = dest;
    env=dest;

    /* must add light before we call init's becuse we might reduce the light
       in the inits, and if we did it after the init's we'd remove too much
       light.  and vis versa
    */

    add_light(dest, item->total_light);

    /*
     * Setup the new commands. The order is very important, as commands
     * in the room should override commands defined by the room.
     */

    if (item->flags & COMMANDS && dest->fun_p[4]) {
	    command_giver = item;
		v.type=T_OBJECT;
        v.u.ob=item;
		set_jump_state(erc,&jmp);
		if(!setjmp(error_recovery_context))
		    (void)apply(dest->fun_p[4],0, dest, &v,0);
			else clear_jump_state(&jmp);
		reset_jump_state(erc);
		command_giver=save_cmd;
	    if (!check_object(item) || env!=item->ref_ob[0]) 
				{finish_move2(item); return;}
	  }
    /*
     * Run init of the item once for every present item that has commands
	 * enablesd, and for the environment if it is enabled also.
     */
     
   	for (ob = dest->ref_ob[1]; ob;ob=next_ob) 
	  {
		next_ob=ob->ref_ob[2];
		if (ob == item) continue;
		if (ob->flags & COMMANDS && item->fun_p[4]) 
		  {
			v.type=T_OBJECT;
    			v.u.ob=ob;
			command_giver=ob;
			set_jump_state(erc,&jmp);
			if(!setjmp(error_recovery_context))
	    		(void)apply(item->fun_p[4],0, item, &v,0);
				else clear_jump_state(&jmp);
			reset_jump_state(erc);
			command_giver=save_cmd;
			if(!check_object(item) || env!=item->ref_ob[0])
			  {finish_move2(item);return;}
		  }

		if (item->flags & COMMANDS && ob->fun_p[4]) 
		  {
			v.type=T_OBJECT;
		    	v.u.ob=item;
			command_giver=item;
			set_jump_state(erc,&jmp);
			if(!setjmp(error_recovery_context))
		    	(void)apply(ob->fun_p[4],0, ob, &v,0);
			  else clear_jump_state(&jmp);
			reset_jump_state(erc);
			command_giver=save_cmd;
			if(!check_object(item) || env!=item->ref_ob[0])
			  { finish_move2(item);return;}
		  }
      }
    if (dest->flags & COMMANDS && item->fun_p[4]) {
	v.type=T_OBJECT;
	v.u.ob=dest;
	command_giver=dest;
	set_jump_state(erc,&jmp);
	if(!setjmp(error_recovery_context))
		(void)apply(item->fun_p[4],0, item, &v,0);
	  else clear_jump_state(&jmp);
	reset_jump_state(erc);
    }
	finish_move2(item);
    command_giver = save_cmd;
}

/*
 * Every object as a count of number of light sources it contains.
 * Update this.
 */

void add_light(p, n)
    register OBJECT *p;
    int n;
{
    if (!n || !check_object(p)) return;
    p->total_light += (short)n;
    if (check_object(p->ref_ob[0])) add_light(p->ref_ob[0], n);
}

/*
 * Load an object definition from file. If the object wants to inherit
 * from an object that is not loaded, discard all, load the inherited object,
 * and reload again.
 *
 * Save the command_giver, because reset() in the new object might change
 * it.
 */

struct object *load_object(realm,lname)
    register struct realms *realm;
    register char *lname;
{
    register FILE *f;
    extern int total_lines;
    register OBJECT *ob, *save_command_giver = command_giver;
    extern struct lnode_def *current_functions;
    extern char *current_file;
    extern unsigned short variable_count;
    extern int current_line;
    extern unsigned short object_flags;
    struct stat i_st, c_st;
    struct wiz_list *wiz;
    int save_line=current_line;
    int i,name_length;
    char *temp,real_name[255], name[255];
    extern struct lnode_funcall *funcall_list;
    VALUE v,v2,*ret;

    extern int assign_fun_p();

    extern int legal_path(),yyparse();
    extern FILE *pre_compile PROT((char *));
    extern void start_new_file(),update_compile_av();

    if(!lname || lname==NULL) error(realm,"load_object: Null value in object name.\n");

#if 0
    if(mcp.ob)
      {
         v.type=T_STRING;
         v.u.string=lname;

         v2.type=T_STRING;
         v2.u.string=realm->realm_dir;

         ret=apply(mcp.fun_p[2],0,mcp.ob,&v,&v2);

         if(!ret || strchk(ret,1)) error(realm,"load_object: Bad path name.\n");

         temp=ret->u.string;
      }
    else temp=lname;
#else
	temp=lname;
#endif

    /* Remove leading '/' if any. */

    while(temp[0] == '/') temp++;

    name_length=strlen(temp);

    (void)strncpy(name, temp, name_length);

    /* Truncate possible .c in the object name. */

    if (name_length > sizeof name - 4) name_length = sizeof name - 4;

    name[name_length] = '\0';

    if (name[name_length-2] == '.' && name[name_length-1] == 'c') 
      {
	(void)strcpy(real_name,name);

	name[name_length-2] = '\0';
	name_length -= 2;
      }
    else
      {
        (void)strcpy(real_name, name);
        (void)strcat(real_name, ".c");
      }

    compile_file=name;


    /*
     * Check if it's a legal name.
     */

    if (!legal_path(real_name)) error(realm,"load_object: Invalid object name '%s'.\n",real_name);

    if(!check_realm_access(real_name,0))
       error(realm,"load_object: Could not load description for object '%s'.\n",real_name);
 
    ob=find_object2(name,1);

    if(ob)
     {
	if(!check_realm_access(0,ob)) 
		error(realm,"load_object: Coult not load description for object '%s'.\n",name);

        error(sys_realm,"load_object: Object '%s' has already been loaded.\n",name);
     }


    /* check if the c-file exits */

    if (stat(real_name, &c_st) == -1) 
	error(realm,"load_object: File '%s' not found, unable to load object.\n", real_name);

    f=pre_compile(real_name);

    start_new_file(f);

    current_file = string_copy(real_name);	/* This one is freed below */

    (void)yyparse();


    current_line=save_line;

    compile_file=0;

    update_compile_av(total_lines);

    total_lines = 0;

    clear_var_hash();

    (void)pclose(f);

    if (inherit_file == 0 && (num_parse_error > 0 || current_functions == 0)) 
      {
	if (current_functions) 
          {

	    /*
	     * Set the reference count to one.
	     * We don't want to confuse free_prog().
	     */

	    add_prog_ref(current_functions);

	    if (!free_prog(current_functions, 0, 0))
		fatal("load_object: Failed to release program area in object '%s'.\n",lname);
          }

        if(prog_status) free_sub_part((struct lnode *)prog_status,1);

        if(new_inherit_list) free_inherit_list(new_inherit_list,0);

        if (num_parse_error == 0 && current_functions == 0) 
          error(realm,"load_object: No program in object '%s'.\n",lname);

        current_functions=0;
        prog_status=0;
        new_inherit_list=0;
	funcall_list=0;

        error(realm,"load_object: Error while loading object '%s'.\n",lname);
     }

    if (inherit_file) 
      {
	VALUE *tmp =make_string( inherit_file );

	if (current_functions) 
          {
	    /*
	     * Set the reference count to one.
	     * We don't want to confuse free_prog().
	     */

	    add_prog_ref(current_functions);

	    if (!free_prog(current_functions, 0, 0))
		fatal("load_object: Failed to release program area in object '%s'.\n",lname);

	    if(prog_status) free_sub_part((struct lnode *)prog_status,1);

	    if(new_inherit_list) free_inherit_list(new_inherit_list,0);

            new_inherit_list=0;
	    prog_status=0;
	    current_functions = 0;
	    funcall_list=0;
	}

	inherit_file = 0;

	if(!load_object(realm,tmp->u.string))
		error(realm,"load_object: Unable to load inherited object '%s' in object '%s'.\n",tmp->u.string,lname);

	ob = load_object(realm,name);
	return ob;
     }

   ob = get_empty_object(variable_count);
   ob->name = make_shared_string(name);

   if(new_inherit_list) 
     { 
	ob->inherit=new_inherit_list;
        new_inherit_list=0;
     }

   ob->realm=extract_realm(real_name);
   temp=extract_wizard(real_name);

   if(temp)
    {
       ob->wl=add_name(temp,ob->realm->realm_owner);
       free(temp);
    }

   if(!ob->wl) ob->wl=add_name("mud",ob->realm->realm_owner);

   ob->status = prog_status;
   ob->flags=object_flags;
   ob->prog = current_functions;

   add_prog_ref(ob->prog);

   add_o_hash(ob,o_table,hash(ob->name,cf.otable),1);

   if((ob->flags & GLOBAL) && ob->realm!=sys_realm)
      {
	destruct_object(ob,0);

	error(realm,"load_object: Error in object '%s', the 'global' object flag may only be used by control objects.\n",lname);
      } 

    if(!assign_fun_p(ob))
      {
        destruct_object(ob,0);
	error(realm,"load_object: Correct function references and try again.\n");
      }

    pre_load_pointers(ob);


    if(ob->reset)
      {
        VALUE *val=0;
	char *old=current_file;
	jmp_buf erc;
	struct jmp_globals jmp;

	current_file=0;

	set_jump_state(erc,&jmp);

	if(!setjmp(error_recovery_context)) 
            val=apply(ob->reset,0, ob, &const0,0);
	 else {val=0;clear_jump_state(&jmp);}

	reset_jump_state(erc);

	current_file=old;

        if(numchk(val,T_NUMBER) || !val->u.n_int) set_reset(ob);
       }

     command_giver = save_command_giver;

     if (check_object(ob)) 
	{
	   free(current_file);
	   current_file=0;
           return ob;
        }

     error(realm,"load_object: Object '%s' self destructed.\n",lname);
}

/* Find an object. If not loaded, load it ! */

struct object *find_object(str)
    register char *str;
{
    register OBJECT *ob;
    register struct realms *realm;
    VALUE *ob_name,v;

    if(!ob_status[0] || !ob_status[0]->ob) realm=sys_realm;
	else realm=ob_status[0]->ob->realm;

#if 0
    v.type=T_STRING;
    v.u.string=realm->realm_dir;

    ob_name=apply(mcp.fun_p[2],0,mcp.ob,make_string(str),&v);
    if(!ob_name || strchk(ob_name,1)) error(realm,"Illegal value to find_object()\n");

    str=ob_name->u.string;

    if(!check_realm_access(ob_name->u.string,0)) return 0;
#else
    if(!check_realm_access(str,0)) return 0;
#endif

    /* Remove leading '/' if any. */

    while(str[0] == '/') str++;

    ob = find_object2(str,1);

    if(ob && !check_realm_access(0,ob)) return 0;

    if (ob) return ob;

    ob = load_object(extract_realm(str),str);

    if(!check_object(ob)) return 0;		/* *sigh* */

    if (ob->flags & SWAPPED) load_ob_from_swap(ob);
    return ob;
}

/* Look for a loaded object. */
struct object *find_object2(str,flag)
    register char *str;
    int flag;
{
    register OBJECT *ob;
    register char *name;
    int length;

    if(!str || str==NULL)
	if(ob_status[0] && ob_status[0]->ob) error(ob_status[0]->ob->realm,"Null value to find_object2()\n");
		else error(sys_realm,"Null value to find_object2()\n");

	if(!flag)
		if(!check_realm_access(str,0)) return 0;
    /* Remove leading '/' if any. */
    while(str[0] == '/') str++;
    /* Truncate possible .c in the object name. */
    length = strlen(str);
    name = string_copy(str);
    if (name[length-2] == '.' && name[length-1] == 'c') {
	name[length-2] = '\0';
	length -= 2;
    }

    if(ob=find_o_hash(name,cf.otable,o_table,1)) {
        free(name);
	if(!flag && !check_realm_access(0,ob)) return 0;
	if (ob->flags & SWAPPED) load_ob_from_swap(ob);
	return ob;
    }

    free(name);
    return 0;
}

VALUE *last_inventory(arg)
    register VALUE *arg;
{
    register OBJECT *ob,*last,*next_ob;
    register VALUE *ret;
    
    if(arg->type==T_STRING) ob=find_object(arg->u.string);
	  else ob=arg->u.ob;
	if(!check_object(ob)) error(ob_status[0]->ob->realm,"No object to last_inventory().\n");
	if(!ob->ref_ob[1]) return &const0;
	for(next_ob=ob->ref_ob[1];next_ob;next_ob=next_ob->ref_ob[2])
			last=next_ob;
	ret=make_object(last);
    return ret;
}

VALUE *first_inventory(arg)
    register VALUE *arg;
{
   register OBJECT *ob;
   register VALUE *ret;

    if (arg->type == T_STRING) ob = find_object(arg->u.string);
    else ob = arg->u.ob;
    if (!check_object(ob)) error(ob_status[0]->ob->realm,"No object to first_inventory()\n");
    if (!ob->ref_ob[1]) return &const0;
    ret = make_object(ob->ref_ob[1]);
    return ret;
}

VALUE *next_prev_inventory(arg,flag)
    register VALUE *arg;
	int flag;
{
    register OBJECT *ob;
    register VALUE *ret;

    if (arg->type == T_STRING) ob = find_object(arg->u.string);
      else ob = arg->u.ob;
    if (!check_object(ob)) 
		if(!flag) error(ob_status[0]->ob->realm,"No object to next_inventory()");
			else error(ob_status[0]->ob->realm,"No object to previous_inventory()");
    if((!flag && !ob->ref_ob[2]) ||
		(flag && !ob->ref_ob[3])) return &const0;

    ret = make_object(flag?ob->ref_ob[3]:ob->ref_ob[2]);
    return ret;
}

/*
 * This will enable an object to use commands normally only
 * accessible by interactive players.
 * Also check if the player is a wizard. Wizards must not affect the
 * value of the wizlist ranking.
 */

void enable_commands(num)
    int num;
{
    if(num)
      {
        ob_status[0]->ob->flags |= COMMANDS;
        command_giver = ob_status[0]->ob;
      }
    else if(ob_status[0]->ob->flags & COMMANDS)
	 {
	   ob_status[0]->ob->flags &= ~COMMANDS;
	   if(command_giver==ob_status[0]->ob) command_giver=0;
	 }
}


/*
 * To find if an object is present, we have to look in two inventory
 * lists. The first list is the inventory of the current object.
 * The second list is all things that have the same ->super as
 * current_object.
 * Also test the environment.
 * If the second argument 'ob' is non zero, only search in the
 * inventory of 'ob'. The argument 'ob' will be mandatory, later.
 */

static VALUE *object_present2();

VALUE *object_present(v, ob)
    register VALUE *v;
    register OBJECT *ob;
{
    register VALUE *ret;
    int specific = 0;
	jmp_buf erc;
	struct jmp_globals jmp;

    if (!ob) ob = ob_status[0]->ob;
    else specific = 1;
    if (v->type == T_OBJECT) {
	if (specific) {
	    if (v->u.ob->ref_ob[0] == ob) return v;
	    else return &const0;
	}
	if (v->u.ob->ref_ob[0] == ob ||
	    (v->u.ob == ob->ref_ob[0] && ob->ref_ob[0]) ||
	    (v->u.ob->ref_ob[0] == ob->ref_ob[0] && ob->ref_ob[0]))
	    return v;
	return &const0;
    }
    ret = object_present2(v, ob->ref_ob[1]);
    if (ret) return ret;
    if (specific) return &const0;

    if (ob->ref_ob[0])
      {
	if(ob->ref_ob[0]->fun_p[6])
	 {
	   set_jump_state(erc,&jmp);
	   if(setjmp(error_recovery_context)) {clear_jump_state(&jmp);ret=0; }
 		else ret = apply(ob->ref_ob[0]->fun_p[6],0, ob->ref_ob[0], v,0);
	   reset_jump_state(erc);

	   if (!check_object(ob->ref_ob[0])) return &const0;

	   if (ret && ret->type & T_NUMBER)
		if((ret->type==T_INT && ret->u.n_int) ||
		   (ret->type==T_FLOAT && ret->u.n_float))
	     {
	       ret = make_object(ob->ref_ob[0]);
	       return ret;
	     }
          }
	return object_present2(v, ob->ref_ob[0]->ref_ob[1]);
      }

    return &const0;
}

static VALUE *object_present2(v, ob)
    register VALUE *v;
    register OBJECT *ob;
{
    VALUE *ret;
    register char *p;
    int count = 0, length;
    VALUE item;
    jmp_buf erc;
    struct jmp_globals jmp;

#ifndef linux
    extern int atoi();
#endif

    item.type = T_STRING;
    item.u.string = string_copy(v->u.string);
    length = strlen(item.u.string);
    p = item.u.string + length - 1;
    if (*p >= '0' && *p <= '9') {
	while(p > item.u.string && *p >= '0' && *p <= '9') p--;
	if (p > item.u.string && *p == ' ') {
	    count = atoi(p+1) - 1;
	    *p = '\0';
	    length = p - item.u.string;	/* This is never used again ! */
	}
    }
    for (; ob; ob = ob->ref_ob[2]) 
       {
	if(!check_realm_access(0,ob) || !ob->fun_p[6]) continue;

	set_jump_state(erc,&jmp);
	if(setjmp(error_recovery_context)) {clear_jump_state(&jmp);ret=0; }
	 	else ret = apply(ob->fun_p[6],0, ob, &item,0);
	reset_jump_state(erc);

	if (!_check_object(ob)) 
	  {
  	  	free(item.u.string);
   	 	return 0;
  	  }

	if (numchk(ret,T_NUMBER)) continue;

    	if((ret->type==T_INT && !ret->u.n_int) ||
		(ret->type==T_FLOAT && !ret->u.n_float)) continue;

	if (count-- > 0) continue;

	ret = make_object(ob);
	free(item.u.string);
	return ret;
       }

    free(item.u.string);
    return 0;
}

void remove_object(ob,offset)
   register OBJECT *ob;
   int offset;
{
    int first,second;

	first=offset;
	second=offset+1;
	if(ob->ref_ob[first])
		 ob->ref_ob[first]->ref_ob[second]=ob->ref_ob[second];
	if(ob->ref_ob[second])
		 ob->ref_ob[second]->ref_ob[first]=ob->ref_ob[first];
	ob->ref_ob[first]=0;
	ob->ref_ob[second]=0;
}
/* must prevent recursion of destruct in exit, and drop.  one call to
    destruct is all that is needed.  So we need to ignore any further calls
    to destroy the current object being destroied.
*/

void destruct_object(ob,ob_name)
    register OBJECT *ob;
    register char *ob_name;
{
    register OBJECT *super, *pp;
    register VALUE *weight,*ret;
    VALUE neg_weight;
    struct lnode_def *pr;
    int removed;
    jmp_buf erc;
    struct jmp_globals jmp;
    char *new_name, void_room[200];
    VALUE v;

    extern OBJECT *find_link PROT((OBJECT *));
    extern int set_heart_beat PROT((OBJECT *,int));
    extern char remove_call_out PROT((OBJECT *,char *,int));
    extern void remove_interactive();
    extern VALUE *new_player_link();
    
	/* if only the object name was passed as a refernece find it's object
	   pointer, if one exists.
	*/

#if 0
    v.type=T_STRING;
    v.u.string=ob_status[0]->ob->realm->realm_dir;

    if(ob_name)
      {
	VALUE *tmp_name=apply(mcp.fun_p[2],0,mcp.ob,make_string(ob_name),&v);

	ob=0;
	if(!strchk(tmp_name,1)) ob = find_object2(tmp_name->u.string,0);
	if (!ob) error(ob_status[0]->ob->realm,"destruct_object: Could not find %s\n", ob_name);
      }
#else
    if(ob_name) ob=find_object2(ob_name,0);
    if(!ob) error(ob_status[0]->ob->realm,"Destruct_object: Could not find %s\n",ob_name);
#endif

	/* Make sure it's not already destructed. */

    if (!check_object(ob)) error(ob_status[0]->ob->realm,"Destruct destructed object.\n");

	/* if we are being destructed don't destruct us again. */

    if(!(ob->flags & VALID_OB)) return;


    if(ob_status[0] && ob_status[0]->ob && ob_status[0]->ob->realm!=sys_realm)
      {
	ret=0;
	if(ob_status[0]->ob->realm==ob_status[0]->ob->realm)
	 {
            set_jump_state(erc,&jmp);
            if(!setjmp(error_recovery_context))
               ret=apply(mcp.fun_p[4],0,mcp.ob,make_object(ob_status[0]->ob),make_object(ob)); 
	         else clear_jump_state(&jmp);
            reset_jump_state(erc);
	 }

        if(!ret || numchk(ret,T_INT) || !ret->u.n_int) 
		error(ob_status[0]->ob->realm,"Tried to destruct restricted object.\n");
       }

	/* set us as being destructed. this prevents recursion. */

	ob->flags&=~VALID_OB;

	/* if we have been swapped, unswap us. */

    if(ob->flags & SWAPPED) load_ob_from_swap(ob);

	/* if this is an interactive object(ie a player) we must see if they
	   are using a diffent object other than there link object (ie the 
	   object they were first linked to).

	   If they are then remove interactive from that object and destruct,
	   if they are not then find the link object reconect it, and destruct,
	   this object.
	*/

    if(ob->interactive)
	  if(ob==find_link(ob)) remove_interactive(ob);
	    else if(!check_object(find_link(ob)) ||
 	    	    !new_player_link(find_link(ob),ob)) 
		 				remove_interactive(ob);

	/* If we have a heart beat, turn it off. */
    if(ob->links[1]) (void)set_heart_beat(ob, 0);

	/* If we define any call out's remove them from the system. */

	(void)remove_call_out(ob,0,1);

	/* if we are in an object, set the 'super' to it, if not, look for
	   a void room.  This is used when we move any objects we might be
	   carrying in us to our environment, or to the void if no environment.

	   WARNING: 'super' MUST find a valid object or the system will terminate.
	*/

    super = ob->ref_ob[0];
    if (!check_object(super)) 
	  {
		 if(ob->realm!=sys_realm)
		   {
		     (void)strcpy(void_room,ob->realm->realm_dir);
			 (void)strcat(void_room,"/room/void");
		   }
	     else  (void)strcpy(void_room,"room/void");
		 super = find_object(void_room);
      }
     else
      {
        /* call drop in us, incase we are linked in some way to our
	   environment, pass 1 so no drop messages are heard.
	*/

	   if(ob->fun_p[1])
             {
		set_jump_state(erc,&jmp);
		if(!setjmp(error_recovery_context))
	        (void)apply(ob->fun_p[1],0,ob,&const1,0); 
		  else clear_jump_state(&jmp);
		reset_jump_state(erc);
             }

	/* call save_me, if the system hasn't already done it.
	   A special condition exists when shutdown is called. and if
	   we saved here, when it is called, we would loose some of the
	   object data or environmental data that might be needed by the 
	   object.
        */

	    if(!save_flag) 
	      {
		set_jump_state(erc,&jmp);
		if(!setjmp(error_recovery_context))
			(void)apply(0,"save_me",ob,&const1,0);
		  else clear_jump_state(&jmp);
		reset_jump_state(erc);
	      }

		/* remove our weight from the environment.  We do this here as
		   it might be needed.
	        */

	     if(ob->fun_p[2] && super->fun_p[3])
	       {
		set_jump_state(erc,&jmp);
		if(setjmp(error_recovery_context)) {clear_jump_state(&jmp);weight=0; }
			else weight = apply(ob->fun_p[2],0, ob, &const0,0);
		reset_jump_state(erc);
		if (weight && weight->type & T_NUMBER) 
		  {
		    	neg_weight.type = weight->type;
		    	if(weight->type==T_INT) neg_weight.u.n_int = - weight->u.n_int;
			  else neg_weight.u.n_float= -weight->u.n_float;
			set_jump_state(erc,&jmp);
			if(!setjmp(error_recovery_context))
		    	(void)apply(super->fun_p[3],0, super, &neg_weight,0);
			  else clear_jump_state(&jmp);
			reset_jump_state(erc);
		  }
               }
      }

    move_object(ob,0,0,1); /* move the object from the current environment. */

	/* now, if we have items in us, move them to the object pointed to by
	   'super', this would be the object we were in, or a void room
	*/

    while(ob->ref_ob[1])
        move_or_destruct(ob->ref_ob[1], super);

    /*
     * Now remove us out of the list of all objects, the object hash table,
	 * our living name if any, and mark us as not having COMMANDS.
     */

    if(ob->links[0]) remove_reset(ob->links[0]);
    del_o_hash(ob,o_table,hash(ob->name,cf.otable),1);
    if (ob->living_name) del_o_hash(ob,l_table,hash(ob->living_name,cf.ltable),0);

    (void)remove_sent(0,ob,0);

    ob->flags&=~COMMANDS; 

	/* If we are the current object we don't want to free the object until
	   we are done executing code in it.  So we put it on the obj_list_destruct
	   so that it might be free'd after it has finnished running.
	   Otherwise free it now, as there is no reason to have it just hang'n
	   around any longer than necisary.
	*/


    ob->flags|=DEST;
  
    if(!(ob->flags & CLONE))
      {

        new_name=make_new_name(ob->name);

        for(pr=ob->prog;pr;pr=pr->next)
	   {
		register char *tmp;

		del_p_hash(pr->name);
		tmp=make_hash_name(strchr(pr->name,' ')+1,new_name);
		free_string(pr->name,"destruct_object");
		pr->name=make_shared_string(tmp);
		free(tmp);
		add_p_hash(pr);
	   }

        free(new_name);
     }
	   
    if(ob==command_giver) command_giver=0;

    if(ob==mcp.ob) load_mcp();

    if((ob_status[0] && ob==ob_status[0]->ob) || ob->flags & MOVE ||
		ob->flags & MOVE2) 
	  {
    	ob->ref_ob[4] = obj_list_destruct;
    	obj_list_destruct = ob;
	  }
	else
	   free_object(ob);
}

/*
 * All destructed objects are moved int a sperate linked list,
 * and deallocated after program execution.
 */

void remove_destructed_objects()
{
    register OBJECT *ob;

	for (ob=obj_list_destruct; ob; ob = obj_list_destruct) 
	  {
		obj_list_destruct=ob->ref_ob[4];
		ob->ref_ob[4]=0;
		free_object(ob);
	  }

}

void remove_ob_ref(ob)
register OBJECT *ob;
{
   ob->num_ref--;
   if(ob->num_ref<0)
     {
	    debug_message(sys_realm,"bad ref count on object %s\n",ob->name);
	    ob->num_ref=0;
     }
   if(ob->flags || ob->num_ref>0) return;
   tot_alloc_object--;
   tot_alloc_ob_bytes-=sizeof(ob);
   num_ob_in_free_list--;
   free((char *)ob);
   ob=0;
}

/*
 * This one is called when no program is execuiting.
 */

static void free_object(ob)
    register OBJECT *ob;
{
    register SENTENCE *s,*next;
    register OBJECT free_ob,*ob2;
    int i;
    char *name;

    if (ob->num_variables) 
      {
	extern void free_svalue();

	for (i=0; i<ob->num_variables; i++)
	  free_svalue(&ob->variables[i]);

	free((char *)ob->variables);
	tot_alloc_svalue-=ob->num_variables;
      }

    /* free all function pointers */

    for(i=0;i<10;i++)
       free_fun_p(ob->fun_p[i]);

    /*
     * If the program is freed, then we can also free the variable
     * declarations and the inherit list.
     */

    if(free_prog((struct lnode_def *)ob->prog, ob->block, ob->swap_size))
      {
	if(ob->swap_num== -1 && ob->status)
	   free_sub_part((struct lnode *)ob->status, 1);

	if(ob->inherit)
	  { 
	     ob->flags&=~CLONE;  	      /* in case it was a clone, as */
	     free_inherit_list(ob->inherit,0);/* the last object using this */
	  }		 		      /* code we need now to treat  */
					      /* it as the root object.     */
      }

    if(ob->inherit && ob->flags & CLONE)
	 free_inherit_list(ob->inherit,1);


    if(ob->logged) free_string(ob->logged,"free_object");

    free_string(ob->name,"free_object");

    if(ob->reset) free_fun_p(ob->reset);

      if(ob->num_ref)
	num_ob_in_free_list++;
      else
       {
         tot_alloc_object--;
	 tot_alloc_ob_bytes-=sizeof(ob);
	 free((char *)ob);
       }
    ob=0;
}

/*
 *
 * Save the command_giver, because reset() in the new object might change
 * it.
 */

VALUE *clone_object(str1)
    register char *str1;
{
    register OBJECT *ob, *new_ob,*save_command_giver=command_giver;
    register VALUE *val;
    register char *name;

    if(!str1) fatal("No filename to clone!\n");

    ob = find_object(str1);

    if (!check_object(ob) || ob->flags & NO_CLONE)
		 error(ob_status[0]->ob->realm,"Unable to clone object %s\n",str1);

    if (ob->flags & CLONE) error(ob_status[0]->ob->realm,"Cloning a used object !\n");

    new_ob = get_empty_object(ob->num_variables);

    if(!new_ob) fatal("Could not get an empty object in clone_object().\n");

    name = make_new_name(ob->name);
    new_ob->name=make_shared_string(name);
    free(name);
    new_ob->flags=ob->flags;
    new_ob->flags |=CLONE;

    new_ob->prog = ob->prog;
    add_prog_ref(ob->prog);

    new_ob->inherit = ob->inherit;
    if (ob->inherit)
	 {
	   struct inherit_list *list=ob->inherit;

	   for(;list;list=list->next)
		  add_prog_ref(list->prog);
	 }

    if(check_object(ob_status[0]->ob) && ob_status[0]->ob->realm!=sys_realm)
	  new_ob->realm=ob_status[0]->ob->realm;
       else new_ob->realm=ob->realm;

    if(!strcmp(ob->wl->name,"mud") && check_object(ob_status[0]->ob) &&
	   ob_status[0]->ob->realm==new_ob->realm) new_ob->wl=ob_status[0]->ob->wl;
      else new_ob->wl = ob->wl;

    if(!new_ob->wl)
	fatal("object cloned without a wizard mark ob:%s wz?%s co:%s wz? %s\n",ob->name,ob->wl?"yes":"no",ob_status[0]->ob->name,ob_status[0]->ob->wl?"yes":"no");

    new_ob->status = ob->status;
    new_ob->block = ob->block;
    new_ob->swap_num=ob->swap_num;
    new_ob->swap_size = ob->swap_size;

    add_o_hash(new_ob,o_table,hash(new_ob->name,cf.otable),1);

    pre_load_pointers(new_ob);

    if(new_ob->reset)
      {
         val=apply(new_ob->reset,0, new_ob, &const0,0);

         if(numchk(val,T_NUMBER) || !val->u.n_int) set_reset(new_ob);

         command_giver=save_command_giver;
      }

    return make_object(new_ob);
}

struct value *environment(arg)
    register VALUE *arg;
{
    register VALUE *ret;
    register OBJECT *ob = ob_status[0]->ob;
    VALUE v;

    v.type=T_STRING;
    v.u.string=ob_status[0]->ob->realm->realm_dir;

    if (!objchk(arg)) ob = arg->u.ob;
    else if (!strchk(arg,1))
	{
#if 0
	   VALUE *tmp_name=apply(mcp.fun_p[2],0,mcp.ob,arg,&v);

	   ob=0;

	   if(!strchk(tmp_name,1)) ob = find_object2(tmp_name->u.string,0);
        }
#else
	   ob=find_object2(arg->u.string,0);
	}
#endif

    if (!ob || !ob->ref_ob[0]) return &const0;

    if (!check_object(ob)) error(ob_status[0]->ob->realm,"environment() off destructed object.\n");
    ret = make_object(ob->ref_ob[0]);
    return ret;
}

/*
 * Replace newlines in a string with a carriage return, to make the string
 * writeable on one line.
 */

static void replace_newline(str)
    register char *str;
{
    for (; *str; str++) {
	if (str[0] == '\n')
	    str[0] = '\r';
    }
}

/*
 * Replace carriage return in a string with newlines.
 */

static int my_strlen(str)
    register char *str;
{
    int sz = 0;

    while (*str) {
	sz++; 
	if (*str == '\"' || *str == '\\') sz++;
	str++;
    }
    return sz;
}

static void my_strcat(dest,src)
    register char *dest,*src;
{
    register char *pt,*pt2;
    char ch[2];

    if(!src)
    {
       debug_message(ob_status[0]->ob->realm,"tried to cat a non string\n");
       return;
    }
    pt = strchr(src,'\\'); ch[1] = 0;
    pt2 = strchr(src,'\"');
    if (((pt2) && (pt2<pt)) || (!pt)) pt = pt2;
    while (pt) {
	ch[0] = *pt; *pt = 0; 
	(void)strcat(dest,src); (void)strcat(dest,"\\"); (void)strcat(dest,ch);
	src = pt+1;
    *pt = ch[0];
    if(!src)
	 {
		debug_message(ob_status[0]->ob->realm,"tried to cat a non string 2nd\n");
	    return;
	 }
	pt = strchr(src,'\\'); 
	pt2 = strchr(src,'\"');
	if (((pt2) && (pt2<pt)) || (!pt)) pt = pt2;
    }
    (void)strcat(dest,src);
}
	

static int save_size(v,flag)
     register struct vector *v;
     int flag;
{
  int i,siz;
  char numbuf[200];

  for (i=0, siz =v->size+3; i < v->size; i++) 
   {
      if (v->item[i].type == T_STRING) 
         siz += my_strlen(v->item[i].u.string)+2;

        else if (v->item[i].type == T_POINTER) 
          siz += save_size(v->item[i].u.vec,flag);

            else if (v->item[i].type & T_NUMBER)
	      {
	        if(v->item[i].type==T_INT) 
		   (void)sprintf(numbuf,"%d",v->item[i].u.n_int);
		 else (void)sprintf(numbuf,"%f",v->item[i].u.n_float);

                siz += strlen(numbuf);
              }
	
	        else if(v->item[i].type==T_OBJECT &&
			check_object(v->item[i].u.ob) &&
			(!v->item[i].u.ob->flags & CLONE || flag))
		           siz+=strlen(v->item[i].u.ob->name)+2;

                  else siz += 1;
      }

  return siz;
}


static void restore_newline(str)
    register char *str;
{
    for (; *str; str++) {
	if (str[0] == '\r')
	    str[0] = '\n';
    }
}


static char *my_string_copy(str)
    register char *str;
{
    register char *apa,*cp;

    cp = apa = xalloc(strlen(str)+1);
    
    while(*str) {
	if (*str == '\\') {
	    *cp = str[1];
	    if (str[1]) str+=2;
	    else str++;   /* String ends with a \\ buggy probably */
	    cp++;
	}
	else { *cp = *str; cp++; str++; }
    }
    *cp=0;
    cp = string_copy(apa);
    free(apa);
    return cp;
}

static unsigned short restore_size(str)
     register char **str;
{
  char *pt,*pt2;
  unsigned short siz;

  pt = *str; 
  if (strncmp(pt,"({",2)) return 0;
  else pt += 2;

  if(pt[0]=='}') return 0;

  siz = 0;

  while ((pt) && (*pt))
    {
	if (pt[0] == '\"') 
	  {
		if(strlen(pt)<2)
			{
				debug_message(ob_status[0]->ob->realm,"string to short for restore_size\n");
				return 0;
			}
		pt2 = strchr(&pt[1],'\"');
      		if (!pt2) return 0;
      		pt2--;
      		while (pt2[0] == '\\') 
		  {
	 		pt = pt2;
			if(strlen(pt2)<3)
				{
					debug_message(ob_status[0]->ob->realm,"string to short for restore_size 2nd\n");
					return 0;
				}
	  		pt2 = strchr(&pt[2],'\"');
	  		if (!pt2) return 0;
	  		pt2--;
      		  }
      		if(pt2[2]!=',' && pt2[2]!='}') return 0;
      		siz++;
      		if(pt2[2]==',') pt= &pt2[3];
     		  else pt= &pt2[2];
    	  }
	else if (pt[0] == '(' && pt[1] == '{')
	  { 
      		if (!restore_size(&pt)) return 0;
		if(pt[0]==',') pt= &pt[1];
      		siz++;
    	  }
	else
	  {
		while(pt && pt[0]!=',' && pt[0]!='}') pt++;
      		if (pt)
		  {
      		    siz++;
      		    if(pt[0]==',') pt++;
		  }
		else return 0;
    	  }
	if (pt[0] == '}' && pt[1]==')') 
	  {
      		*str = &pt[2];
      		return siz;
    	  }
    }
  return 0;
}

static struct value *restore_array(str)
     register char **str;
{
  register VALUE *d,*d2;
  SVALUE v2;
  char *pt,*pt2;
  register VECTOR *v;
  int i;
  unsigned short siz;
  
  pt = *str; 
  if (strncmp(pt,"({",2)) return 0;
  pt2 = pt;
  siz = restore_size(&pt2);
  d =allocate_array(siz);
  if (!siz) return d;
  v=d->u.vec;
  pt+=2;

  for (i=0;i<siz;i++)
     {
        if (!*pt) return 0;
       	if (pt[0] == '\"')
	  	  {
     		pt2 = strchr(&pt[1],'\"');
      		if (!pt2) return 0;
      		pt2--;
      		while (pt2[0] == '\\')
		 	 {
	  	   	  pt2 = strchr(&pt2[2],'\"');
	  	   	  if (!pt2) return 0;
	  	   	  pt2--;
      		  }
      		if (pt2[2] != ',' && pt2[2]!='}') return 0;
      		pt2[1] = 0;
		v2.type=T_STRING;
		v2.u.string=make_shared_string(my_string_copy(pt+1));
      		assign_svalue(&v->item[i],0,&v2);
      		if(pt2[2]==',') pt = &pt2[3];
	 	  		else pt= &pt2[2];
    	  }
        else if (pt[0] == '(' && pt[1] == '{')
	  	  {
      		d2 = restore_array(&pt);
      		if (!d2) return 0;
      		assign_svalue(&v->item[i],d2,0);
			if(pt[0]==',') pt++;
    	  }
        else
	  	{
		pt2= &pt[0]; 
		while(pt2 && pt2[0]!=',' && pt2[0]!='}') pt2++;
       		if(pt2)
	          {
			double num;
         		num=atof(pt);
			if(!strchr(pt,'.') && num<=(double)MAX_INT &&
			   num>=(double)MIN_INT)
			  {
				v2.type=T_INT;
				v2.u.n_int=(int)num;
				assign_svalue(&v->item[i],0,&v2);
			  }
	 		else
			  {
				 v2.type=T_FLOAT;
				 v2.u.n_float=num;
				 assign_svalue(&v->item[i],0,&v2);
			  }

			pt= &pt2[0];
         		if(pt[0]==',') pt++;
		  }
		else return 0;
    	 }
    }
  if (strncmp(pt,"})",2)) return 0;
  *str = &pt[2];
  return d;
}

char *save_array(v,flag)
     register VECTOR *v;
     int flag;
{
  register char *buf,*tbuf;
  char numbuf[100];
  int i;

  buf = xalloc(save_size(v,flag)+1);

  (void)strcpy(buf,"({");
  for (i=0; i < v->size; i++) {
    if (v->item[i].type == T_STRING) {
      (void)strcat(buf,"\""); my_strcat(buf,v->item[i].u.string); 
      (void)strcat(buf,"\","); 
    }
    else if (v->item[i].type == T_POINTER) {
      tbuf = save_array(v->item[i].u.vec,flag);
      (void)strcat(buf,tbuf); (void)strcat(buf,",");
      free(tbuf);
    }
    else if (v->item[i].type & T_NUMBER) {
	  if(v->item[i].type==T_INT) (void)sprintf(numbuf,"%d",v->item[i].u.n_int);
        else (void)sprintf(numbuf,"%f",v->item[i].u.n_float);
      (void)strcat(buf,numbuf);
      (void)strcat(buf,",");
    }
    else if(v->item[i].type == T_OBJECT && check_object(v->item[i].u.ob) &&
	        (!v->item[i].u.ob->flags & CLONE || flag))
			{
				(void)strcat(buf,"\"");
				 my_strcat(buf,v->item[i].u.ob->name);
				(void)strcat(buf,"\",");
			}
    else (void)strcat(buf,"0,");
  }
  if(buf[strlen(buf)-1]==',') buf[strlen(buf)-1]='\0';
  (void)strcat(buf,"})");
  return buf;
}
/*
 * Save an object to a file.
 */
int save_object(ob, file,perms)
    register OBJECT *ob;
    int perms;
    char *file;
{
    register char *name, *save_name,*temp;
    char tmp_name[100];
    OBJECT *save_command_giver=command_giver;
    int len;
    register FILE *f;
    register struct lnode_var_def *p;
    int saved_old=0,failed = 0;

    extern int getpid();

    if(!check_object(ob)) return 0;
    if(ob->flags & SWAPPED) load_ob_from_swap(ob);
    command_giver=ob_status[0]->ob;
    if(!(file=check_file_name(file,1,perms)))
      {
         add_message("Illegal save file name %s in object %s\n", file,ob->name);
	 debug_message(ob_status[0]->ob->realm,"Illegal save file name %s in object %s\n",file,ob->name);
	 command_giver=save_command_giver;
         return 0;
      }
    command_giver=save_command_giver;
    len = strlen(file);
    name = xalloc(len + 3);
    save_name=xalloc(len+3);
    (void)strcpy(name, file);
    (void)strcat(name, ".o");
    (void)strcpy(save_name,file);
    (void)strcat(save_name,"-o");
    (void)sprintf(tmp_name, "%s/s%d",cf.temp_dir, getpid());
    f = fopen(tmp_name, "w");
    if(!f && errno == EMFILE) fatal("Max files open.\n");
    if(!f) 
	 error(ob_status[0]->ob->realm,"Could not open %s for a save.\n", tmp_name);
    if(ob->wl && strcmp(ob->wl->name,"mud"))
	  {
		if(!ob->wl->name || strlen(ob->wl->name)<3)
		    {
			    (void)fclose(f);
			    (void)free(name);
		  	    (void)free(save_name);
				error(ob_status[0]->ob->realm,"Bad wizard in wiz_list\n");
			}
        if(fprintf(f,"CrEaToR \"%s\"\n",ob->wl->name)==EOF) 
            debug_message(ob_status[0]->ob->realm,"Could not write creator mark!\n");
	  }
    for (p = ob->status; p; p = p->next) 
	 {
		struct svalue *v = &ob->variables[p->num_var];
		char *new_string;

	if (p->flags & L_PRIVATE || p->flags & L_STATIC) continue;
	if(v->type==T_INT && v->u.n_int)
	  {
	    if (fprintf(f, "%s %d\n", p->name, v->u.n_int) == EOF)
	    	debug_message(ob_status[0]->ob->realm,"could not write number %d\n",v->u.n_int);
	  }
	else if(v->type==T_FLOAT && v->u.n_float)
		{
			if(fprintf(f,"%s %lf\n",p->name,v->u.n_float)==EOF)
				debug_message(ob_status[0]->ob->realm,"could not write number %lf\n",v->u.n_float);
		}
    else if (v->type == T_STRING) 
		   {
	    	new_string = string_copy(v->u.string);
	    	replace_newline(new_string);
	    	if (fprintf(f, "%s \"%s\"\n", p->name, new_string) == EOF)
	     		debug_message(ob_status[0]->ob->realm,"could not write string %s\n",new_string);
	    	free(new_string);
           }
		 else if(v->type==T_OBJECT && check_object(v->u.ob) && 
			!strchr(v->u.ob->name,'#')) 
				{
					new_string = string_copy(v->u.ob->name);
					replace_newline(new_string);
					if(fprintf(f, "%s \"%s\"\n", p->name,new_string) == EOF)
		 		    debug_message(ob_status[0]->ob->realm,"could not write ob name %s\n",new_string);
					free(new_string);
			    }
	 		 else if (v->type == T_POINTER) 
					{
			  		    new_string = save_array(v->u.vec,0);
					    replace_newline(new_string);
	    				if (fprintf(f, "%s %s\n", p->name, new_string) == EOF)
	     					debug_message(ob_status[0]->ob->realm,"could not write array %s\n",new_string);
	    				free(new_string);
					}
      }
   if(!failed) 
	  {
    	if(file_size(name)>=0) 
     	 {
		(void)unlink(save_name);
      		if(link(name,save_name)== -1) 
       	      {
			        save_flag=1;
				(void)fclose(f);
				fatal("Failed to link-save old file %s\n",name);
       	 	  }
     		else
			 {
      			(void)unlink(name);
      			saved_old=1;
      	     }
         }
       if (!failed && link(tmp_name, name) == -1) 
	     {
		   debug_message(sys_realm,"Failed to link %s to %s\n", tmp_name, name);
		   failed=1;
		   if(saved_old) {(void)link(save_name,name);(void)unlink(name);}
    	 }
       else if(saved_old) (void)unlink(save_name);
     }
   if(f) (void)fclose(f);
   (void)unlink(tmp_name);
   free(name);
   free(save_name);
   if (failed)
	{
 	 	add_message("Failed to save to file. Disk could be full.\n");
		return 0;
	}
  return 1;
}

int restore_object(ob, file,perms)
    register OBJECT *ob;
    int perms;
    char *file;
{
    register char *name, *val, *buff, *space;
    char var[100];
    int cs,len;
    register FILE *f;
    register VALUE *ret;
    register struct lnode_var_def *p;
    struct object_status *save_ob_status[2];
    OBJECT *save_command_giver=command_giver;
    struct stat st;
    char not_cleared=1;
    SVALUE v2;

    if(!check_object(ob)) return 0;
    if(ob->flags & SWAPPED) load_ob_from_swap(ob);
    command_giver=ob_status[0]->ob;
    if(!(file=check_file_name(file,1,perms)))
      {
	    add_message("Illegal restore file name %s in object %s\n",file,ob->name);
	    debug_message(ob_status[0]->ob->realm,"Illegal restore file name %s in object %s\n",file,ob->name);
	    command_giver=save_command_giver;
        return 0;
      }
    len = strlen(file);
    command_giver=save_command_giver;
    name = xalloc(len + 3);
    (void)strcpy(name, file);
    if (name[len-2] == '.' && name[len-1] == 'c') name[len-1] = 'o';
      else (void)strcat(name, ".o");
    f = fopen(name, "r");
    if(!f && errno == EMFILE) fatal("Max files open.\n");
    if (!f)
      {
	free(name);
        return 0; 
      }
    if (fstat(fileno(f), &st) == -1) 
      {
	debug_message(ob_status[0]->ob->realm,"Could not stat open file '%s'.\n",name);
	free(name);
	(void)fclose(f);
	return 0;
      }
    if (st.st_size == 0) 
      {
	free(name);
	(void)fclose(f);
	return 0;
      }
    val = xalloc((int)st.st_size + 1);
    buff = xalloc((int)st.st_size + 1);
	for(cs=0;cs<2;cs++)
  	  {
		save_ob_status[cs]=ob_status[cs];
		ob_status[cs]=0;
	  }
    ob_status[0]=alloc_ob_status();
    ob_status[0]->ob=ob;
    while(1)
	 {
		struct svalue *v;

		if (fgets(buff,(int)st.st_size + 1, f) == 0) break;
		/* Remember that we have a newline at end of buff ! */
		space = strchr(buff, ' ');
		if (space == 0) 
		  {
            (void)fclose(f);
	        free(val);
	        free(buff);
	        free(name);
			for(cs=0;cs<2;cs++)
			  {
			    if(ob_status[cs]) free_ob_status(ob_status[cs]);
			    ob_status[cs]=save_ob_status[cs];
		      }
	        add_message("Illegal format when restore %s.\n", name);
	        debug_message(ob_status[0]->ob->realm,"Illegal format when restore %s.\n",name);
	        return 0;
          }

			/* Clear are variables to 0 before restoring. */

        if(not_cleared)
		  {
			 struct lnode_var_def *ps;
			 
			 not_cleared=0;
			 for(ps=ob->status;ps;ps=ps->next)
				{
					SVALUE *vs;

					if(ps->flags & L_STATIC || ps->flags & L_PRIVATE) continue;
					vs= &ob->variables[ps->num_var];
					assign_svalue(vs,&const0,0);
				}
		  }
		(void)strncpy(var, buff, space - buff);
		var[space - buff] = '\0';
		(void)strcpy(val, space+1);
		if(!strncmp(var,"CrEaToR",7) && val[0]=='"')
          {
	   		 VALUE *creat;
			 WIZ_LIST *w;
	    	 extern WIZ_LIST *find_wiz PROT((char *,char *));

	    	 val[strlen(val)-2]='\0';
	    	 restore_newline(val+1);
	    	 creat=make_string(val+1);
	    	 w=find_wiz(creat->u.string,ob->realm->realm_owner);
			 if(w) ob->wl=w;
	    	 continue;
	  	  } 
		p = find_status(var);
		if (!p) continue;
		v = &ob->variables[p->num_var];
		if (val[0] == '"') 
		  {
	    	val[strlen(val) - 2] = '\0';	/* Strip trailing "\n */
	    	restore_newline(val+1);
		v2.type=T_STRING;
		v2.u.string=make_shared_string(val+1);
	    	assign_svalue(v,0,&v2);
	    	continue;
		  }
		else
		 if (val[0] == '(' && val[1] == '{')
	  		{
	    		char *pt = val;
	    		struct value *arr;

	    		val[strlen(val) - 1] = '\0';	/* Strip trailing "\n */
	    		restore_newline(val+1);
	    		arr=restore_array(&pt);
	    		assign_svalue(v, arr,0);
	    		continue;
         	}
	      else
		if(val[0] == '(' && val[1] == '[')
			continue;
		else
		{
			double d=atof(val);
			if(!strchr(val,'.') && d>=(double)MIN_INT && d<=(double)MAX_INT)
			  {
				v2.type=T_INT;
				v2.u.n_int=atoi(val);
		 		assign_svalue(v,0,&v2);
			  }
			else 
			  {
				v2.type=T_FLOAT;
				v2.u.n_float=d;
				assign_svalue(v,0,&v2);
			  }
	        }
    	}

	for(cs=0;cs<2;cs++)
	  {
	    if(ob_status[cs]) free_ob_status(ob_status[cs]);
	    ob_status[cs]=save_ob_status[cs];
	  }
    free(name);
    free(buff);
    free(val);
    (void)fclose(f);
    return 1;
}

void tell_npc(ob, str)
    register OBJECT *ob;
    register char *str;
{
    struct value thing;
    jmp_buf erc;
    struct jmp_globals jmp;

    if(!check_object(ob) || !ob->fun_p[7]) return;

    thing.type = T_STRING;
    thing.u.string=str;

    set_jump_state(erc,&jmp);
    if(!setjmp(error_recovery_context))
 	(void)apply(ob->fun_p[7],0, ob, &thing,0);
	  else clear_jump_state(&jmp);
    reset_jump_state(erc);

    if(ob->logged) write_file(ob->logged,str,0);
}

void do_write(arg)
    register VALUE *arg;
{
    if(!check_object(command_giver)) return;

    switch(arg->type) {
    case T_STRING:
        if(!command_giver->interactive)
	   tell_npc(command_giver,arg->u.string);
	else add_message("%s", arg->u.string);
	break;
    case T_OBJECT:
        if(!command_giver->interactive)
	   tell_npc(command_giver,arg->u.ob->name);
	else add_message("%s", arg->u.ob->name);
	break;
    case T_INT:
      {
	char n_int[20];

	(void)sprintf(n_int, "%d", arg->u.n_int);

        if(!command_giver->interactive)
	   tell_npc(command_giver,n_int);
	else add_message("%s", n_int);
	break;
      }
    case T_FLOAT:
      {
	char n_float[200];

	(void)sprintf(n_float,"%f",arg->u.n_float);

        if(!command_giver->interactive)
	   tell_npc(command_giver,n_float);
	else add_message("%s", n_float);
	break;
      }
    case T_POINTER:
      {
	char *buff;

	buff=save_array(arg->u.vec,1);

        if(!command_giver->interactive)
	   tell_npc(command_giver,buff);
	else add_message("%s", buff);

	free(buff);
	break;
      }
    default:
	error(ob_status[0]->ob->realm,"Invalid argument %d to write()\n", arg->type);
    }
}

void tell_object(ob,msg)
   register OBJECT *ob;
   register VALUE *msg;
{
   OBJECT *save_command_giver=command_giver;

   command_giver=ob;
   do_write(msg);
   command_giver=save_command_giver;
}

struct object *get_empty_object(num_var)
    unsigned short num_var;
{
    register OBJECT *ob;
    int size =sizeof (struct object);
    int i;

    tot_alloc_object++;
    tot_alloc_ob_bytes+=size;
    ob = (struct object *)xalloc(size);
    clear_object(ob);
	tot_alloc_svalue+=num_var;
    ob->swap_num = -1;		/* Object not swapped. */
	ob->flags |=VALID_OB;
    ob->num_variables =num_var;
    ob->links[0]=0;
    ob->links[1]=0;
    ob->reset=0;
    for(i=0;i<10;i++) ob->fun_p[i]=0;

	for(i=0;i<NUM_REF_OB;i++) ob->ref_ob[i]=0;
	if(num_var)
	  {
	   ob->variables=(struct svalue *)xalloc(sizeof (struct svalue)*num_var);
    	   for (i=0; i<num_var; i++) 
	     {
		ob->variables[i].type=T_INT;
                ob->variables[i].u.n_int=0;
		ob->variables[i].u.n_float=0.0;
		ob->variables[i].u.ob=0;
		ob->variables[i].u.string=0;
		ob->variables[i].u.vec=0;
             }
          }
    return ob;
}

void set_living_name(ob, str)
    register OBJECT *ob;
    register char *str;
{
    if (ob->living_name) 
	  {
		del_o_hash(ob,l_table,hash(ob->living_name,cf.ltable),0);
		free_string(ob->living_name,"set_living_name");
      } 
    else 
      {
		if(!str) return;
		if(str=="\0") error(ob_status[0]->ob->realm,"NULL value passed to set_living_name()\n");
      }
    ob->living_name=make_shared_string(str);
    add_o_hash(ob,l_table,hash(str,cf.ltable),0);
    return;
}

int save_inventory(ob,dir)
   register OBJECT *ob;
   register char *dir;
{
    extern int eval_cost;

	register VALUE *inventory=0;
	int i,count=1;
	register char *item_list=0, *objects_saved=0;
 
    inventory=all_inventory(ob);
    i= -1;
   if(!pointchk(inventory))
    while(i<inventory->u.vec->size-1)
     {
	register OBJECT *inv_ob=0;
        register char *item_file=0;
	register VALUE *drop=0;
	char buff[100];
	int stat=0;
	jmp_buf erc;
	struct jmp_globals jmp;

        i++;
	if(eval_cost>=(cf.max_cost-1000))
		if(command_giver)
		 {
		    tell_object(command_giver,make_string("Too much to Save! Some inventory unsaved!\n"));
		    break;
		 }
		   else break;
    if(inventory->u.vec->item[i].type!=T_OBJECT) continue;
	inv_ob=inventory->u.vec->item[i].u.ob;
	if(!check_object(inv_ob) || inv_ob->flags & NO_EXT_SAVE) continue;
	(void)sprintf(buff,"%d",count);
	item_file=xalloc(strlen(dir)+strlen(buff)+6);
	(void)strcpy(item_file,dir);
	(void)strcat(item_file,"/item");
	(void)strcat(item_file,buff);
	buff[0]='\0';

	if(inv_ob->fun_p[8])
	{
	  set_jump_state(erc,&jmp);
	  if(!setjmp(error_recovery_context))
	     (void)apply(inv_ob->fun_p[8],0,inv_ob,&const0,0);
	       else clear_jump_state(&jmp);
	  reset_jump_state(erc);
        }

	stat=save_object(inv_ob,item_file,0);
	if(!stat || !check_object(inv_ob)) 
	  {
	 	free(item_file);
		continue;
	  }
	if(inv_ob->flags & CLONE)
	  {
		int c;

		c=strlen(inv_ob->name)-strlen(strchr(inv_ob->name,'#'));
		if(!objects_saved) 
		   {
			 objects_saved=xalloc(c+3); 
		 	 objects_saved[0]='\0';
	       }
		   else
			  objects_saved=(char *)realloc(objects_saved,strlen(objects_saved)+c+3);
		(void)strncat(objects_saved,inv_ob->name,c);
	  }
	else
      {
	   if(!objects_saved)
	     {
			objects_saved=xalloc(strlen(inv_ob->name)+4);
			objects_saved[0]='\0';
	     }
	   else objects_saved=(char *)realloc(objects_saved,strlen(objects_saved)+strlen(inv_ob->name)+4);
	   (void)strcat(objects_saved,"~");
	   (void)strcat(objects_saved,inv_ob->name);	
	 }
	(void)strcat(objects_saved,":");
	count++;
	if(inv_ob->ref_ob[1])
	 {
 	     register OBJECT *cont,*cont2;
	     int count2;

	     count2=1;
	     cont=inv_ob->ref_ob[1];
	     while(check_object(cont))
	      {
		char buf2[100], *item_file2;

		cont2=cont->ref_ob[2];
		if(!check_object(cont) || (cont->flags & NO_EXT_SAVE))
		  {
			cont=cont2;
			continue;
		  }
		(void)sprintf(buf2,"%d",count2);
		item_file2=xalloc(strlen(item_file)+strlen(buf2)+2);
		(void)strcpy(item_file2,item_file);
		(void)strcat(item_file2,"-");
		(void)strcat(item_file2,buf2);
		if(cont->fun_p[8])
	        {
	          set_jump_state(erc,&jmp);
		  if(!setjmp(error_recovery_context))
		     (void)apply(cont->fun_p[8],0,cont,&const0,0);
		       else clear_jump_state(&jmp);
		  reset_jump_state(erc);
	        }
		stat=0;
		stat=save_object(cont,item_file2,0);
		free(item_file2);
		buf2[0]='\0';
		if(!stat || !check_object(cont)) continue;
		if(inv_ob->flags & CLONE)
		  {
			int c,not_cloned=0;

		    c=strlen(cont->name)-strlen(strchr(cont->name,'#'));	
			objects_saved=(char *)realloc(objects_saved,strlen(objects_saved)+c+4);
			(void)strcat(objects_saved,"^");
			(void)strncat(objects_saved,cont->name,c);
		  }
		else 
		 {
			objects_saved=(char *)realloc(objects_saved,strlen(objects_saved)+strlen(cont->name)+5);
			(void)strcat(objects_saved,"^~");
			(void)strcat(objects_saved,cont->name);	
		 }
		(void)strcat(objects_saved,":");
		count2++;
		cont=cont2;
	    }
        }
      if(item_file) free(item_file);
    }
   item_list=xalloc(strlen(dir)+7);
   (void)strcpy(item_list,"/");
   (void)strcat(item_list,dir);
   (void)strcat(item_list,"/list");
   item_list++;
   if(file_size(item_list)>=0) (void)unlink(item_list);
   item_list--;
   if(!objects_saved)
     {
	free(item_list);
	eval_cost=0;
	return 1;
     }
   objects_saved[strlen(objects_saved)-1]=0;
   objects_saved=(char *)realloc(objects_saved,strlen(objects_saved)+3);
   (void)strcat(objects_saved,"\n");
   write_file(item_list,objects_saved,0);
   free(item_list);
   free(objects_saved);
  eval_cost=0;
  return 1;
}


void do_move_inv(ob,dest)
	register OBJECT *ob,*dest;
{
	jmp_buf erc;
	struct jmp_globals jmp;
	register VALUE *weight;

	/* add our weight to the environment.  */

    if(ob->fun_p[2] && dest->fun_p[3])
      {
	set_jump_state(erc,&jmp);
	if(setjmp(error_recovery_context)) {clear_jump_state(&jmp);weight=0; }
	else weight = apply(ob->fun_p[2],0, ob, &const0,0);
	reset_jump_state(erc);
	if (weight && weight->type & T_NUMBER) 
	  {
		set_jump_state(erc,&jmp);
		if(!setjmp(error_recovery_context))
	    	(void)apply(dest->fun_p[3],0, dest, weight,0);
		  else clear_jump_state(&jmp);
		reset_jump_state(erc);
	  }
      }
    move_object(ob,dest,1,0);
}

int restore_inventory(ob,dir)
	register OBJECT *ob;
	register char *dir;
{
  extern VALUE *print_file PROT((char *,int,int,int));
  extern VALUE *explode_string PROT((char *,char *));
  extern int eval_cost;

  jmp_buf erc;
  struct jmp_globals jmp;
  int ret=0,object_count=0,count,tcount=0,fz;
  register char *list,*o_list;
  register VALUE *object_list;
  register VECTOR *ob_vec;
  register OBJECT *prev_ob,*container=0;
  register FILE *f;
 
  list=xalloc(strlen(dir)+6);
  (void)strcpy(list,dir);
  (void)strcat(list,"/list");
  fz=file_size(list);
  if(fz<1)
    {
      add_message("No inventory list to restore.\n");
	  free(list);
      return 0;
    }
  f=fopen(list,"r");
  if(!f && errno == EMFILE) fatal("Max files open.\n");
  if(!f)
    { 
	free(list);
	return 0;
    }
  o_list=xalloc(fz+2);
  if(!fgets(o_list,fz+1,f))
    {
	free(list);
	free(o_list);
	(void)fclose(f);
	return 0;
    }
  free(list);
  (void)fclose(f);
  o_list[strlen(o_list)-1]=0;
  object_list=explode_string(o_list,string_copy(":"));
  free(o_list);
  if(pointchk(object_list)) return 0;
  ob_vec=object_list->u.vec;
  for(count=0;count<ob_vec->size;count++)
      {
	char num[100];
        register char *res_file;
 
       if(ob_vec->item[count].u.string[0]=='^')
		{
	    	tcount++;
	    	if(!container) container=prev_ob;
        }
       else
		{
	  		if(container) { tcount=0;container=0;}
	  		object_count++;
		}
       if(ob_vec->item[count].u.string[0]=='~')
		{
		  register char *temp;

		  temp= &ob_vec->item[count].u.string[1];
		  if(temp[0]=='^') temp= &temp[1];
		  set_jump_state(erc,&jmp);
		  if(setjmp(error_recovery_context))
			{
			  clear_jump_state(&jmp);
			  prev_ob=0;
			}
	       else prev_ob=find_object(temp);
		   reset_jump_state(erc);
		}
        else 
          {
	     	register VALUE *clone_ob;
		register char *temp;

		temp=ob_vec->item[count].u.string;
		if(temp[0]=='^') temp= &temp[1];
		set_jump_state(erc,&jmp);
		if(setjmp(error_recovery_context))
		 {
			clear_jump_state(&jmp);
			clone_ob=0;
			prev_ob=0;
		 }
	     	else
		 {
		    clone_ob=clone_object(temp);
		    prev_ob=clone_ob->u.ob;
		 }
		reset_jump_state(erc);
	  }
       if(!check_object(prev_ob)) continue;
       (void)sprintf(num,"%d",object_count);
       res_file=xalloc(strlen(dir)+16); /* allow enough for container too */
       (void)strcpy(res_file,dir);
       (void)strcat(res_file,"/item");
       (void)strcat(res_file,num);
       num[0]='\0';
       if(container) 
	{
	   (void)sprintf(num,"%d",tcount); /* add on container sufix */
	   (void)strcat(res_file,"-");
	   (void)strcat(res_file,num);
	   num[0]='\0';
	}
      if(!restore_object(prev_ob,res_file,0)) 
        { 
	   free(res_file);
	   destruct_object(prev_ob,0);
	   prev_ob=0;
	   continue;
	}
      if(container) do_move_inv(prev_ob,container);
	else do_move_inv(prev_ob,ob);
      free(res_file);
      if(check_object(prev_ob) && prev_ob->fun_p[9]) 
       {
	 set_jump_state(erc,&jmp);
	 if(!setjmp(error_recovery_context))
	     (void)apply(prev_ob->fun_p[9],0,prev_ob,&const0,0);
		  else clear_jump_state(&jmp);
	 reset_jump_state(erc);
         if(!check_object(prev_ob)) prev_ob=0;
       }
      ret=1;
   }
 eval_cost=0;
 return ret;
}


int check_object(ob)
 register OBJECT *ob;
{
  return _check_object(ob);
}

int _check_object(ob)
 register OBJECT *ob;
{
  if(ob && ob->flags && !(ob->flags & DEST)) return 1;
 return 0;
}

void clear_object(ob)
	OBJECT *ob;
{
#if 1
	memset((char *)ob,'\0',sizeof (struct object));
#else
	ob->flags=0;
	ob->not_touched=0;
	ob->total_light=0;
	ob->num_variables=0;
	ob->swap_num=0;
	ob->num_ref=0;
	ob->swap_size=0;
	ob->logged=0;
	ob->block=0;
	ob->name=0;
	ob->living_name=0;
	ob->realm=0;
	ob->prog=0;
	ob->status=0;
	ob->interactive=0;
	ob->verbs=0;
	ob->ed_buffer=0;
	ob->wl=0;
	ob->inherit=0;
	ob->links[0]=0;
  	ob->links[1]=0;
 	ob->reset=0;
	ob->fun_p[0]=0;
	ob->fun_p[1]=0;
	ob->fun_p[2]=0;
	ob->fun_p[3]=0;
	ob->fun_p[4]=0;
	ob->fun_p[5]=0;
	ob->fun_p[6]=0;
	ob->fun_p[7]=0;
	ob->fun_p[8]=0;
	ob->fun_p[9]=0;
	ob->ref_ob[0]=0;
	ob->ref_ob[1]=0;
	ob->ref_ob[2]=0;
	ob->ref_ob[3]=0;
	ob->ref_ob[4]=0;
	ob->ref_ob[5]=0;
	ob->variables=0;
#endif
}

void pre_load_pointers(ob)
 register OBJECT *ob;
{
    ob->reset=find_fun_p("reset",ob,0);
    ob->fun_p[0]=find_fun_p("query_can_drop",ob,0);
    ob->fun_p[1]=find_fun_p("drop",ob,0);
    ob->fun_p[2]=find_fun_p("query_weight",ob,0);
    ob->fun_p[3]=find_fun_p("add_weight",ob,0);
    ob->fun_p[4]=find_fun_p("init",ob,0);
    ob->fun_p[5]=find_fun_p("exit",ob,0);
    ob->fun_p[6]=find_fun_p("id",ob,0);
    ob->fun_p[7]=find_fun_p("catch_tell",ob,0);
    ob->fun_p[8]=find_fun_p("extra_save",ob,0);
    ob->fun_p[9]=find_fun_p("extra_restore",ob,0);
}

void load_mcp()
{
int i;
jmp_buf erc;
struct jmp_globals jmp;
extern struct realms *load_realm;

    if(mcp.ob) for(i=0;i<4;i++) free_fun_p(mcp.fun_p[i]);

    set_jump_state(erc,&jmp);
    if(!setjmp(error_recovery_context)) 
      {
       mcp.ob=0;
       mcp.ob=load_object(sys_realm,"closed/mcp");
      }
	 else {mcp.ob=0;clear_jump_state(&jmp);}

    reset_jump_state(erc);

    if(!mcp.ob)
      if(load_realm) fatal("Could not load 'closed/mcp' unable to start mud.\n");
	  else fatal("Could not load 'closed/mcp' mud terminated.\n");
	else
         {
	   if(!(mcp.fun_p[0]=find_fun_p("valid_read",mcp.ob,0)))
		fatal("Could not locate 'valid_read' in closed/mcp.\n");
	   if(!(mcp.fun_p[1]=find_fun_p("valid_write",mcp.ob,0)))
		fatal("Could not locate 'valid_write' in closed/mcp.\n");
	   if(!(mcp.fun_p[2]=find_fun_p("rectify_path",mcp.ob,0)))
		fatal("Could not locate 'rectify_path' in closed/mcp.\n");
	   if(!(mcp.fun_p[3]=find_fun_p("allow_snoop",mcp.ob,0)))
		fatal("Could not locate 'allow_snoop' in closed/mcp.\n");
	   if(!(mcp.fun_p[4]=find_fun_p("query_dest",mcp.ob,0)))
		fatal("Could not locate 'query_dest' in closed/mcp.\n");
	   debug_message(sys_realm,"MCP has been initialized.\n");
         }
}
