#ifndef M_XENIX
#include <stdlib.h>
#endif
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include "config.h"
#include "lint.h"
#include "lnode.h"
#include "object.h"
#include "lint2.h"
#include "lang.h"
#include "realms.h"
#include "sent.h"
#include "wiz_list.h"
#include "lan_fun.h"
#include "o_hash.h"
#include "error.h"
#include "s_hash.h"

#ifdef DRAND48
extern double	drand48 PROT((void));
extern void	srand48 PROT((long));
#endif

extern REALMS *sys_realm;

extern int	file_size PROT((char *)),
		check_object(),
		_check_object(),
		command_for_object(),
		swap PROT((OBJECT *)),
		remove_call_out PROT((OBJECT *,  char *,int)),
		set_heart_beat(),
		link(),
		unlink(),
		tail PROT((char *));

extern VALUE    *allocate_array PROT((unsigned short)),
		*query_call_out PROT((OBJECT *,char *)),
		*query_load_av(),
	        *slice_array(),
		*query_snoop PROT((OBJECT *)),
		*copy_svalue PROT((struct svalue *)),
		*this_player(),
		*this_object(),
		*first_inventory PROT((VALUE *)),
		*last_inventory PROT((VALUE *)),
		*next_prev_inventory PROT((VALUE *,int)),
		*environment PROT((VALUE *)),
		*print_file PROT((char *,int,int,int)),
		*input_to PROT((OBJECT *,char *,int,VALUE *)),
		*inter_sscanf PROT((LNODE *)),
		*explode_string PROT((char *,char *)),
		*users PROT((int)),
		*new_player_link PROT((OBJECT *,OBJECT *,VALUE *)),
		*object_present PROT((VALUE *,OBJECT *));

extern OBJECT   *find_link PROT((OBJECT *)),
		*find_player PROT((char *,int)),
		*find_object PROT((char *)),
		*find_object2 PROT((char *,int)),
		*find_living_object PROT((char *,int)),
                *used_object PROT((OBJECT *));

extern char     *query_ed PROT((OBJECT *)),
		*get_error_file PROT((char *,char *)),
 		*string_copy(),
		*check_file_name PROT((char *,int,int)),

#ifndef M_XENIX
# ifdef sun
		*_crypt PROT((char *,char *)),
# else
		*crypt PROT((char *,char *)),
# endif
#endif
		*query_prompt PROT((OBJECT *)),
		ret_type PROT((int,int));

extern void     set_prompt PROT((char *, OBJECT *)),
		set_living_name(),
		set_notify_fail_message(),
		remove_file(),
		assign(),
		log_file(),
		do_write(),
		set_snoop(),
		ed_start(),
		say(),
		tell_room(),
		add_light(),
		shout_string PROT((char *,int)),
		del_element PROT((VECTOR *,int)),
		write_file PROT((char *,char *,int)),
		shutdowngame PROT((int)),
		print_local_commands PROT((OBJECT *,OBJECT *)),
		new_call_out PROT((OBJECT *, char *, int, VALUE *)),
		add_action PROT((char *, char *, int)),
		list_files PROT((char *)),
		enable_commands PROT((int)),
		load_ob_from_swap PROT((OBJECT *)),
		do_error PROT((char *,char *));

extern VALUE    *print_expr_list();

extern void 	free_ob_status();


extern VALUE		*get_one_expr(),
			*print_expr();

extern struct object_status *ob_status[];

extern VALUE	*switch_arg;

extern LNODE	*case_def;

extern char	case_match, break_flag, break_level;

extern struct sentence *last_verb;

extern int	eval_cost;

extern struct lnode_2  *next_arg_list_to_use;

#ifdef AIX
signed char	random_count;  /* used for making random numbers */
#else
char random_count;
#endif
/*
 * This variable is set to true when return is called inside a function,
 * or when the current object(ob_status[0]->ob) is destructed.
 */

extern int	stop_function;

/*
 * This is used for 'break' in while-statements.
 */


extern VALUE	*catch_value,		/* Used to throw an error to a catch */
		*return_value;		/* Here is a value when "return". */

VALUE *f_mod_eq(p)
	LNODE *p;
{
	VALUE *arg1,*arg2,*ret= &const0;
	char cmd[5];

	 if(p->fun==f_mod) (void)strcpy(cmd,"'%'");
		else (void)strcpy(cmd,"'%='");

	 arg1 = print_expr(p->a1);
	 if (numchk(arg1,T_INT)) do_error("1st",cmd);

	 arg2 = print_expr(p->a2);
	 if (numchk(arg2,T_INT)) do_error("2nd",cmd);

	 if (!arg2->u.n_int) error(ob_status[0]->ob->realm,"Modulus by zero.");

	 ret = make_number(arg1->u.n_int % arg2->u.n_int,0.0,0);

	 if(p->fun==f_mod_eq) assign(p->a1,ret);

	return ret;
}

VALUE *f_string(p)
	LNODE *p;
{
	return make_string(((struct lnode_name *)p)->name);
}

VALUE *f_add_action(p)
	LNODE *p;
{
	VALUE *arg,*arg1,*arg2;
	LNODE *l=p->a1;

 	arg1 = get_one_expr(&l, "add_action");
 	if (strchk(arg1,1)) do_error("1st","add_action");

 	arg2 = get_one_expr(&l, "add_action");
 	if (strchk(arg2,0) && pointchk(arg2)) do_error("2nd","add_action");

 	arg = get_one_expr(&l, 0);
 	if (arg && (numchk(arg,T_INT) || arg->u.n_int<0 || arg->u.n_int>2))
	 	do_error("3rd","add_action");

	if(!strchk(arg2,0))
   		add_action(arg1->u.string, arg2->u.string, arg ? arg->u.n_int : 0);
	else
  	{
		int i,flag=arg ? arg->u.n_int : 0;
		VECTOR *arr;

		arr=arg2->u.vec;
		for(i=0;i<arr->size;i++)
  		{
			if(arr->item[i].type!=T_STRING) 
				error(ob_status[0]->ob->realm,"Bad %d element in verb array.\n",i);
			add_action(arg1->u.string,arr->item[i].u.string,flag);
  		}
  	}
   return &const0;
}

VALUE *f_allocate(p)
	LNODE *p;
{
	VALUE *arg;

	arg = print_expr_list(p->a1);
	if (numchk(arg,T_INT) || arg->u.n_int<1) do_error("1st","allocate");
	return allocate_array((unsigned short)arg->u.n_int);
}

VALUE *f_extract(p)
	LNODE *p;
{
	VALUE *arg,*arg1,*arg2,*ret;
	char *temp1;
	int len, from, to;
	LNODE *l=p->a1;

	arg = get_one_expr(&l,"extract");
	if(strchk(arg,1) && pointchk(arg)) do_error("1st","extract");
	if(arg->type==T_STRING) len = strlen(arg->u.string);
           else len=arg->u.vec->size;

	arg1 = get_one_expr(&l,"extract");

	if (!arg1 || numchk(arg1,T_INT) || arg1->u.n_int<0)
	 do_error("2nd","extract");

	from = arg1->u.n_int;

	if (from >= len)  error(ob_status[0]->ob->realm,"extract: Invalid index '%d'.\n",from);

	arg2 = get_one_expr(&l,0);

	if (!arg2 || arg2->u.n_int==len-1) 
	  {
	     if(arg->type==T_STRING)
	      {
        	ret=make_string( arg->u.string + from );
    	        ret->constant = 1;
    	        return ret;
	      }
	     return slice_array(arg,from,arg->u.vec->size-1);
	  }

	if (numchk(arg2,T_INT) || arg2->u.n_int<arg1->u.n_int) 
			do_error("3rd","extract");

	to = arg2->u.n_int;
	if (to < from)  error(ob_status[0]->ob->realm,"extract: invalid range, '%d' to '%d'.\n",from,to);

	if (to >= len) error(ob_status[0]->ob->realm,"extract: index '%d' out of range.\n",to);

        if(arg->type==T_POINTER) return slice_array(arg,from,to);

	temp1 = xalloc(to - from + 2);
	(void)strncpy(temp1, arg->u.string + from, to - from + 1);
	temp1[to - from + 1] = '\0';
	ret=make_string(temp1);
	free(temp1);
	return ret;
}

VALUE *f_braced_extract(p)
	LNODE *p;
{
	VALUE *arg,*arg1,*arg2,*ret;
	char *temp1;
	int len, from, to;

	arg = print_expr(p->a1);
	if(strchk(arg,1) && pointchk(arg)) do_error("1st","extract");
	if(arg->type==T_STRING) len = strlen(arg->u.string);
           else len=arg->u.vec->size;

	arg1 = print_expr(p->a2);

	if (numchk(arg1,T_INT) || arg1->u.n_int<0) do_error("2nd","extract");

	from = arg1->u.n_int;

	if (from >= len)  error(ob_status[0]->ob->realm,"extract: Invalid index '%d'.\n",from);

	arg2 = print_expr(p->a3);

	if (!arg2 || arg2->u.n_int==len-1) 
	  {
	     if(arg->type==T_STRING)
	      {
        	ret=make_string( arg->u.string + from );
    	        ret->constant = 1;
    	        return ret;
	      }
	     return slice_array(arg,from,arg->u.vec->size-1);
	  }

	if (numchk(arg2,T_INT) || arg2->u.n_int<arg1->u.n_int) 
			do_error("3rd","extract");

	to = arg2->u.n_int;
	if (to < from)  error(ob_status[0]->ob->realm,"extract: invalid range, '%d' to '%d'.\n",from,to);

	if (to >= len) error(ob_status[0]->ob->realm,"extract: index '%d' out of range.\n",to);

        if(arg->type==T_POINTER) return slice_array(arg,from,to);

	temp1 = xalloc(to - from + 2);
	(void)strncpy(temp1, arg->u.string + from, to - from + 1);
	temp1[to - from + 1] = '\0';
	ret=make_string(temp1);
	free(temp1);
	return ret;
}

VALUE *f_strstr(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;
	char *temp1;

	arg=get_one_expr(&l,"strstr");
	if(strchk(arg,0)) do_error("1st","strstr");

	arg1=get_one_expr(&l,"strstr");
	if(strchk(arg,0)) do_error("1st","strstr");

	temp1=strstr(arg->u.string,arg1->u.string);

	if(temp1) return make_string(temp1);
	return &const0;
}

VALUE *f_strrchr(p)
	LNODE *p;
{
	return f_strchr(p);
}

VALUE *f_strchr(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	char *temp1,cmd[8];
	LNODE *l=p->a1;

  	if(p->fun==f_strchr) (void)strcpy(cmd,"strchr");
		else (void)strcpy(cmd,"strrchr");

  	arg=get_one_expr(&l,cmd);
  	if(strchk(arg,0)) do_error("1st",cmd);

  	arg1=get_one_expr(&l,cmd);
  	if(numchk(arg1,T_INT) || arg1->u.n_int<0 || arg1->u.n_int>127)
			 do_error("2nd",cmd);

 	if(p->fun==f_strchr) temp1=strchr(arg->u.string,arg1->u.n_int);
  	  else temp1=strrchr(arg->u.string,arg1->u.n_int);

 	if(temp1) return make_string(string_copy(temp1));
	return &const0;
}

VALUE *f_strncmp(p)
	LNODE *p;
{
	VALUE *arg,*arg1,*arg2;
	LNODE *l=p->a1;

  arg=get_one_expr(&l,"strncmp");
  if(strchk(arg,0)) do_error("1st","strncmp");

  arg1=get_one_expr(&l,"strncmp");
  if(strchk(arg1,0)) do_error("2nd","strncmp");

  arg2=get_one_expr(&l,"strncmp");
  if(numchk(arg2,T_INT)) do_error("3rd","strncmp");

  if(strlen(arg1->u.string)<arg2->u.n_int &&
	 strlen(arg->u.string)<arg2->u.n_int)
		error(ob_status[0]->ob->realm,"Invalid Indexing in third argument to strncmp().\n");

  return make_number(strncmp(arg->u.string,arg1->u.string,arg2->u.n_int),0.0,0);
}

VALUE *f_switch(p)
	LNODE *p;
{
	VALUE *save_switch_arg=switch_arg;
	LNODE *save_case_def=case_def;

	switch_arg=print_expr(p->a1);

	break_level++;

	(void)print_expr(p->a2);

	if(case_def && !case_match)
	  {
	   case_match=2;
	   (void)print_expr(case_def);
	  }

	break_level--;
	break_flag=0;

	switch_arg=save_switch_arg;

	case_def=save_case_def;
	case_match=0;

	return &const0;
}

VALUE *f_case(p)
	LNODE *p;
{
	VALUE *arg;

	 if(!switch_arg) error(ob_status[0]->ob->realm,"case: without 'switch()'\n");
	 if(case_match || break_flag) return &const0;

	 case_match=1;
	 arg=print_expr(p->a1);
	 case_match=0;

	 if(arg->type!=switch_arg->type) return &const0;

	 switch(arg->type)
		{
		   case T_STRING:
				if(!strcmp(arg->u.string,switch_arg->u.string))
					case_match=1;
				break;

		   case T_INT:
				if(arg->u.n_int==switch_arg->u.n_int)
					case_match=1;

		   case T_FLOAT:
				if(arg->u.n_float==switch_arg->u.n_float) 
					case_match=1;
			    break;

		   case T_OBJECT:
				if(arg->u.ob==switch_arg->u.ob)
				    case_match=1;
				break;

		   defualt:
				do_error("Illegal type argument to case.\n",0);
		}

	 return &const0;
}

VALUE *f_default(p)
	LNODE *p;
{

	if(!switch_arg) error(ob_status[0]->ob->realm,"default: without 'switch()'\n");
	case_match=1;
	return &const0;
}

VALUE *f_while(p)
	LNODE *p;
{

    /*
     * We come to the next statement in three ways:
     * 0: Set up of long jump.
     * 1: break statement.
     * 2: continue statement.
     */

    break_level++;

    while(!stop_function && !break_flag)
	  {
		VALUE *arg;

		arg = print_expr(p->a1);

		if(!arg || ((arg->type==T_INT && !arg->u.n_int) ||
		    (arg->type==T_FLOAT && !arg->u.n_float)))
			break;

		(void)print_expr(p->a2);

		if(break_flag==2) break_flag=0;

		if (!check_object(ob_status[0]->ob)) 
		  {
	    	return_value = &const0;
	    	stop_function = 1;
		  }
       }

    break_flag=0;
    break_level--;

    return &const0;
}

VALUE *f_do(p)
	LNODE *p;
{

    /*
     * We come to the next statement in three ways:
     * 0: Set up of long jump.
     * 1: break statement.
     * 2: continue statement.
     */

    break_level++;

    while(!stop_function && !break_flag) 
	  {
		VALUE *arg;

		(void)print_expr(p->a1);

		if(break_flag==2) break_flag=0;

		arg = print_expr(p->a2);

		if(!arg ||
		   ((arg->type==T_INT && !arg->u.n_int) ||
		    (arg->type==T_FLOAT && !arg->u.n_float)))
			break;

		if (!check_object(ob_status[0]->ob)) 
		  {
	    	return_value = &const0;
	    	stop_function = 1;
	      }
       }

    break_flag=0;
    break_level--;

    return &const0;
}

VALUE *f_for(p)
	LNODE *p;
{

    /*
     * We come to the next statement in three ways:
     * 0: Set up of long jump.
     * 1: break statement.
     * 2: continue statement.
     */

    break_level++;

    while(!stop_function && !break_flag) 
	 {
		VALUE *arg;

		arg = print_expr(p->a1);

		if(!arg ||
		   ((arg->type==T_INT && !arg->u.n_int) ||
		    (arg->type==T_FLOAT && !arg->u.n_float)))
			break;

		(void)print_expr(p->a3);

		if(break_flag==2) break_flag=0;

		if(!break_flag) (void)print_expr(p->a2);

		if (!check_object(ob_status[0]->ob)) 
		  {
	    	return_value = &const0;
	    	stop_function = 1;
		  }
      }

    break_flag=0;
    break_level--;

    return &const0;
}

VALUE *f_subscript(p)
	LNODE *p;
{
	VALUE *arg1,*arg2,*ret;
	int i;

	arg1 = print_expr(p->a1);
	if(strchk(arg1,0) && pointchk(arg1)) do_error("1st","'[]'");

	arg2 = print_expr(p->a2);
	if(numchk(arg2,T_INT) || arg2->u.n_int<0) do_error("2nd","'[]'");

	if (!pointchk(arg1)) 
	  {
	    i = arg2->u.n_int;

	    if (i && i >= arg1->u.vec->size)
			error(ob_status[0]->ob->realm,"Illegal index size: %d\n", i);

	    return copy_svalue(&arg1->u.vec->item[i]);
	  }

	if (arg2->u.n_int && arg2->u.n_int >= strlen(arg1->u.string))
	    error(ob_status[0]->ob->realm,"Illegal index size: %d\n",arg2->u.n_int);

        return make_number(arg1->u.string[arg2->u.n_int],0.0,0);
}

VALUE *f_clone_object(p)
	LNODE *p;
{
	VALUE *ret,*arg1;

	arg1 = print_expr_list(p->a1);
	if(strchk(arg1,1)) do_error("1st","clone_object");

	return clone_object(arg1->u.string);
}

VALUE *f_save_object(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg = get_one_expr(&l,"save_object");
	if(strchk(arg,1)) do_error("1st","save_object");

	arg1=get_one_expr(&l,0);
	if(arg1 && objchk(arg1)) do_error("2nd","save_object");

	if(arg1 && arg1->u.ob->flags & NO_EXT_SAVE)
   		error(ob_status[0]->ob->realm,"Extern call to save_object() not permited on this object.\n");

	return make_number(save_object(arg1 ? arg1->u.ob:ob_status[0]->ob, arg->u.string,arg1?0:1),0.0,0);
}

VALUE *f_find_object(p)
	LNODE *p;
{
	VALUE *arg,v;
	OBJECT *ob;
	char *file;

	arg = print_expr_list(p->a1);
	if(strchk(arg,1)) do_error("1st","find_object");

#if 0
        v.type=T_STRING;
	v.u.string=ob_status[0]->ob->realm->realm_dir;

        arg=apply(mcp.fun_p[2],0,mcp.ob,arg,&v);

	if(!arg || strchk(arg,1)) do_error("1st","find_object");
#endif

	ob = find_object2(arg->u.string,0);

	if (!ob) return &const0;

	return make_object(ob);
}

VALUE *f_find_player(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;
	extern int num_player;

	arg = get_one_expr(&l,"find_player");
	if(strchk(arg,1)) do_error("1st","find_player");

	arg1=get_one_expr(&l,0);
   	if(arg1 && (numchk(arg1,T_INT) || arg1->u.n_int>num_player))
		do_error("2nd","find_player");

	return make_object(find_player(arg->u.string, arg1?arg1->u.n_int:0));
}

VALUE *f_find_living(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg = get_one_expr(&l,"find_living");
	if(strchk(arg,1)) do_error("1st","find_living");

	arg1= get_one_expr(&l,0);
	if(arg1 && (numchk(arg1,T_INT) || arg1->u.n_int<1)) do_error("2nd","find_living");

	return make_object(find_o_hash(arg->u.string,cf.ltable,l_table,0));
}

VALUE *f_tell_object(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	OBJECT *ob;
	LNODE *l=p->a1;

	arg = get_one_expr(&l, "tell_object");
	if(strchk(arg,1) && objchk(arg)) do_error("1st","tell_object");

	if(!strchk(arg,1)) ob=find_object(arg->u.string);
		else ob=arg->u.ob;

	if(!ob || (ob_status[0]->ob->realm!=sys_realm && ob_status[0]->ob->realm!=ob->realm)) return &const0;

	arg1 = get_one_expr(&l, "tell_object");

	tell_object(ob, arg1);

	return &const0;
}

VALUE *f_restore_object(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg = get_one_expr(&l,"restore_object");
	if(strchk(arg,1)) do_error("1st","restore_object");

	arg1=get_one_expr(&l,0);
	if(arg1 && objchk(arg1)) do_error("2nd","restore_object");

	if(arg1 && arg1->u.ob->flags & NO_EXT_SAVE)
		error(ob_status[0]->ob->realm,"external call to restore_object() n this object is not allowed.\n");

	return make_number(restore_object(arg1 ? arg1->u.ob:ob_status[0]->ob, arg->u.string,arg1?0:1),0.0,0);
}

VALUE *f_this_player(p)
	LNODE *p;
{
	return this_player();
}

VALUE *f_move_object(p)
	LNODE *p;
{
	VALUE *arg1,*arg2,*arg;
	LNODE *l=p->a1;
	OBJECT *ob,*ob2;

 	arg1 = get_one_expr(&l, "move_object");
 	if(strchk(arg1,1) && objchk(arg1)) do_error("1st","move_object");

	arg2 = get_one_expr(&l, "move_object");
	if(strchk(arg2,1) && objchk(arg2)) do_error("2nd","move_object");

	if (!objchk(arg1)) ob = arg1->u.ob;
  		else {
    		ob = find_object(arg1->u.string);
    		if (!ob) error(ob_status[0]->ob->realm,"Object %s not found.\n", arg1->u.string);
  		}

 	if (!objchk(arg2)) ob2 = arg2->u.ob;
  		else {
    		ob2 = find_object(arg2->u.string);
    		if (!ob2) error(ob_status[0]->ob->realm,"Object %s not found.\n",arg2->u.string);
  		}

	arg=get_one_expr(&l,0);
	if(arg && (numchk(arg,T_INT) || arg->u.n_int<0 || arg->u.n_int>1))
		do_error("3rd","move_object");

 	if (!check_object(ob))
     	error(ob_status[0]->ob->realm,"move_object() of destructed object.\n");

 	if (!check_object(ob2))
     	error(ob_status[0]->ob->realm,"move_object() to destructed object.\n");

        if(ob_status[0]->ob->realm!=sys_realm)
           {
              if(!check_realm_access(0,ob))
		error(ob_status[0]->ob->realm,"Illegal move on %s.\n",ob->name);

              if(!check_realm_access(0,ob2))
		error(ob_status[0]->ob->realm,"Illegal move on %s.\n",ob2->name);
           }
 	move_object(ob, ob2,arg?arg->u.n_int:0,0);
	return &const0;
}

VALUE *f_first_inventory(p)
	LNODE *p;
{
	VALUE *arg;

	arg = print_expr_list(p->a1);
	if(strchk(arg,1) && objchk(arg)) do_error("1st","fist_inventory");

	return first_inventory(arg);
}

VALUE *f_next_inventory(p)
	LNODE *p;
{
	VALUE *arg;

	arg = print_expr_list(p->a1);
	if(strchk(arg,1) && objchk(arg)) do_error("1st","next_inventory");

	return next_prev_inventory(arg,0);
}

VALUE *f_previous_inventory(p)
	LNODE *p;
{
	VALUE *arg;

	arg=print_expr_list(p->a1);
	if(strchk(arg,1) && objchk(arg)) do_error("1st","previous_inventory");

	return next_prev_inventory(arg,1);
}

VALUE *f_last_inventory(p)
	LNODE *p;
{
	VALUE *arg;

	arg=print_expr_list(p->a1);
	if(strchk(arg,1) && objchk(arg)) do_error("1st","last_inventory");

	return last_inventory(arg);
}

VALUE *f_environment(p)
	LNODE *p;
{
	VALUE *arg;

	arg = print_expr_list(p->a1);
	if(arg && strchk(arg,1) && objchk(arg)) do_error("1st","environment");

	return environment(arg);
}

VALUE *f_this_object(p)
	LNODE *p;
{
	return this_object();
}

VALUE *f_previous_object(p)
	LNODE *p;
{
	if (!ob_status[0] || !ob_status[1] || ob_status[1]->ob==command_giver)
		 return &const0;

	return make_object(ob_status[1]->ob);
}

VALUE *f_destruct(p)
	LNODE *p;
{
	VALUE *arg;

	arg = print_expr_list(p->a1);
	if (strchk(arg,1) && objchk(arg)) do_error("1st","destruct");

	if(!strchk(arg,1)) destruct_object(0,arg->u.string);
	   else destruct_object(arg->u.ob,0);

	return &const0;
}

VALUE *f_random(p)
	LNODE *p;
{
	VALUE *arg,*ret;

	arg = print_expr_list(p->a1);
	if (numchk(arg,T_INT) || arg->u.n_int<0) do_error("1st","random");

	if(!arg->u.n_int) return &const0;

	++random_count;
	if(random_count<0) random_count=0;

#ifdef DRAND48

  	srand48(time(0)^(long)(random_count));
  	ret = make_number((int)(drand48()*arg->u.n_int),0.0,0);

#else
#ifdef RANDOM

	srandom(time(0)^(long)(random_count));
	ret = make_number( (int) (random() % arg->u.n_int) ,0.0,0 );

#else

	ret = make_number((((int)arg + (int) ret)>>2 + time(0l)) % arg->u.n_int,0.0,0);

#endif /* RANDOM */
#endif /* DRAND48 */
	return ret;
}

VALUE *f_say(p)
	LNODE *p;
{
	VALUE *arg1,*arg2;
	LNODE *l=p->a1;

	arg1 = get_one_expr(&l, "say");

	arg2 = get_one_expr(&l, 0);
	if (arg2 && objchk(arg2)) do_error("2nd","say");

	say(arg1, arg2 ? arg2->u.ob:0,0);

	return &const0;
}

VALUE *f_tell_room(p)
	register LNODE *p;
{
	register VALUE *arg1,*arg2,*arg;
	OBJECT *ob,*ob2;
	LNODE *l=p->a1;

    arg1 = get_one_expr(&l, "tell_room");
    if(strchk(arg1,1) && objchk(arg1)) do_error("1st","tell_room");

    if(strchk(arg1,1)) ob=arg1->u.ob;
		else ob=find_object(arg1->u.string);

    if(!check_object(ob)) do_error("1st","tell_room");

    arg2 = get_one_expr(&l, "tell_room");

    arg=get_one_expr(&l, 0);

    if(arg)
      {
        if(objchk(arg) && strchk(arg,1)) do_error("3rd","tell_room");
	    if(strchk(arg,1)) ob2=arg->u.ob;
	      else  ob2=find_object(arg->u.string);
	    if(!check_object(ob2)) do_error("3rd","tell_room");
	  }

    tell_room(ob, arg2,arg ? ob2:0);

	return &const0;
}

VALUE *f_shout(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;

	arg = get_one_expr(&l, "shout");
	if (strchk(arg,0)) do_error("1st","shout");

	shout_string(arg->u.string,0);
	return &const0;
}

VALUE *f_sscanf(p)
	LNODE *p;
{
		return inter_sscanf(p->a1);
}

VALUE *f_enable_commands(p)
	LNODE *p;
{
	VALUE *arg;

	arg=print_expr_list(p->a1);
	if(arg && (numchk(arg,T_INT) || arg->u.n_int<0 || arg->u.n_int>1)) 
			do_error("1st","enable_commands");

	enable_commands(arg?arg->u.n_int:1);
	return &const0;
}

VALUE *f_present(p)
	LNODE *p;
{
	VALUE *arg1,*arg2;
	LNODE *l=p->a1;

	arg1 = get_one_expr(&l, "present");
	if (strchk(arg1,1) && objchk(arg1)) do_error("1st","present");

	arg2 = get_one_expr(&l,0);
	if (arg2 && objchk(arg2)) do_error("2nd","present");

	return object_present(arg1, arg2 ? arg2->u.ob:0);
}

VALUE *f_set_light(p)
	LNODE *p;
{
	VALUE *arg,*ret;
	OBJECT *ob;

	arg = print_expr_list(p->a1);
	if (arg && numchk(arg,T_INT)) do_error("1st","set_light");

	add_light(ob_status[0]->ob,arg->u.n_int);

	ret = alloc_value();
	ret->type = T_INT;

	ob = ob_status[0]->ob;

	while(ob->ref_ob[0]) ob = ob->ref_ob[0];

	ret->u.n_int = ob->total_light;

	return ret;
}

VALUE *f_set_heart_beat(p)
	LNODE *p;
{
	VALUE *arg;

	arg = print_expr_list(p->a1);
	if (numchk(arg,T_INT) || arg->u.n_int<0 || arg->u.n_int>1)
		 do_error("1st","set_heart_beat");

	if (set_heart_beat(ob_status[0]->ob, arg->u.n_int)) return &const1;

	return &const0;
}

VALUE *f_strlen(p)
	LNODE *p;
{
	VALUE *arg,*ret;

	arg = print_expr_list(p->a1);
	if(!arg || arg->type!=T_STRING) do_error("1st","strlen");

	ret = alloc_value();
	ret->type = T_INT;

   	if(!arg->u.string) ret->u.n_int=0;
         else ret->u.n_int = strlen(arg->u.string);

	return ret;
}

VALUE *f_sizeof(p)
	LNODE *p;
{
	VALUE *arg;

	arg = print_expr_list(p->a1);
	return make_number(pointchk(arg)?0:arg->u.vec->size,0.0,0);
}

VALUE *f_implode(p)
	LNODE *p;
{
	register VALUE *arg,*arg1;
	register char *tmp;
	VALUE *implode_string PROT((struct vector *,char *));
	LNODE *l=p->a1;

	arg = get_one_expr(&l, "implode");
	if(pointchk(arg)) do_error("1st","implode");

	arg1 = get_one_expr(&l, "implode");

	if(strchk(arg1,1))
          {
	    if(numchk(arg1,T_INT) || arg1->u.n_int<0 ||
	       arg1->u.n_int>127) do_error("2nd","implode");

	    tmp=xalloc(2);
	    tmp[0]=(unsigned char)arg1->u.n_int;
	    tmp[1]=0;
	  }
	else tmp=string_copy(arg1->u.string);

	return implode_string(arg->u.vec, tmp);
}

VALUE *f_explode(p)
	LNODE *p;
{
	register char *tmp;
	register VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg = get_one_expr(&l, "explode");
	if(strchk(arg,1)) do_error("1st","explode");

	arg1 = get_one_expr(&l, "explode");

        if(strchk(arg1,1))
	 {
	   if(numchk(arg1,T_INT) || arg1->u.n_int<0 ||
	      arg1->u.n_int>127) do_error("2nd","explode");

	   tmp=xalloc(2);
	   tmp[0]=(unsigned char)arg1->u.n_int;
	   tmp[1]=0;
         }
	else tmp=string_copy(arg1->u.string);

	return explode_string(arg->u.string, tmp);
}

VALUE *f_clear_bit(p)
	LNODE *p;
{
	return f_test_bit(p);
}

VALUE *f_set_bit(p)
	LNODE *p;
{
	return f_test_bit(p);
}

VALUE *f_test_bit(p)
	register LNODE *p;
{
	int new_bits=0;

	register VALUE *arg,*arg1,*ret;
	LNODE *l=p->a1;
	char cmd[10];

	if(p->fun==f_clear_bit) (void)strcpy(cmd,"clear_bit");
		else if(p->fun==f_set_bit) (void)strcpy(cmd,"set_bit");
			else (void)strcpy(cmd,"test_bit");

	arg  = get_one_expr(&l,cmd);
	if (numchk(arg,T_INT)) do_error("1st",cmd);

	arg1 = get_one_expr(&l,cmd); 
	if(numchk(arg1,T_INT) || arg1->u.n_int<0) do_error("2nd",cmd);

	if(p->fun==f_clear_bit)
	  {
	     new_bits=arg->u.n_int;
	     new_bits&=~(1<<arg1->u.n_int);
	  }
	else if(p->fun==f_test_bit)
		{ 
		   if(arg->u.n_int&1<<arg1->u.n_int) return &const1;
			else return &const0;
		}
	     else 
		{
		  new_bits=arg->u.n_int;
   		  new_bits|=1<<arg1->u.n_int;
		}
	ret=make_number(new_bits,0.0,0);
	if(p->a1->a1->fun==f_identifier) 
		assign(p->a1->a1,ret);
	
	return ret;
}

VALUE *f_del_element(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"del_element");
	if(pointchk(arg)) do_error("1st","del_element");

	arg1=get_one_expr(&l,"del_element");
	if(numchk(arg1,T_INT) || arg1->u.n_int<0) do_error("2nd","del_element");

	if(arg1->u.n_int>=arg->u.vec->size)
		error(ob_status[0]->ob->realm,"Bad indexing of array in del_element()\n");

	del_element(arg->u.vec,arg1->u.n_int);
	return arg;
}

VALUE *f_slice_array(p)
	LNODE *p;
{
	VALUE *arg,*arg1,*arg2;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"slice_array");
	if(pointchk(arg)) do_error("1st","slice_array");

	arg1=get_one_expr(&l,"slice_array");
	if(numchk(arg1,T_INT) || arg1->u.n_int<0) do_error("2nd","slice_array");

	arg2=get_one_expr(&l,0);
	if(arg2 && (numchk(arg2,T_INT) || arg2->u.n_int<arg1->u.n_int))
	 		do_error("3rd","slice_array");

	return slice_array(arg,arg1->u.n_int,arg2?arg2->u.n_int:0);
}

VALUE *f_pow(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"pow");
	if(numchk(arg,T_FLOAT)) do_error("1st","pow");

	arg1=get_one_expr(&l,"pow");
	if(numchk(arg1,T_FLOAT)) do_error("2nd","pow");

	return make_number(0,pow(arg->u.n_float,arg1->u.n_float),1);
}

VALUE *f_exp(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"exp");
	if(numchk(arg,T_FLOAT)) do_error("1st","exp");

	return make_number(0,exp(arg->u.n_float),1);
}

VALUE *f_floor(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"floor");
	if(numchk(arg,T_FLOAT)) do_error("1st","floor");

	return make_number(0,floor(arg->u.n_float),1);
}

VALUE *f_ceil(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"ceil");
	if(numchk(arg,T_FLOAT)) do_error("1st","ceil");

	return make_number(0,ceil(arg->u.n_float),1);
}

VALUE *f_sqrt(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"sqrt");
	if(numchk(arg,T_FLOAT)) do_error("1st","sqrt");

	return make_number(0,sqrt(arg->u.n_float),1);
}

VALUE *f_abs(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;
#ifndef linux
	extern int abs();
#endif

	arg=get_one_expr(&l,"abs");
	if(numchk(arg,T_INT)) do_error("1st","abs");

	return make_number(abs(arg->u.n_int),0.0,0);
}

VALUE *f_atof(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"atof");
	if(strchk(arg,1)) do_error("1st","atof");

	return make_number(0,(double)atof(arg->u.string),1);
}

VALUE *f_atoi(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;
#ifndef linux
	extern int atoi();
#endif

	arg=get_one_expr(&l,"atoi");
	if(strchk(arg,1)) do_error("1st","atoi");

	return make_number(atoi(arg->u.string),0.0,0);
}

VALUE *f_ntoa(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;
	char new_num[200];

	arg=get_one_expr(&l,"ntoa");
	if(numchk(arg,T_NUMBER)) do_error("1st","ntoa");

	switch(arg->type)
	  {
		case T_INT:
			(void)sprintf(new_num,"%d",arg->u.n_int);
			break;

		case T_FLOAT:
			(void)sprintf(new_num,"%f",arg->u.n_float);
			break;
	  }

	return make_string(new_num);
}

VALUE *f_type(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"type");
	if(!arg) do_error("1st","type");

	return make_number(arg->type,0.0,0);
}

VALUE *f_cast(p)
	LNODE *p;
{
	VALUE *arg,*ret= &const0;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"cast");
	if(numchk(arg,T_NUMBER)) do_error("1st","cast");

	switch(arg->type)
	  {
		case T_INT:
			ret=make_number(0,(double)arg->u.n_int,0);
			break;

		case T_FLOAT:
			if(arg->u.n_float>(double)MAX_INT)
				ret=make_number(MAX_INT,0.0,0);
			 else if(arg->u.n_float<(double)MIN_INT)
					ret=make_number(MIN_INT,0.0,0);
				else if(arg->u.n_float<0.0)
					   ret=make_number((int)ceil(arg->u.n_float),0.0,0);
					  else ret=make_number((int)floor(arg->u.n_float),0.0,0);
	  }
	return ret;
}

VALUE *f_fabs(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"fabs");
	if(numchk(arg,T_FLOAT)) do_error("1st","fabs");

	return make_number(0,fabs(arg->u.n_float),1);
}

VALUE *f_fmod(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"fmod");
	if(numchk(arg,T_FLOAT)) do_error("1st","fmod");

	arg1=get_one_expr(&l,"fmod");
	if(numchk(arg1,T_FLOAT)) do_error("2nd","fmod");

	return make_number(0,fmod(arg->u.n_float,arg1->u.n_float),1);
}
VALUE *f_itoc(p)
	LNODE *p;
{
	VALUE *arg;
	char cmd[2];
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"itoc");
	if(numchk(arg,T_INT) || arg->u.n_int<0 || arg->u.n_int>127)
			 do_error("1st","itoc");

	cmd[0]=(unsigned char)arg->u.n_int;
	cmd[1]=0;

	return make_string(cmd);
}

VALUE *f_verb_matching(p)
	LNODE *p;
{
	VALUE *arg;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"verb_matching");
	if(numchk(arg,T_INT)) do_error("1st","verb_matching");

	if(arg->u.n_int) ob_status[0]->ob->flags |= VERB_MATCHING;
  	  else ob_status[0]->ob->flags &=~VERB_MATCHING;

   	return make_number(ob_status[0]->ob->flags & VERB_MATCHING?1:0,0.0,0);
}

VALUE *f_remove_verb(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"remove_verb");
	if(strchk(arg,0)) do_error("1st","remove_verb");

	arg1=get_one_expr(&l,"remove_verb");
	if(objchk(arg1)) do_error("2st","remove_verb");

	return make_number(remove_sent(0,arg1->u.ob,arg->u.string),0.0,0);
}

VALUE *f_remove_all_verbs(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"remove_all_verbs");
	if(objchk(arg)) do_error("1st","remove_all_verbs");

	arg1=get_one_expr(&l,0);
	if(arg1 && objchk(arg1)) do_error("2nd","remove_all_verbs");

	return make_number(remove_sent(arg1 ? arg1->u.ob:0,arg->u.ob,0),0.0,0);
}

VALUE *f_block_shouts(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;
	OBJECT *ob;

	arg=get_one_expr(&l,0);

	if(arg) 
	  {
		if(numchk(arg,T_INT) && objchk(arg) && strchk(arg,1))
   			do_error("1st","block_shouts");

		if(!numchk(arg,T_INT)) arg1=get_one_expr(&l,0);
  			else {arg1=arg;arg=0;}

		if(arg1 && objchk(arg1) && strchk(arg1,1)) 
			do_error("2nd","block_shouts");

		if(arg1)
  		  {
	    		if(!objchk(arg1)) ob=arg1->u.ob;
				else
	      		 	  {
					ob=find_object(arg1->u.string);
					if(!check_object(ob))
						 do_error("2nd","block_shouts");
	      		 	  }
  		  }
		else ob=ob_status[0]->ob;

		if(arg)
  		    if(arg->u.n_int==1) ob->flags|=BLOCK_SHOUTS;
	   		 else if(arg->u.n_int==0) ob->flags&=~BLOCK_SHOUTS;
				else do_error("1st","block_shout");
	  }
	else ob=ob_status[0]->ob;

	return make_number(ob->flags & BLOCK_SHOUTS?1:0,0.0,0);
}

VALUE *f_restore_inventory(p)
	LNODE *p;
{
	return f_save_inventory(p);
}

VALUE *f_save_inventory(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;
	char temp1[18],*dir1;

	if(p->fun==f_save_inventory) (void)strcpy(temp1,"save_inventory");
  		else (void)strcpy(temp1,"restore_iventory");

	arg=get_one_expr(&l,temp1);
	if(objchk(arg)) do_error("1st",temp1);

	arg1=get_one_expr(&l,"save_inventory");
	if(strchk(arg1,1)) do_error("2st",temp1);

	if(!(dir1=check_file_name(arg1->u.string,1,0)))
	    error(ob_status[0]->ob->realm,"%s is not a valid save directory.\n",arg1->u.string);

	if(file_size(dir1)!=-2) 
		error(ob_status[0]->ob->realm,"%s is not a valid directory.\n",arg1->u.string);

	if(p->fun==f_save_inventory) 
		return make_number(save_inventory(arg->u.ob,dir1),0.0,0);
	return make_number(restore_inventory(arg->u.ob,dir1),0.0,0);
}

VALUE *f_version(p)
	LNODE *p;
{
	return make_string(VERSION);
}

VALUE *f_find_link(p)
	LNODE *p;
{
	VALUE *arg;
	OBJECT *ob;

	arg=print_expr_list(p->a1);
	if(objchk(arg)) do_error("1st","find_link");

	ob=find_link(arg->u.ob);
	if(!check_object(ob)) return &const0;

	return make_object(ob);
}

VALUE *f_used_object(p)
	LNODE *p;
{
	VALUE *arg;

	arg=print_expr_list(p->a1);
	if(objchk(arg)) do_error("1st","used_object");

	return make_object(used_object(arg->u.ob));
}

VALUE *f_all_inventory(p)
	LNODE *p;
{
	register VALUE *arg1;
	register OBJECT *ob;
	extern VALUE *all_inventory PROT((OBJECT *));

	arg1=print_expr_list(p->a1);
	if(strchk(arg1,1) && objchk(arg1)) do_error("1st","all_inventory");

        if(strchk(arg1,1)) ob=arg1->u.ob;
           else ob=find_object(arg1->u.string);

        if(!check_object(ob)) 
		error(ob_status[0]->ob->realm,"Invalid object to call all_inventory on.\n");

	return all_inventory(ob);
}

VALUE *f_mv(p)
	LNODE *p;
{
	return f_cp(p);
}

VALUE *f_cp(p)
	LNODE *p;
{
	VALUE *arg,*arg1,*ret= &const0;
	LNODE *l=p->a1;
	char *temp1,*temp2,cmd[325];
	FILE *f;

	if(p->fun==f_cp) (void)strcpy(cmd,"cp");
		else (void)strcpy(cmd,"mv");

	arg=get_one_expr(&l,cmd);
	if(strchk(arg,1)) do_error("1st",cmd);

	arg1=get_one_expr(&l,cmd);
	if(strchk(arg1,1)) do_error("2st",cmd);

	temp1=check_file_name(arg->u.string,0,0);
	if(!temp1) error(ob_status[0]->ob->realm,"Illegial use of %s()\n",cmd);

	temp2=check_file_name(arg1->u.string,1,0);
	if(!temp2) error(ob_status[0]->ob->realm,"Illegal use of %s()\n",cmd);

	if(p->fun==f_cp) 
           {
		(void)sprintf(cmd, "%s %s %s",cf.cp,temp1,temp2);
       	         if((f=popen(cmd,"r"))==NULL)
	      	    error(ob_status[0]->ob->realm,"Could not cp %s to %s\n",temp1,temp2);
	         (void)pclose(f);
           }
          else
           {
		if(link(temp1,temp2)==-1)
			error(ob_status[0]->ob->realm,"Could not move file.\n");

	 	if(unlink(temp1)==-1)
		  {
			(void)unlink(temp2);
			error(ob_status[0]->ob->realm,"Could not move file.\n");
		  } 
		 ret= &const1;
	   }
	return ret;
}

VALUE *f_sprintf(p)
	LNODE *p;
{
	 extern VALUE *inter_sprintf PROT((LNODE *));

	 return inter_sprintf(p->a1);
}

VALUE *f_set_realm(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;

	if(ob_status[0]->ob->realm!=sys_realm)
		return &const0;

	arg=get_one_expr(&l,"set_realm");
	if(strchk(arg,0)) do_error("1st","set_realm");

	arg1=get_one_expr(&l,"set_realm");
	if(objchk(arg1)) do_error("2nd","set_realm");

	arg1->u.ob->realm=find_realm(arg->u.string,0);

	return &const0;
}

VALUE *f_grep(p)
	LNODE *p;
{
	extern void intr_grep PROT((char *));
	VALUE *arg;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"grep");
	if(strchk(arg,1)) do_error("1st","grep");

	intr_grep(arg->u.string);

	return &const0;

}

VALUE *f_system(p)
	LNODE *p;
{
	VALUE *arg,*arg1,*ret= &const0;
	LNODE *l=p->a1;
	extern int intr_system PROT((char *,char *));

	if(ob_status[0]->ob->realm!=sys_realm)
		error(sys_realm,"Illegal use of system() from %s.\n",ob_status[0]->ob->realm->realm_name);

	arg=get_one_expr(&l,"system");
	if(strchk(arg,1)) do_error("1st","system");

	arg1=get_one_expr(&l,0);	
	if(arg1 && strchk(arg1,1)) do_error("2nd","system");

	if(intr_system(arg->u.string,arg1?arg1->u.string:0)) ret= &const1;

	return ret;
}

VALUE *f_query_realm(p)
	LNODE *p;
{
	VALUE *arg,*arg1,*ret= &const0;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"query_realm");
	if(objchk(arg)) do_error("1st","query_realm");

	arg1=get_one_expr(&l,"query_realm");
	if(numchk(arg1,T_INT) || arg1->u.n_int<0 || arg1->u.n_int>2) 
		do_error("2nd","query_realm");

    if(!arg1->u.n_int) ret=make_string(arg->u.ob->realm->realm_name);
  	  else if(arg1->u.n_int==1) ret=make_string(arg->u.ob->realm->realm_owner);
   		else if(arg1->u.n_int==2) ret=make_string(arg->u.ob->realm->realm_dir);

	return ret;
}


VALUE *f_set_prompt(p)
	LNODE *p;
{
	VALUE *arg,*arg1;
	LNODE *l=p->a1;
	char cmd[100];

	arg=get_one_expr(&l,"set_prompt");
	if(objchk(arg)) do_error("1st","set_prompt");

	arg1=get_one_expr(&l,"set_prompt");
	if(strchk(arg1,0) || !arg1->u.string) do_error("2nd","set_prompt");

	(void)strncpy(cmd,arg1->u.string,80);
    if(strlen(cmd)>=79 && cmd[80]!='\0') cmd[80]='\0';

	set_prompt(cmd,arg->u.ob);
	return &const0;
}


VALUE *f_query_prompt(p)
	register LNODE *p;
{
	register VALUE *arg;

	arg=print_expr_list(p->a1);
	if(objchk(arg)) do_error("1st","query_prompt");

	return make_string(query_prompt(arg->u.ob));
}

VALUE *f_query_light(p)
	register LNODE *p;
{
	register VALUE *arg;

	arg=print_expr_list(p->a1);
	if(arg && objchk(arg)) do_error("1st","query_light");

	return make_number(arg->u.ob->total_light,0.0,0);
}

VALUE *f_query_ed(p)
	register LNODE *p;
{
	register VALUE *arg;

    arg=print_expr_list(p->a1);
	if(objchk(arg)) do_error("1st","query_ed");

	if(!strcmp(query_ed(arg->u.ob),"\0")) return &const0;

	return make_string(query_ed(arg->u.ob));
}

VALUE *f_new_player(p)
	register LNODE *p;
{
	register VALUE *arg,*arg1,*arg2;
	LNODE *l=p->a1;
	register OBJECT *new_ob,*old_ob;

	arg=get_one_expr(&l,"new_player");
	if(strchk(arg,1) && objchk(arg)) do_error("1st","new_player");

	arg1=get_one_expr(&l,"new_player");
	if(objchk(arg1)) do_error("2nd","new_player");

	arg2=get_one_expr(&l,0);
	old_ob=arg1->u.ob;
	if(!strchk(arg,1))
	 {
	 	new_ob = (clone_object(arg->u.string))->u.ob;
	 	if (!new_ob) error(ob_status[0]->ob->realm,"Could not load '%s'\n",arg->u.string);
	 }
	else new_ob=arg->u.ob;

	return new_player_link(new_ob,old_ob,arg2);
}

VALUE *f_tail(p)
	register LNODE *p;
{
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if(strchk(arg,1)) do_error("1st","tail");

	if (tail(arg->u.string)) return &const1;
	return &const0;
}

VALUE *f_write_file(p)
	LNODE *p;
{
	register VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg = get_one_expr(&l, "write_file");
	if(strchk(arg,1)) do_error("1st","write_file");

	arg1 = get_one_expr(&l, "write_file");
	if(strchk(arg1,1)) do_error("2nd","write_file");

	write_file(arg->u.string, arg1->u.string,0);

	return &const0;
}

VALUE *f_file_size(p)
	LNODE *p;
{
	register VALUE *arg;
	register char *temp1;

	arg = print_expr_list(p->a1);
	if(strchk(arg,1)) do_error("1st","file_size");
	temp1=check_file_name(arg->u.string,0,0);
	if(!temp1) error(ob_status[0]->ob->realm,"file_size: Invalid File. %s\n",arg->u.string);

	return make_number(file_size(temp1),0.0,0);
}

VALUE *f_living(p)
	register LNODE *p;
{
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if(objchk(arg)) do_error("1st","living");

	if(arg->u.ob->flags & COMMANDS) return &const1;
	
	return &const0;
}

VALUE *f_shutdown(p)
	LNODE *p;
{
   	if(ob_status[0]->ob->realm!=sys_realm)
  		error(sys_realm,"Illegal call to shutdown() from %s\n",ob_status[0]->ob->realm->realm_name);

	shutdowngame(0);

	return &const0;
}

VALUE *f_shutting_down(p)
	LNODE *p;
{
	extern char shut_down_game;

	if(shut_down_game) return &const1;

	return &const0;
}

VALUE *f_query_load_average(p)
	LNODE *p;
{
	return query_load_av();
}

VALUE *f_notify_fail(p)
	register LNODE *p;
{
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if(strchk(arg,0)) do_error("1st","notify_fail");

	set_notify_fail_message(arg->u.string);
	return &const0;
}

VALUE *f_query_idle(p)
	register LNODE *p;
{
	extern int query_idle PROT((struct object *));
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if(objchk(arg)) do_error("1st","query_idle");

	return make_number(query_idle(arg->u.ob),0.0,0);
}

VALUE *f_query_snoop(p)
	register LNODE *p;
{
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if(objchk(arg)) do_error("1st","query_snoop");

	if (!arg->u.ob->interactive || !ob_status[0]->ob->interactive)
		return &const0;
 
	return query_snoop(arg->u.ob);
}

VALUE *f_query_ip_number(p)
	register LNODE *p;
{
	register VALUE *arg;
	register char *temp1;
	extern char *query_ip_number PROT((struct object *));

	if (p->a1) arg = print_expr_list(p->a1);
		else arg = 0;

	if(arg && objchk(arg)) do_error("1st","query_ip_number");

	temp1 = query_ip_number(arg ? arg->u.ob : 0);

	if (temp1 != 0) return make_string(temp1);

	return &const0;
}

VALUE *f_query_host_name(p)
	register LNODE *p;
{
	register VALUE *arg;
	register char *temp1;
	extern char *query_host_name PROT((OBJECT *));

	arg=print_expr_list(p->a1);

	if(arg && objchk(arg)) do_error("1st","query_host_name");

	temp1 = query_host_name(arg?arg->u.ob:0);

	if(temp1) return make_string(temp1);
	   else return &const0;
}

VALUE *f_localcmd(p)
	LNODE *p;
{
        register VALUE *arg,*arg1;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,0);
	if(arg && objchk(arg)) do_error("1st","localcmd");

	arg1=get_one_expr(&l,0);
	if(arg1 && objchk(arg1)) do_error("2nd","localcmd");

	print_local_commands(arg?arg->u.ob:0,arg1?arg1->u.ob:0);
	return &const0;
}

VALUE *f_swap(p)
	register LNODE *p;
{
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if(objchk(arg)) do_error("1st","swap");

	(void)swap(arg->u.ob);
	return &const0;
}

VALUE *f_time(p)
	LNODE *p;
{
	return make_number(time(0l),0.0,0);
}

VALUE *f_realm_list(p)
	LNODE *p;
{
	realm_list();
	return &const0;
}

VALUE *f_wizlist(p)
	LNODE *p;
{
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if(arg && strchk(arg,1)) do_error("1st","wizlist");

	(void)wizlist(arg?arg->u.string:0,ob_status[0]->ob->realm->realm_owner);
	return &const0;
}

VALUE *f_add_worth(p)
	LNODE *p;
{
	register VALUE *arg,*arg1;
	LNODE *l=p->a1;
	register char *temp1;

	arg = get_one_expr(&l,"add_worth");
	if(numchk(arg,T_INT)) do_error("1st","add_worth");

	arg1 = get_one_expr(&l, 0);
	if(arg1 && objchk(arg1)) do_error("2st","add_worth");

	temp1=strchr(ob_status[0]->ob->name,'/');
	if(!strncmp(temp1,"/w/",3)) error(ob_status[0]->ob->realm,"Illegal call of add_worth.\n");

	if (arg1) 
	  {
    	if (arg1->u.ob->wl) arg1->u.ob->wl->total_worth += arg->u.n_int;
    	return &const0;
	  }

	if (!ob_status[1] || !ob_status[1]->ob) return &const0;
	if (ob_status[1]->ob->wl) ob_status[1]->ob->wl->total_worth += arg->u.n_int;

	return &const0;
}

VALUE *f_log_file(p)
	LNODE *p;
{
	register VALUE *arg1,*arg2;
	LNODE *l=p->a1;

	arg1 = get_one_expr(&l, "log_file");
	if(strchk(arg1,1)) do_error("1st","log_file");

	arg2 = get_one_expr(&l, "log_file");
	if(strchk(arg2,1)) do_error("2nd","log_file");

	log_file(arg1->u.string, arg2->u.string,(extract_realm(ob_status[0]->ob->name))->realm_dir);

	return &const0;
}

VALUE *f_query_verb(p)
	LNODE *p;
{
	if (!last_verb) return &const0;

	return make_string(last_verb->verb);
}

VALUE *f_file_name(p)
	LNODE *p;
{
	register VALUE *arg,*ret;
	char *file_name;

	arg = print_expr_list(p->a1);
	if (objchk(arg)) do_error("1st","file_name");

        if(ob_status[0]->ob->realm==sys_realm)
	  return make_string(arg->u.ob->name);

#if 0
	if(arg->u.ob->realm==sys_realm)
	  {
	     file_name=xalloc(strlen(arg->u.ob->name)+3);

	     (void)strcpy(file_name,"^/");
	     (void)strcat(file_name,arg->u.ob->name);
	
	     ret=make_string(file_name);
	     free(file_name);

	     return ret;
	  }
#endif

        file_name=arg->u.ob->name;

#if 0
	file_name+=strlen(arg->u.ob->realm->realm_dir)+1;
#endif

	return make_string(file_name);
}


VALUE *f_users(p)
	LNODE *p;
{
	register VALUE *arg;

	arg=print_expr_list(p->a1);
	if(arg && (numchk(arg,T_INT) || arg->u.n_int<0 ||
	   arg->u.n_int>1)) do_error("1st","users");

	return users(arg?arg->u.n_int:0);
}

VALUE *f_call_out(p)
	LNODE *p;
{
	register VALUE *arg,*arg1,*arg2;
	LNODE *l=p->a1;

	arg = get_one_expr(&l, "call_out");
	if (strchk(arg,1)) do_error("1st","call_out");

	arg1 = get_one_expr(&l, "call_out");
	if (numchk(arg1,T_INT) || arg1->u.n_int<0) do_error("2nd","call_out");

	arg2 = get_one_expr(&l, 0);

	new_call_out(ob_status[0]->ob, arg->u.string, arg1->u.n_int, arg2);

	return &const0;
}

VALUE *f_remove_call_out(p)
	LNODE *p;
{
	register VALUE *arg;
	LNODE *l=p->a1;

	arg = get_one_expr(&l, "remove_call_out");
	if (strchk(arg,1)) do_error("1st","remove_call_out");

	return make_number(remove_call_out(ob_status[0]->ob, arg->u.string,0),0.0,0);
}

VALUE *f_query_call_out(p)
	LNODE *p;
{
	register VALUE *arg;
	LNODE *l=p->a1;

 	arg=get_one_expr(&l, "query_call_out");
 	if(strchk(arg,1)) do_error("1st","query_call_out");

	return query_call_out(ob_status[0]->ob,arg->u.string);
}

VALUE *f_write(p)
	LNODE *p;
{
	register VALUE *arg;
	LNODE *l=p->a1;

	arg = get_one_expr(&l, "write");
	do_write(arg);
	return &const0;
}

VALUE *f_snoop(p)
	LNODE *p;
{
	register VALUE *arg1;
	LNODE *l=p->a1;

 	if(!ob_status[0]->ob->interactive) return &const0;

 	arg1 = get_one_expr(&l,0);
 	if (arg1 && objchk(arg1)) do_error("1st","snoop");

 	set_snoop(ob_status[0]->ob, arg1 ? arg1->u.ob:0);

	return &const0;
}

VALUE *f_ed(p)
	LNODE *p;
{
	register VALUE *arg;
	register char *temp1;

	arg = print_expr_list(p->a1);
   	if (!command_giver || !command_giver->interactive) return &const0;

    if(arg && strchk(arg,1)) do_error("1st","ed");

	if(!arg)
	  {
		ed_start(0);
		return &const1;
	  }

	if(!strcmp(arg->u.string,"-r"))
	  {
    		arg = apply(0,"query_user_name", command_giver, &const0,0);
    		if (strchk(arg,1)) return &const0;
    		temp1 = get_error_file(arg->u.string,command_giver->realm->realm_owner);
    		ed_start(temp1);
		return &const1;
  	  }

	ed_start(arg->u.string);
	return &const1;
}

VALUE *f_no_crypt(p)
	LNODE *p;
{
	register VALUE *arg;
	LNODE *l=p->a1;
   	extern char *u_crypt PROT ((char *));

	arg=get_one_expr(&l,"crypt");
	if(strchk(arg,0)) do_error("1st","crypt");

   	if(arg->u.string==NULL) return arg;

	return make_string(u_crypt(arg->u.string));
}

VALUE *f_crypt(p)
	LNODE *p;
{
#ifdef M_XENIX
	return f_no_crypt(p);
#else
	register VALUE *arg,*arg1;
	VALUE v;
	LNODE *l=p->a1;
	char salt[2];
	register char *choise =
    	"abcdefghijklmnopqrstuvxyzABCDEFGHIJKLMNOPQRSTUVXYZ0123456789./";

	v.u.string=ob_status[0]->ob->realm->realm_dir;
	v.type=T_STRING;

	arg=apply(0,"unix_crypt",mcp.ob,&v,0);

        if(!arg || numchk(arg,T_INT) || !arg->u.n_int) return f_no_crypt(p);

	arg = get_one_expr(&l, "crypt");
#if 0
	if (strchk(arg,1) || strlen(arg->u.string)<6) do_error("1st","crypt");
#else
	if (strchk(arg,1)) do_error("1st","crypt");
#endif

	arg1 = get_one_expr(&l, "crypt");

	if (!strchk(arg1,1) && strlen(arg->u.string) >= 2) 
	  {
	    salt[0] = arg1->u.string[0];
	    salt[1] = arg1->u.string[1];
	  }
	else
	  {
#ifdef RANDOM
	    salt[0] = choise[random() % strlen(choise)];
	    salt[1] = choise[random() % strlen(choise)];
#else /* RANDOM */
#ifdef DRAND48
	    salt[0] = choise[(int)(drand48() * strlen(choise))];
	    salt[1] = choise[(int)(drand48() * strlen(choise))];
#else /* DRAND48 */
	    salt[0] = choise[time(0l) % strlen(choise)];
	    salt[1] = choise[time(0l) % strlen(choise)];
#endif /* DRAND48 */
#endif /* RANDOM */
	  }
#ifdef sun 
	return  make_string(_crypt(arg->u.string, salt));
#else
	return  make_string(crypt(arg->u.string, salt));
#endif 

#endif
}

VALUE *f_creator(p)
	LNODE *p;
{
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if (objchk(arg)) do_error("1st","creator");

	if (!strcmp(arg->u.ob->wl->name,"mud")) return &const0;

	return make_string(arg->u.ob->wl->name);
}

VALUE *f_lower_case(p)
	LNODE *p;
{
	register VALUE *arg,*ret;
	register char *temp1;
	LNODE *l=p->a1;

	arg = get_one_expr(&l,"lower_case");
	if (strchk(arg,0)) do_error("1st","lower_case");
		{
		   int c;

 		   temp1=string_copy(arg->u.string);
		    for (c = strlen(temp1)-1; c>=0; c--)
				if (isalpha(temp1[c]))
				    temp1[c] |= 'a' - 'A';
		}
        ret=make_string(temp1);
        free(temp1);
	return ret;
}

VALUE *f_upper_case(p)
	LNODE *p;
{
	register VALUE *arg,*ret;
	register char *temp1;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"upper_case");
	if(strchk(arg,1)) do_error("1st","upper_case");
 		{
			int c;

			temp1=string_copy(arg->u.string);
			for(c=strlen(temp1)-1;c>=0;c--)
				if(isalpha(temp1[c]))
					temp1[c]+='A'-'a';
		 }
	ret=make_string(temp1);
	free(temp1);
	return ret;
}

VALUE *f_capitalize(p)
	LNODE *p;
{
	register VALUE *arg,*ret;
	register char *temp1,*temp2;

	arg = print_expr_list(p->a1);
	if (strchk(arg,1)) do_error("1st","capitalize");

	temp2=string_copy(arg->u.string);

	if (islower(temp2[0])) 
	    temp2[0] += 'A' - 'a';

	temp1=strchr(temp2,' ');

	if(temp1) temp1++;

	while(temp1)
	  {
		if(temp1)
			if(islower(temp1[0])) temp1[0]+='A'-'a';

		temp1=strchr(temp1,' ');

	    if(temp1) temp1++;
	  }
	
        ret=make_string(temp2);
        free(temp2);
	return ret;
}


VALUE *f_command(p)
	LNODE *p;
{
	register VALUE *arg,*arg1;
	LNODE *l=p->a1;
	int hold_eval=eval_cost;

	arg = get_one_expr(&l, "command");
	if (strchk(arg,1)) do_error("1st","command");

	arg1 = get_one_expr(&l, 0);
	if (arg1 && objchk(arg1)) do_error("2nd","command");

	if (command_for_object(arg->u.string,arg1 ? arg1->u.ob:0))
	 return make_number(eval_cost-hold_eval,0.0,0);

	return &const0;
}

VALUE *f_ls(p)
	LNODE *p;
{
	register VALUE *arg;
	LNODE *l=p->a1;

	arg = get_one_expr(&l, "ls");
	if (arg && strchk(arg,1)) do_error("1st","ls");

	list_files(arg ? arg->u.string : 0);
	
	return &const0;
}

VALUE *f_rm(p)
	LNODE *p;
{
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if (strchk(arg,1)) do_error("1st","rm");

	if(file_size(arg->u.string)==-2)
        error(ob_status[0]->ob->realm,"rm on a directory.\n");

    remove_file(arg->u.string);

	return &const0;
}

VALUE *f_read_file(p)
	LNODE *p;
{
	return f_cat(p);
}

VALUE *f_cat(p)
	LNODE *p;
{
	register int start = 0, len = 0;
	char temp1[10];
	register VALUE *arg,*arg1,*arg2;
	LNODE *l=p->a1;

	if(p->fun==f_cat) (void)strcpy(temp1,"cat");
	  else (void)strcpy(temp1,"read_file");

	arg = get_one_expr(&l, temp1);
	if (strchk(arg,1)) do_error("1st",temp1);

	arg1 = get_one_expr(&l, 0);
	if (arg1) 
	  {
	    if (numchk(arg1,T_INT) || arg1->u.n_int<0) do_error("2nd",temp1);

	    start = arg1->u.n_int;
	    arg2 = get_one_expr(&l, 0);
	    if(arg2)
		  {
			if (numchk(arg2,T_INT) || arg2->u.n_int<0) do_error("3rd",temp1);
	   	    len = arg2->u.n_int;
		  }
	  }

	if(p->fun==f_cat) return print_file(arg->u.string, start, len,0);

	return print_file(arg->u.string,start,len,1);
}

VALUE *f_mkdir(p)
	LNODE *p;
{
	register VALUE *ret;
	LNODE *l=p->a1;
	register char *temp1;
	extern int mkdir();

	ret = get_one_expr(&l, "mkdir");
	if (strchk(ret,1)) do_error("1st","mkdir");

	temp1 = check_file_name(ret->u.string, 1,0);
	if (temp1 == 0 || mkdir(temp1, 0770) == -1) ret = &const0;
		else ret = &const1;
	return ret;
}

VALUE *f_rmdir(p)
	LNODE *p;
{
	register VALUE *ret;
	LNODE *l=p->a1;
	register char *temp1;
	extern int rmdir();

	ret = get_one_expr(&l, "rmdir");
	if (strchk(ret,1)) do_error("1st","rmdir");

	temp1 = check_file_name(ret->u.string, 1,0);

	if (!temp1 || rmdir(temp1) == -1) ret = &const0;
		else ret = &const1;
	return ret;
}

VALUE *f_input_to(p)
	LNODE *p;
{
	int flag = 1;
	LNODE *l=p->a1;
	register VALUE *arg,*arg1,*arg2,*arg3=0;
	
	arg2 = get_one_expr(&l, "input");
	if(objchk(arg2)) do_error("1st","input");

	arg = get_one_expr(&l, "input");
	if (strchk(arg,1)) do_error("2st","input");

	arg1 = get_one_expr(&l, 0);
	if (!arg1 || (!numchk(arg1,T_INT) && !arg1->u.n_int)) flag = 0;

        if(arg1) arg3=get_one_expr(&l,0);

	return input_to(arg2->u.ob,arg->u.string, flag,arg3);
}

VALUE *f_set_living_name(p)
	register LNODE *p;
{
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if (arg && strchk(arg,1)) do_error("1st","set_living_name");

	set_living_name(ob_status[0]->ob,arg?arg->u.string:0);
	return &const0;
}

VALUE *f_log_object(p)
	LNODE *p;
{
	register VALUE *arg,*arg1;
	LNODE *l=p->a1;
	register OBJECT *ob;
	char *temp1;

	arg=get_one_expr(&l,"log_object");
	if(strchk(arg,1) && objchk(arg)) do_error("1st","log_object");

	arg1=get_one_expr(&l,0);
	if(arg1 && strchk(arg1,1)) do_error("2nd","log_object");

	if(!objchk(arg)) ob=arg->u.ob;
	  else
	   {
		ob=find_object(arg->u.string);
		if(!check_object(ob))
		   error(ob_status[0]->ob->realm,"Unable to Find object. in log_object()\n");
	   }
	if(arg1)
         {
		temp1=check_file_name(arg1->u.string,1,0);
		if(!temp1) error(ob_status[0]->ob->realm,"Illegal log file.\n");

		ob->logged=make_shared_string(temp1);
    	 }
	else 
	 {
		if(ob->logged) free_string(ob->logged,"f_log_object");
		ob->logged=0;
         }

	return &const0;
}

VALUE *f_ctime(p)
	LNODE *p;
{
	long tmp;
	register char *cp,*cp2;
	register VALUE *arg;

	arg = print_expr_list(p->a1);
	if (numchk(arg,T_INT) || arg->u.n_int<0) do_error("1st","ctime");

	tmp = arg->u.n_int;

	cp2=ctime(&tmp);

	/* Now strip the newline. */

	cp = strchr(cp2, '\n');
	if (cp) *cp = '\0';

	return make_string(cp2);
}

VALUE *f_add_realm(p)
	register LNODE *p;
{
	LNODE *l=p->a1;
	register VALUE *arg,*arg1,*arg2;
	extern REALMS *add_realm PROT((char *,char *, char *));

	if(!_check_object(command_giver) ||
	   command_giver->realm!=sys_realm)
		 error(ob_status[0]->ob->realm,"Illegal use of add_realm().\n");

	arg=get_one_expr(&l,"add_realm");
	if(strchk(arg,1)) do_error("1st","add_realm");

	arg1=get_one_expr(&l,"add_realm");
	if(strchk(arg1,1)) do_error("2nd","add_realm");

	arg2=get_one_expr(&l,"add_realm");
	if(strchk(arg2,1)) do_error("3rd","add_realm");

	(void)add_realm(arg->u.string,arg1->u.string,arg2->u.string);

	return &const0;
}

VALUE *f_test_player(p)
	LNODE *p;
{
	LNODE *l=p->a1;
	register VALUE *arg;

	arg=get_one_expr(&l,"test_player");
	if(objchk(arg)) do_error("1st","test_player");
	 
	return make_number(arg->u.ob->flags & PLAYER,0.0,0);
}

VALUE *f_search_array(p)
	LNODE *p;
{
	LNODE *l=p->a1;
	register VALUE *arg,*arg1,*arg2;

	extern int search_array PROT((VECTOR *,VALUE *,int));

	arg=get_one_expr(&l,"search_array");
	if(pointchk(arg)) do_error("1st","search_array");

	if(arg->u.vec->sorted) debug_message(ob_status[0]->ob->realm,"search_array: bsearch_array() should be used on sorted arrays.\n");

	arg1=get_one_expr(&l,"search_array");

	arg2=get_one_expr(&l,0);
	if(arg2 && numchk(arg2,T_INT)) do_error("3rd","search_array");

        return make_number(search_array(arg->u.vec,arg1,arg2?arg2->u.n_int:0),0.0,0);
}


VALUE *f_sort_array(p)
	LNODE *p;
{
	LNODE *l=p->a1;
	register VALUE *arg,*arg1,*arg2,*arg3;
        struct fun_p *fun;

	extern void sort_array PROT((VECTOR *,OBJECT *,struct fun_p *,int));

	arg=get_one_expr(&l,"sort_array");
	if(pointchk(arg)) do_error("1st","sort_array");

	if(arg->u.vec->size<2 || arg->u.vec->sorted) return arg;

	arg1=get_one_expr(&l,"sort_array");
	if(objchk(arg1)) do_error("2st","sort_array");

	arg2=get_one_expr(&l,"sort_array");
	if(strchk(arg2,1)) do_error("3rd","sort_array");

	arg3=get_one_expr(&l,0);
	if(arg3 && numchk(arg3,T_INT)) do_error("4th","sort_array");

        fun=find_fun_p(arg2->u.string,arg1->u.ob,0);

	if(!fun) error(ob_status[0]->ob->realm,"sort_array: no such function '%s' in object '%s'.\n",arg2->u.string,arg1->u.ob);

        sort_array(arg->u.vec,arg1->u.ob,fun,arg3?arg3->u.n_int:0);

	free_fun_p(fun);

        return arg;
}

VALUE *f_bsearch_array(p)
	LNODE *p;
{
	LNODE *l=p->a1;
	register VALUE *arg,*arg1,*arg2,*arg3,*ret;
        struct fun_p *fun;

	extern int bsearch_array PROT((VECTOR *,VALUE *,OBJECT *,struct fun_p *));

	arg=get_one_expr(&l,"bsearch_array");
	if(pointchk(arg)) do_error("1st","bsearch_array");

	if(!arg->u.vec->sorted)
	  error("bsearch_array: Tried to bsearch on a non=sorted array.\n");

	arg1=get_one_expr(&l,"bsearch_array");

	arg2=get_one_expr(&l,"bsearch_array");
	if(objchk(arg2)) do_error("3st","bsearch_array");

	arg3=get_one_expr(&l,"bsearch_array");
	if(strchk(arg3,1)) do_error("4rd","bsearch_array");

        fun=find_fun_p(arg3->u.string,arg2->u.ob,0);

	if(!fun) error(ob_status[0]->ob->realm,"bsearch_array: no such function '%s' in object '%s'.\n",arg2->u.string,arg1->u.ob);

        ret=make_number(bsearch_array(arg->u.vec,arg1,arg2->u.ob,fun),0.0,0);

	free_fun_p(fun);

        return ret;
}

VALUE *f_add_sort(p)
	LNODE *p;
{
	LNODE *l=p->a1;
	register VALUE *arg,*arg1,*arg2,*arg3,*ret;
        struct fun_p *fun;

	extern VALUE *add_sort PROT((VECTOR *,VALUE *,OBJECT *,struct fun_p *));

	arg=get_one_expr(&l,"add_sort");
	if(pointchk(arg)) do_error("1st","add_sort");

	if(!arg->u.vec->sorted)
	   error(ob_status[0]->ob->realm,"add_sort: Tried to add to a non-sorted array.\n");

	if(arg->u.vec->size==cf.max_array_size)
		error(ob_status[0]->ob->realm,"add_sort: Array is too big to be added to.\n");

	arg1=get_one_expr(&l,"add_sort");

	if(!pointchk(arg1)) error(ob_status[0]->ob->realm,"add_sort: Tried to add more then one data element at a time.\n");

	arg2=get_one_expr(&l,"add_sort");
	if(objchk(arg2)) do_error("3st","add_sort");

	arg3=get_one_expr(&l,"add_sort");
	if(strchk(arg3,1)) do_error("4rd","add_sort");

        fun=find_fun_p(arg3->u.string,arg2->u.ob,0);

	if(!fun) error(ob_status[0]->ob->realm,"add_sort: no such function '%s' in object '%s'.\n",arg2->u.string,arg1->u.ob);

        ret=add_sort(arg->u.vec,arg1,arg2->u.ob,fun);

	free_fun_p(fun);

        return ret;
}

VALUE *f_query_port_number(p)
	register LNODE *p;
{
	register VALUE *arg;

        extern int query_port_number PROT((OBJECT *));

	arg = print_expr_list(p->a1);
	if (arg && objchk(arg)) do_error("1st","query_port_number");

	return make_number(query_port_number(arg?arg->u.ob:ob_status[0]->ob),0.0,0);
}

VALUE *f_hash(p)
	register LNODE *p;
{
	register VALUE *arg,*arg2;
	LNODE *l=p->a1;

	arg=get_one_expr(&l,"hash");
	if(strchk(arg,1)) do_error("1st","hash");

        arg2=get_one_expr(&l,"hash");
        if(numchk(arg2,T_INT) || arg2->u.n_int<1) do_error("2nd","hash");

	return make_number(hash(arg->u.string,arg2->u.n_int),0.0,0);
}
